C      PROGRAM MAIN(EINAR,OUTPUT,TAPE5=EINAR,TAPE6=OUTPUT,TAPE2,
C     &TAPE10,TAPE11,TAPE12,TAPE13,ZZZG67,TAPE67=ZZZG67)
C                            MAINPROGRAM
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + THE MAINPROGRAM  READS THE SELECTION CARDS (SPSCAN,TDSCOR,ABSORB,  +
C + SPHERE,AVERAG,REFINE,FOURIE,ERRMAP,PDFMAP,POTCAL,ARBSEC,PLOTTE,    +
C + BONVIB,LISTFC,MULPD,FINISH,NTITEL,INFO## AND CALLS THE             +
C + CORRESPONDING OVERLAYS.                                             +
C + WRITTEN BY E. PERENTHALER AND U. ZUCKER MPI-FKF (1979)             +
C +                                                                    +
C + (LAST UPDATE FEBRUARY 1982)                                        +
C +                                                                    +
C + IN ADDITION THE FOLLOWING SUBROUTINES ARE CALLED                   +
C + TITEL, TIME, ANFANG (ENTRY 'ENDE')                                 +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- DIMENSION DECLARATION FOR PROGRAMS   OF THE NEW GENERATION
C
C   - IN THE ARRAY  LINE  ONE MAY WRITE THE NAME OF THAT PERSON,
C     WHO IS RESPONSIBLE FOR CORRECT RUNNING OF PROMETHEUS
C   - MAXLIN  IS THE NUMBER OF LINES PER PAGE FOR THE PRINTER USED.
C   - IN  IS LOGICAL NUMBER OF STANDARD INPUT UNIT
C   - SAME FOR OUTPUT-UNIT
C   - NUMBER  IS THE DIMENSION OF FIELDS IN COMMON/OVNAM/
C
      DIMENSION LINE(11)
C
      CHARACTER ISTAR1*4,ISTAR2*2,IAY(21)*2
      CHARACTER*4 IOVERL(21)
      COMMON /ALL/IN,IOUT,LINE,MAXLIN,ISTAR3,IREW19
C
C---- DATA STATEMENTS
C
C---- DIMENSION OF FIELDS IN COMMON /OVNAM/
C
      DATA NUMBER/21/
C
C---- NAME OF RESPONSIBLE MAN
C
      DATA LINE/4HSTEU,4HRER ,4H    ,4H    ,4H    ,4H    ,
     &          4HZIMM,4HER 2,4H42  ,4H    ,4H    /
C
C---- LOGICAL UNITS FOR INPUT (IN) AND OUTPUT (IOUT)
C
      DATA IN,IOUT/05,06/
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/'SPSC','TDSC','ABSO','SPHE','AVER','REFI','FOUR',
     &'ERRM','PDFM','POTC','ARBS','PLOT','BONV','LIST','PRED','FINI',
     &'NTIT','INFO','OPTI','    ','MULP'/
      DATA IAY/'AN','OR','RB','RE','AG','NE','IE','AP','AP','AL','EC',
     &'TE','IB','FC','ES','SH','LE','  ','ON','  ','DF'/
C
      OPEN(5,FILE="einar")
      OPEN(6,FILE="lparb")
      OPEN(67,FILE="ZZZG67")
      OPEN(2,FILE="ftn02",FORM="UNFORMATTED")
      OPEN(10,FILE="ftn10",FORM="UNFORMATTED")
      OPEN(11,FILE="ftn11",FORM="UNFORMATTED")
      OPEN(12,FILE="ftn12",FORM="UNFORMATTED")
      OPEN(13,FILE="ftn13",FORM="UNFORMATTED")
C---- INITIALIZE
C
C---- LOGICAL UNIT OF THAT FILE ON WHICH PLOTTING ORDERS TO BE
C     WRITTEN.C
      IPLOT=19
C
C---- MAXIMUM LINES PER PAGE OF PRINTER USED.
C
      MAXLIN = 63
C
C---- OTHERS
C
      IREW19=0
      IZAEHL=0
      ILAB = 0
      IERR = 0
      M    = 0
      ITITEL = 0
      ISHORT = 0
C
C---- THE VARIABLE ITOP IS SET TO 1, IF COVER IS PRINTED. OTHERWISE
C     IT COULD HAPPEN THAT ERRORMESSAGES WILL BE PRINTED INSIDE COVER.
C
      ITOP = 0
C
C---- READ LABEL OF OVERLAY. COMPARE WITH TABLE OF LEGAL NAMES AND
C     SWITCH.
C
C---- SET CLOCK TO START
C
   01 CONTINUE
      IF(ITITEL.EQ.1) ITOP = 1
C

   02 READ (IN,10,END=2050) ISTAR1,ISTAR2,ISTAR3
   10 FORMAT (A4,A2,I1)
C
      IF(ISTAR3.NE.1) ISTAR3=0
      IF(ISTAR1.EQ.IOVERL(19)) ISHORT=1
      IF(ISHORT.EQ.1) ISTAR3 = 1
      IOVERL (NUMBER) = ISTAR1
      DO 20 I = 1,NUMBER
      ILAB = I
   20 IF (ISTAR1 .EQ.IOVERL(I)) GO TO 30
C
C---- IF THIS IS THE FIRST REQUEST AND IS IT NOT EQUAL *NTITLE*
C     PRINT THE MAINCOVER
C
   30 IF(ITITEL.EQ.0 .AND. I.NE.17) CALL TITEL(IOUT)
C
      IF(I.NE.17)M=1
      ITITEL = 1
C
      GO TO (100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,
     &1400,1500,3000,02,02,02,2000,1600),ILAB
  100 CONTINUE
      GO TO 01
  200 CONTINUE
      GO TO 01
  300 CONTINUE
      GO TO 01
  400 CONTINUE
      GO TO 01
  500 CONTINUE
      GO TO 01
  600 CONTINUE
C     CALL CALREF
      GO TO 01
  700 CONTINUE
C     CALL FOURIE
      GOTO 01
  800 CONTINUE
      GOTO 01
  900 CONTINUE
C     CALL PDFMAPS
      GOTO 01
 1000 CONTINUE
      GO TO 01
 1100 CONTINUE
      CALL ARBSEC
      GOTO 01
 1200 CONTINUE
      GOTO 01
 1300 CONTINUE
      GOTO 01
 1400 CONTINUE
      GOTO 01
 1500 CONTINUE
      GO TO 01
 1600 CONTINUE
C     CALL MULPDF
      GO TO 01
C
C---- ERROR MESSAGES
C
 2000 IF(ITOP.EQ.0) WRITE(IOUT,2010)
      ITOP = 1
      WRITE (IOUT,2020) ISTAR1,ISTAR2
 2010 FORMAT(1H1)
 2020 FORMAT(/1X,5(1H*),37HWARNING - INSTEAD OF A PROGRAM   NAME,
     & 2H ",A4,A2,40H" WAS READ.    THE CARD WILL BE IGNORED.)
C
      IZAEHL=IZAEHL+1
      IF(IZAEHL.GT. 3) GOTO 2030
      GO TO 02
 2030 WRITE(IOUT,2040)
 2040 FORMAT(//,1X,34HTHERE ARE TOO MANY ILLEGAL CARDS. /
     & 55H THE PROGRAM   SUPPOSE A FATAL ERROR - JOB TERMINATED. )
      IERR = 1
      GO TO 3000
C
 2050 WRITE(IOUT,2060)
 2060 FORMAT(5(/),1X,45H*END OF FILE* WAS READ ON STANDARD INPUT UNIT,
     & 17H. JOB TERMINATED.)
      IERR = 1
C
 3000 IF(IREW19.EQ.0)GOTO 3020
      WRITE(IOUT,3010) IPLOT
 3010 FORMAT(44H0*END OF FILE* WRITTEN TO THE PLOTTING FILE. ,
     & 14H (LOG.-NO. IS ,I4,1H) )
C
C---- THERE ARE TWO POSSIBILITIES OF GENERATING END OF FILE ON PLOTTER
C     FILE IPLOT. THE FIRST WAY IS BY CALLING OVERLAY PLOTT AGAIN  AND
C     AND DO IT THERE. (NOT POSSIBLE ON HONEYWELL BULL). THE SECOND IS
C     BY DOING IT HERE. ON SOME COMPUTERS LIKE UNIVAC 1110 ON EXEC  IT
C     IS NOT RECOMMENDABLE, BECAUSE OF  THE GREAT  CORE ALLOCATION  OF
C     THE PLOTTING SOFTWARE.
C
C     CALL LLINK("PLOTT")
C     CALL PLOTTE(IREW19,1)
C     CALL PLOT(0.,0.,999)
 3020 CONTINUE
C     CALL TIME (100,IOVERL,IAY,TTINI,TOVINI)
      IF(IERR.EQ.0) WRITE(IOUT,3030)
      IF(IERR.EQ.1) WRITE(IOUT,3040)
 3030 FORMAT(19H0NORMAL TERMINATION)
 3040 FORMAT(4(/),21H ABNORMAL TERMINATION)
C
C
      STOP
      END
                         SUBROUTINE TITEL(IOUT)
C
C       THIS ROUTINE GENERATES THE COVER OF THE SYSTEM PROMETHEUS
C
C             PROGRAMMERS   E. PERENTHALER AND U. ZUCKER
C
C                             NOVEMBER 1980
C
C----            IOUT IS LOGICAL NUMBER OF OUTPUT UNIT
C
C---- PRINT COVER. (THERE ARE MORE THAN ONE FORMAT STATEMENT, BECAUSE
C      OF A POSSIBLE MAXIMUM NUMBER OF CONTINUATION CARDS ALLOWED)
C
      WRITE(IOUT,1)
      WRITE(IOUT,2)
      WRITE(IOUT,3)
      WRITE(IOUT,4)
      WRITE(IOUT,5)
C
C---- WRITE COVER.   FIRST IN GREAT LETTERS    PROMETHEUS
C
C---- FIRST LINE
    1 FORMAT(1H1,4(/),10X,8(1HX),3X,8(1HX),5X,6(1HX),3X,3(1HX),4X,3(1HX
     & ),1X,10(1HX),1X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX
     & ),4X,3(1HX),3X,8(1HX)/
C---- SECOND LINE
     & 10X,9(1HX),2X,9(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1
     & X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,10(1HX)/
C---- THIRD LINE
     & 10X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,3(1HX),4X,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3
     & (1HX),8X,3(1HX),4X,3(1HX),1X,3(1HX)/
C---- FOURTH LINE
     & 10X,3(1HX),4X,3(1HX),2(1X,3(1HX),4X,3(1HX)),1X,4(1HX),2X,4(1HX)
     & ,1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3(1HX),4
     & X,3(1HX),1X,3(1HX)/
C---- FIFTH LINE
     & 10X,9(1HX),2X,9(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),2X,5(1HX))
C
C---- SIXTH LINE
   2  FORMAT(
     & 10X,8(1HX),3X,6(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),4X,6(1HX)/
C---- SEVENTH LINE
     & 10X,3(1HX),8X,3(1HX),1X,3(1HX),4X,3(1HX),4X,3(1HX),1X,3(1HX),1
     & X,2(1HX),2(1X,3(1HX)),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX)
     & ,8X,3(1HX),4X,3(1HX),8X,3(1HX)/
C---- EIGHTH LINE
     & 10X,3(1HX),8X,3(1HX),2X,3(1HX),3X,3(1HX),4X,3(1HX),1X,3(1HX),4X
     & ,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3
     & (1HX),4X,3(1HX),8X,3(1HX)/
C---- NINETH LINE
     & 10X,3(1HX),8X,3(1HX),3X,3(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),2X,8(1HX),2
     & X,9(1HX)/
C---- TENTH LINE
     & 10X,3(1HX),8X,3(1HX),4X,3(1HX),3X,6(1HX),3X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),3X,6(1HX),3
     & X,8(1HX),5(/))
C
C---- PRINT NOW     THE FIRE BEARING
C
C---- FIRST LINE
    3 FORMAT(21X,1HX,4X,1HX,18X,2(1HX),2X,1HX,18X,1HX,27X,1HX/
C---- SECOND LINE
     & 21X,1HX,4X,1HX,17X,1HX,23X,1HX/
C---- THIRD LINE
     & 19X,5(1HX),2X,4(1HX),4X,3(1HX),5X,5(1HX),2X,1HX,2X,1HX,1X,
     & 3(1HX),2X,3(1HX),6X,4(1HX),4X,3(1HX),4X,3(1HX),3X,1HX,1X,
     & 3(1HX),2X,1HX,2X,1HX,1X,2(1HX),4X,3(1HX)/
C---- FOURTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,3X,1HX,6X,1HX,4X,1HX,2X,2HXX,4X,
     & 1HX,3X,1HX,5X,1HX,3X,1HX,2X,1HX,3X,1HX,2X,1HX,2X,1HX,3X,2HXX,
     & 5X,1HX,2X,2(1HX),2X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,5(1HX),6X,1HX,4X,1HX,2X,1HX,5X,5(1HX)
     & ,5X,1HX,3X,1HX,2X,5(1HX),2X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,10X,1HX,4X,1HX,2X,1HX,5X,1HX,9X,
     & 1HX,3X,1HX,2X,1HX,6X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X,1HX,2X
     & ,1HX,3X,1HX/
C---  SEVENTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,3X,4(1HX),6X,1HX,4X,1HX,2X,1HX,6X,4(1HX)
     & ,5X,4(1HX),4X,4(1HX),3X,4(1HX),2X,1HX,6X,1HX,2X,1HX,3X,1HX,3X,
     & 4(1HX)/
C--- EIGHTH AND NINETH LINE
     & 110X,1HX/106X,4(1HX),5(/))
C
C---- PRINT NOW    TITAN GOD
C
C---- FIRST LINE
    4 FORMAT(39X,5(1HX),2X,1HX,4X,1HX,21X,3(1HX),14X,1HX/
C---- SECOND LINE
     & 41X,1HX,9X,1HX,20X,1HX,17X,1HX/
C---- THIRD LINE
     & 41X,1HX,4X,1HX,2X,5(1HX),3X,3(1HX),3X,1HX,1X,3(1HX),4X,1HX,1X,
     & 3(1HX),3X,3(1HX),4X,4(1HX)/
C---- FOURTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,2(1HX),2X,1HX,4X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SEVENTH LINE  (THANKS HEAVEN)
     & 41X,1HX,4X,1HX,4X,1HX,5X,4(1HX),2X,1HX,3X,1HX,5X,3(1HX),4X,
     & 3(1HX),4X,4(1HX),5(/))
C
C---- PRINT REST OF COVER
C
    5 FORMAT(38X,45HPROGRAM   SYSTEM FOR SOPHISTICATED STRUCTURE ,
     & 10HREFINEMENT,7(/),
C
C---- PRINT DATE OF LAST UPDATE
C
     & 52X,24HVERSION OF NOVEMBER 1980,7(/),
C
C---- AUTHORS
     & 32X,66HU.H. ZUCKER, E. PERENTHALER, W.F. KUHS, R. BACHMANN, AND H
     &. SCHULZ)
      RETURN
      END
                          SUBROUTINE SPACE
     &                  (N,IOV,IB,IO,MAXLIN)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + SUBROUTINE SPACE PRINTS THE FIRST AND THE LAST LINE OF THE COVER   +
C + FOR EACH PROGRAM   AND POSITIONES THE TEXT BLOCK OF THE COVER      +
C + DEPENDING ON THE MAXIMUM NUMBER OF LINES PER PAGE (MAXLIN).        +
C + WRITTEN BY E. PERENTHALER  MPI-FKF (DECEMBER 1980)                 +
C +                                                                    +
C + THIS PROGRAM   IS CALLED BY EACH PROGRAM  OF THE SYSTEM            +
C + PROMETHEUS.                                                        +
C +                                                                    +
C + THIS PROGRAM   DO NOT CALL ANY OTHER SUBROUTINE.                   +
C +                                                                    +
C + IN CASE OF AN OVERLAY STRUCTURE IT IS PART OF THE MAIN-OVERLAY     +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- INPUT VARIABLES
C     ---------------
C
C   - N       FIRST OR SECOND CALL BY ONE OF THE PROGRAM  S
C             (BEGIN OR END OF THE COVER TO BE PRINTED)
C   - IOV     NUMBER OF THE CALLING PROGRAM
C   - IB      LENTH OF THE TEXT BLOCK ON THE COVER OF THIS PROGRAM
C
C---- DIMENSION STATEMENTS
C     --------------------
C
      DIMENSION IOVERL(14),IAY(14)
C
C---- DATA STATEMENTS
C     ---------------
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/4HSPSC,4HTDSC,4HABSO,4HSPHE,4HAVER,4HREFI,4HFOUR,
     &4HERRM,4HPDFM,4HPOTC,4HARBS,4HPLOT,4HBONV,4HLIST/
C
      DATA IAY/2HAN,2HOR,2HRB,2HRE,2HAG,2HNE,2HIE,2HAP,2HAP,2HAL,2HEC,
     &2HTE,2HIB,2HFC/
C
C---- FORMAT STATEMENTS
C     -----------------
C
   10 FORMAT (1H1,3X,18(A4,A2,1X))
   40 FORMAT (1X)
   70 FORMAT (4X,18(A4,A2,1X))
C
C---- EXECUTABLE STATEMENTS
C     ---------------------
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 20
C
C---- FIRST LINE OF THE COVER
      WRITE (IO,10) (IOVERL(IOV),IAY(IOV),I=1,18)
C
C---- NUMBER OF EMPTY LINES TILL START OF TEXT BLOCK
   20 IS = MAXLIN / 3
      IF (MAXLIN - IS - IB - 4 .LT. 4) IS = MAXLIN - IB - 8
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 50
C
C---- EMPTY LINES
      DO 42 I=1,IS
42    WRITE (IO,40)
C
      RETURN
C
C---- NUMBER OF EMPTY LINES BEHIND THE TEXT BLOCK
   50 IS = MAXLIN - IS - IB - 4
C
C---- EMPTY LINES
      DO 43 I=1,IS
43    WRITE (IO,40)
C
C---- LAST LINE OF THE COVER
      WRITE (IO,70) (IOVERL(IOV),IAY(IOV),I=1,18)
C
      RETURN
      END
C
C     OVERLAY (MAI,4,0)
C
C                       PROGRAM ARBSEC
C    &(EINGABE,OUTPUT,TAPE5=EINGABE,TAPE6=OUTPUT)
      SUBROUTINE ARBSEC
C
C     PROGRAM TO READ A FOURIER MAP GENERATED BY THE PROGRAM FOURIER
C                 AND COMPUTE AN ARBITRARY SECTION.
C
C                    WRITTEN  BY  L. W. FINGER
C                    MODIFIED BY  U. H. ZUCKER
C
C
C                   LAST UPDATE  SEPTEMBER 1981
C
C
C     IN     = STANDARD INPUT  UNIT
C     IOUT   = STANDARD OUTPUT UNIT
C     LLINE  = IN THIS ARRAY ONE CAN WRITE THE NAME OF A MAN WHO TAKES
C              CARE OF THE PROGRAM.  THIS ARRAY WILL BE PRINTED IN THE
C              COVER
C     MAXLIN = MAXIMUM NUMBER OF LINES PER PAGE
C     MARK   = 0/1 DO PRINT COMPLETE/PRINT SHORTENED OUTPUT
C
C
C
      REAL         ILINE
      INTEGER      ZRO,ENDD,FOURN,FROT,FRMT,IU
C
      DIMENSION    LINE(33),POINTS(3,3),A(4),TITLE(18),FY(15),JDEX(4),
     &             CELL(6),JSECT(1),TITEL(3),FOURN(18),ARB(4),FROT(2),
     &             FRMT(50),IU(50),LLINE(11),ILINE(1),IPRT(10),PRT(10)
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C    DECLARE DIMENSION OF THE BUFFERFIELD AND SET NMR1 (SEE BELOW) TO
C                       THE SELECTED VALUE.
C
                D I M E N S I O N   BUFFER(17000)
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      COMMON /ALL/IN,IOUT,LLINE,MAXLIN,MARK
      EQUIVALENCE (BUFFER,ILINE),(JDEX(1),IP1),(JDEX(2),IP2),(JDEX(3),
     &            IP3),(JDEX(4),IP4),(BUFFER,IPRT),(PRT,IPRT)
C
      DATA FROT  /1H0,1H /
      DATA FRMT  /4H(A1,,4HF4.0,3H,1X,47*1H /
      DATA ZRO,NZRO,ENDD /3H,4X,3H,I4,1H)/
      DATA LEER,IPDF,IERR/1H ,4HPDF ,4HERR /
C
C     LOGICAL NUMBER OF  FILE CONTAINING THE DENSITY ARRAY = ISC
C     LOGICAL NUMBER OF  FILE CONTAINING THE ARBITRARY SECTION = ISC1
C
      DATA  ISC,ISC1/11,12/
C
      DATA    IU    /3H,1X,3H,2X,3H,3X,3H,4X,3H,5X,3H,6X,3H,7X,3H,8X,
     & 3H,9X,4H,10X,4H,11X,4H,12X,4H,13X,4H,14X,4H,15X,4H,16X,4H,17X,
     &4H,18X,4H,19X,4H,20X,4H,21X,4H,22X,4H,23X,4H,24X,4H,25X,4H,26X,
     &4H,27X,4H,28X,4H,29X,4H,30X,4H,31X,4H,32X,4H,33X,4H,34X,4H,35X,
     &4H,36X,4H,37X,4H,38X,4H,39X,4H,40X,4H,41X,4H,42X,4H,43X,4H,44X,
     &4H,45X,4H,46X,4H,47X,4H,48X,4H,49X,4H,50X/
C
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C              NMR1=DIMENSION OF THE ARRAY NAMED BUFFER
C
                         N M R 1 = 17000
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
    1 FORMAT(/28H0TITLE OF THE PROGRAM FOURIE/1X,27(1H-)//,1X,18A4//
     & 18H0LATTICE CONSTANTS/1X,17(1H-)//3(F10.2,4X),9HANGSTROMS//
     & 3(F10.2,4X),7HDEGREES)
    2 FORMAT(18A4)
    3 FORMAT(4I1,7I3)
    4 FORMAT(1H1,18A4,15X,4HPAGE,I3,20H OF APPARENT SECTION,I5//F10.0,14
     & F8.0//)
    5 FORMAT(/13H0ERRORMESSAGE/1X,12(1H-)//23H0IMPROPER SECTION SELEC,
     &5HTION./13H0JOB ABORTED.)
    7 FORMAT(4I3)
    8 FORMAT(/34H0FRACTIONAL COORDINATES OF CORNERS/1X,33(1H-),(T45,3F10
     & .5/))
    9 FORMAT(/36H0PARAMETERS OF THE TRANSFORMED PLANE/1X,35(1H-)//,
     & 28H0LENGTH OF TRANSFORMED X =  ,F13.3,11H  ANGSTROMS,7X,
     & 8H(ACROSS)//28H LENGTH OF TRANSFORMED Y =  ,F13.3,11H  ANGSTROMS,
     & 7X,6H(DOWN)//33H ANGLE BETWEEN TRANS. X AND Y =  ,F8.3,2X,
     & 7HDEGREES)
   10 FORMAT(1H+,25X,F10.4,4H X +,F10.4,4H Y +,F10.4,4H Z +,F14.2,
     & 6H = 0.0 /)
   11 FORMAT(/28H0TITLE OF THE PROGRAM PDFMAP/1X,27(1H-)//,1X,17A4//
     & 18H0LATTICE CONSTANTS/1X,17(1H-)//3(F10.2,4X),9HANGSTROMS//
     & 3(F10.2,4X),7HDEGREES)
   12 FORMAT(9F7.4,I5)
   13 FORMAT(7H1ARBSEC/1X,6(1H-)//)
   14 FORMAT(A1,I3,2H. ,30I4)
   16 FORMAT(/27H0PARAMETERS OF CONTROL CARD/1X,26(1H-)//5H IO =,I2,
     & 2X,4HNP =,I2,2X,6HISPC =,I2,2X,5HMRK =,I2,5X,5HIZO =,I4,5X,
     & 5HIYI =,I4,2X,5HIYF =,I4,4X,5HIZI =,I4,2X,5HIZF =,I4,5X,
     & 6HMINI =,I4,2X,6HMAXI =,I4)
   17 FORMAT(/32H0PARAMETERS OF INPUT-OUTPUT CARD/1X,31(1H-)//
     & 7H IALP =,I4,7X,6HLESE =,I4,7X,6HIEIN =,I3,4X,6HIAUS =,I3)
   19 FORMAT(41H0THESE CELL PARAMETERS ARE OVERWRITTEN BY,5X,
     & 3(F6.3,3X),9HANGSTROMS,8X,3(F6.2,3X),7HDEGREES)
   21 FORMAT(///8H0WARNING/1X,7(1H-)//30H IF MRK IS NOT ZERO, VALUES OF,
     &61H IYI,IYF,IZI AND IZF HAVE TO BE GIVEN. THEREFORE  MRK IS SET  ,
     & 9H TO ZERO.////)
 111  FORMAT(/28H0TITLE OF THE PROGRAM ERRMAP/1X,27(1H-)//,1X,17A4//
     & 18H0LATTICE CONSTANTS/1X,17(1H-)//3(F10.2,4X),9HANGSTROMS//
     & 3(F10.2,4X),7HDEGREES)
  161 FORMAT(/27H0PARAMETERS OF CONTROL CARD/1X,26(1H-)//5H IO =,I2,
     & 3X,4HNP =,I2,3X,6HISPC =,I2,3X,5HMRK =,I2,7X,5HIZO =,I4,7X,
     & 6HMINI =,I4,3X,6HMAXI =,I4)
  240 FORMAT(///////, 46X,29H LABEL  OF THE UNIT MAIN  =     ,3A4,
     &10(/),35X,10HSUBSTANCE=,15X,12HTEMPERATURE=,15X,8HSPECIAL= )
  902 FORMAT(/13H0ERRORMESSAGE/1X,12(1H-)//21H0END OF  INPUT  FILE ,
     &27HIS READ. ARBSEC TERMINATED.)
  998 FORMAT(/17H0REQUIRED STORAGE,/,1X,16(1H-)//,1X,13HUSED ELEMENTS,
     & 28H OF THE ARRAY NAMED "BUFFER" ,I6,1H.,15X,9HAVAILABLE,I6,1H.)
  999 FORMAT(13H0ERRORMESSAGE/1X,12(1H-)/
     &61H0YOU HAVE TO INCREASE THE DIMENSION OF THE ARRAY *BUFFER* TO ,
     &8HAT LEAST,I6,26H ELEMENTS. CURRENT VALUE =,I6//11H0I'M SORRY,,
     &19H I'VE TO CALL  EXIT,2X,1H.)
 1111 FORMAT(27X,44H P R O M E T H E U S  HAS  BEEN  CALLED FOR ,
     & 34HCALCULATION OF ARBITRARY SECTIONS  //
     &40X,50H             WRITTEN  BY  L. W. FINGER            //
     &40X,50H             MODIFIED BY  U. H. ZUCKER            ///
     &40X,50H FOUR POINT INTERPOLATION OF DENSITY FIELDS CAN BE/
     &40X,50H CALCULATED  AND   PREPARED  FOR  LATER  PLOTTING.//
     &40X,50H INFORMATIONS ABOUT THIS  PROGRAM   ARE  AVAILABLE/
     &40X, 6H FROM ,11A4)
 1206 FORMAT(A1,F4.0)
 1301 FORMAT(/45H0COORDINATES OF THE POINTS DEFINING THE PLANE/1X,44(1H-
     &)//33H (1. COORDINATE ACROSS , 2. DOWN),T45,F10.6,3X,F10.6//
     & 21H (IN MAP COORDINATES),2(T45,F10.6,3X,F10.6//))
 4711 FORMAT(17H0TITLE OF PROGRAM/1X,16(1H-)//1X,18A4///
     &18H TIME OF EXECUTION/1X,17(1H-)//)
 4713 FORMAT(6F8.0)
 4714 FORMAT(1H1)
 6001 FORMAT(/18H0EQUATION OF PLANE/1X,17(1H-)//19H IN MAP-COORDINATES)
 6002 FORMAT(21H0IN FRAC.-COORDINATES)
C
C
C---- INITIIALIZE FLAGS AND INITIAL VALUES.
C
C     IPRINT=0/1  COVER IS NOT/IS ALREADY PRINTED.
C     ARB(4)=0.   SIGNALS THE FILE  ISC1  TO  BE OUTPUT  OF  THE
C                 ARBSEC PROGRAM.
C
      IPRINT = 0
      ARB(4) = 0.0
C
C---- READ TITLE CARD, CONTROLCARD AND INPUT-OUTPUT CARD
C
   15 READ(IN,2,END=901)TITLE
      READ(IN,3)IO,NP,ISPC,MRK,IZO,IYI,IYF,IZI,IZF,MINI,MAXI
      READ(IN,7)IALP,LESE,IEIN,IAUS
C
C---- INIT  =0 JUST A FLAG, THAT CALCULATION OF PLANE HAS BEEN  DONE.
C
      INIT   = 0
C
C---- RESTRICTION OF THE PARAMETER ISPC TO 1 OR 2.
C
      ISPC = MOD(IABS(ISPC),2) + 1
C
C---- IF THE LOGICAL UNIT FOR THE INPUT/OUTPUT UNITS ARE READ TO
C     BE NOT ZERO, OVERWRITE THE DEFAULT VALUES.
C
      IF(IEIN.NE.0) ISC  = IEIN
      IF(IAUS.NE.0) ISC1 = IAUS
C
C---- DO NOT REWIND OUTPUT UNIT, IF THIS IS NOT THE FIRST CALCULATED
C     PLANE.
C
      REWIND ISC1
C
C---- REWIND INPUT-UNIT CONTAINING THE DENSITY ARRAY
C
      REWIND ISC
C
C---- READ SECTION CARD, CONTAINING THE POINTS DEFINING THE PLANE
C
      READ(IN,12)POINTS,ITP
C
C---- READ RECORD OF BINARY FILE, DEFINING THE DENSITY ARRAY
C
      READ(ISC)TITEL,FOURN,CELL,JACHS
C
C---- PRINT COVER, IF THIS IS NOT THE FIRST PLANE AND IF
C     MARK IS NOT EQUAL ZERO.
C
      IF(IPRINT.NE.0 .OR. MARK.NE.0) GOTO 4710
      CALL SPACE(1,11,30,IOUT,MAXLIN)
      WRITE(IOUT,1111)LLINE
      WRITE(IOUT,240)TITEL
      CALL SPACE(2,11,30,IOUT,MAXLIN)
 4710 IPRINT=1
      IF(MARK.NE.0) WRITE(IOUT,13)
C
C---- COVER IS PRINTED. NOW WRITE OUT TITLE OF RUN (FOR THIS PLANE),
C     THEN TIME OF EXECUTION IS PRINTED.
C
      IF(MARK.EQ.0) WRITE(IOUT,4714)
      WRITE(IOUT,4711)TITLE
C
C---- WRITE PARAMETERS OF CONTROL CARD AND OF THE INPUT-OUTPUT CARD.
C
      IF(MRK.EQ.0)WRITE(IOUT,161) IO,NP,ISPC,MRK,MINI,MAXI
      IF(MRK.EQ.0) GOTO 22
C
      IF((IYI.NE.0.OR.IYF.NE.0).AND.(IZI.NE.0.OR.IZF.NE.0))GOTO 222
C
      WRITE(IOUT,161)IO,NP,ISPC,MRK,IZO,MINI,MAXI
      WRITE(IOUT,21)
      MRK = 0
      GOTO 22
C
  222 WRITE(IOUT,16)IO,NP,ISPC,MRK,IZO,IYI,IYF,IZI,IZF,MINI,MAXI
C
   22 WRITE(IOUT,17)IALP,LESE,IEIN,IAUS
C
C---- WRITE TITLE OF THE PROGRAM (FOURIE,PDFMAP OR ERRMAP) WHICH
C     GENERATES THE DENSITY ARRAY
C
      IF(MARK.NE.0) GOTO 252
      IF(FOURN(18).EQ.IPDF) GOTO 251
      IF(FOURN(18).EQ.IERR) GOTO 253
      WRITE(IOUT,1)FOURN,CELL
      GOTO 252
  251 WRITE(IOUT,11) (FOURN(L),L=1,17),CELL
      GOTO 252
  253 WRITE(IOUT,111)(FOURN(L),L=1,17),CELL
C
C---- IF LESE NOT EQUAL ZERO, READ NEW CELL PARAMETERS. THIS IS ONLY
C     NECESSARY, IF WRONG CELL CONSTANTS ARE ON THE INPUTFILE.
C     (WRONG DATA PREPARED BY FOURIE, PDFMAP OR ERRMAP GENERATE WRONG
C     PLOT LAYOUT)
C
  252 IF(LESE.EQ.0) GOTO  4712
      READ (IN,4713)CELL
      WRITE(IOUT,19)CELL
 4712 DO 18 II=4,6
   18 CELL(II)=COS(CELL(II)*.017453)
C
C---- READ RECORD CONTAINING GRID INFO. OF POINT DENSITY.
C
 3000 READ(ISC,END=100)JXA,JYA,KZC,IZ,IX,IXI,IXF,IY,JYI,JYF,JZI,JZF
C
C---- ONLY IN THE FIRST TIME (COMING THIS WAY) PROGRAM CALCULATES
C     PARAMETERS OF THE DEFINED PLANE
C
      IF(INIT.NE.0) GOTO 35
      INIT = 1
C
C---- IF MRK EQUAL ZERO TAKE GRID LIMITS AS LIMITS OF PLANE. OTHERWISE
C     LIMITS HAS BEEN READ VIA CONTROL CARD.
C
      IF(MRK.NE.0)GOTO  300
C
      IYI = JYI
      IZI = JZI
      IYF = JYF
      IZF = JZF
C
C----  COORDINATES OF POINTS DEFINING PLANE ARE GIVEN IN X, Y, Z. THE
C      COORDINATES ARE TRANSFORMED TO THE ORIENTATION OF THE SYSTEM, IN
C      WHICH THE POINT DENSITY IS CALCULATED.
C
  300 CALL TRANS(JACHS,POINTS)
C
C---- CONVERT FRACTIONAL TO MAP COORDINATES, IF ITP NOT EQUAL ZERO.
C
      IF(ITP.EQ.0)GOTO  32
      DO 31 I=1,3
      POINTS(1,I)=POINTS(1,I)*IX
      POINTS(2,I)=POINTS(2,I)*IY
   31 POINTS(3,I)=POINTS(3,I)*IZ
C
C---- WRITE OUT THE COORDINATES OF THE POINTS (DEFINING THE PLANE) IN
C     COORDINATES OF THE PLANE TO BE CALCULATED.
C
   32 WRITE(IOUT,1301)POINTS(2,1),POINTS(3,1),POINTS(2,2),POINTS(3,2),
     & POINTS(2,3),POINTS(3,3)
C
C---- CALCULATE EQUATION OF PLANE
C
      A(1)=(POINTS(2,2)-POINTS(2,1))*(POINTS(3,3)-POINTS(3,1))-(POINTS(3
     &     ,2)-POINTS(3,1))*(POINTS(2,3)-POINTS(2,1))
      A(2)=(POINTS(3,2)-POINTS(3,1))*(POINTS(1,3)-POINTS(1,1))-(POINTS(1
     &     ,2)-POINTS(1,1))*(POINTS(3,3)-POINTS(3,1))
      A(3)=(POINTS(1,2)-POINTS(1,1))*(POINTS(2,3)-POINTS(2,1))-(POINTS(2
     &     ,2)-POINTS(2,1))*(POINTS(1,3)-POINTS(1,1))
      A(4)=-(A(1)*POINTS(1,1)+A(2)*POINTS(2,1)+A(3)*POINTS(3,1))
C
C---- WRITE EQUATION OF PLANE, IF POINTS ARE NOT LINEAR DEPENDENT.
C
      IF(ABS(A(1)).GT.1.0E-10)GOTO  33
C
  320 WRITE(IOUT,5)
      STOP
C
   33 WRITE(IOUT,6001)
      WRITE(IOUT,10)A
      WRITE(IOUT,6002)
      PRT(1)=A(1)/FLOAT(IY*IZ)
      PRT(2)=A(2)/FLOAT(IX*IZ)
      PRT(3)=A(3)/FLOAT(IX*IY)
      PRT(4)=A(4)/FLOAT(IX*IY*IZ)
      WRITE(IOUT,10)(PRT(III),III=1,4)
C
C---- COMPUTE COORDINATES OF CORNERS OF MAP
C
      DO 20 I=2,4
   20 A(I)=-A(I)/A(1)
C
      POINTS(1,1) = (A(2)*IYI+A(3)*IZI+A(4))/IX
      POINTS(1,2) = (A(2)*IYF+A(3)*IZI+A(4))/IX
      POINTS(1,3) = (A(2)*IYI+A(3)*IZF+A(4))/IX
      POINTS(2,1) =    FLOAT(IYI)/FLOAT(IY)
      POINTS(2,3) = POINTS(2,1)
      POINTS(3,1) =    FLOAT(IZI)/FLOAT(IZ)
      POINTS(3,2) = POINTS(3,1)
      POINTS(2,2) =    FLOAT(IYF)/FLOAT(IY)
      POINTS(3,3) =    FLOAT(IZF)/FLOAT(IZ)
C
C---- WRITE IT OUT.
C
      IF(MARK.EQ.0) WRITE(IOUT,8)POINTS
C
C---- SET UP DEFAULT VALUE FOR SHEER ANGLE, IF NO ANGLE IS GIVEN AND
C     NO ANGLE CAN BE CALCULATED.
C
      IF(CELL(1).LE.0.0.AND.IALP.LE.0)IALP=90
C
C---- COMPUTE SIZE OF TRANSFORMED SECTION, IF CELL CONSTANTS ARE MEAN-
C     INGFUL.
C
      IF(CELL(1).LE.0.0)GOTO  342
C
      AA = 0.0
      BB = 0.0
      CC = 0.0
C
      DO 340 I=1,3
      POINTS(I,2) = (POINTS(I,2)-POINTS(I,1))*CELL(I)
      AA = AA+POINTS(I,2)**2
      POINTS(I,3) = (POINTS(I,3)-POINTS(I,1))*CELL(I)
      BB = BB+POINTS(I,3)**2
  340 CC=CC+POINTS(I,2)*POINTS(I,3)
C
      DO 341 I=1,3
      J=MOD(I,3)+1
      K=9-I-J
      AA=AA+2.0*CELL(K)*POINTS(I,2)*POINTS(J,2)
      BB=BB+2.0*CELL(K)*POINTS(I,3)*POINTS(J,3)
  341 CC=CC+CELL(K)*(POINTS(I,2)*POINTS(J,3)+POINTS(J,2)*POINTS(I,3))
C
      AA=SQRT(AA)
      BB=SQRT(BB)
      CC=ACOS(CC/(AA*BB))*57.2957
C
C---- WRITE LENGTH AND WIDTH OF TRANSFORMED PLANE AND THE ANGLE BETWEEN
C     THE AXES.  MOVE THESE PARAMETERS TO ARB(1-3) FOR OUTPUTFILE.
C
      WRITE(IOUT,9)AA,BB,CC
      ARB(1) = AA
      ARB(2) = BB
      ARB(3) = CC
C
C---- CALCULATE SHEER ANGLE AND TRANSFORMATION OF OUTPUT, IF REQUESTED.
C
  342 CALL SHERE(IALP,CC,ISPC,IOUT,IS,MINI,MAXI,MARK,IO,IHILF,NP)
C
C---- COMPUTE SIZE OF SECTION AND CHECK FOR SUFFICIENT CORE
C
      NUM  = JXA*JYA
      IZA  = IZF-IZI+1
      IYA  = IYF-IYI+1
      NUM2 = IYA*IZA+NUM
      IPRT(1)=NUM2+IZA
      IF(NMR1-NUM2+IZA)8000,8000,8001
 8000 WRITE(IOUT,999)IPRT(1),NMR1
      STOP
C
 8001 IF(MARK.EQ.0) WRITE(IOUT,998)IPRT(1),NMR1
C
C----  SET FLAGS FOR FULL CELL AND SECTIONS
C
      DO 339 II=1,IZA
  339 JSECT(II+NUM2) = 1
      IFC  = 1
      IFCY = 1
      IFCZ = 1
C
C---- CLEAR FLAGS IF FULL CELL AVAILABLE ALONG X, Y, AND Z
C
      IF(IXF-IXI.GE.IX-1) IFC  = 0
      IF(JYF-JYI.GE.IY-1) IFCY = 0
      IF(JZF-JZI.GE.IZ-1) IFCZ = 0
C
C---- READ SECTION
C
   35 READ(ISC)(BUFFER(I),I=1,NUM)
C
      DO 90 II=1,IZA
      JZC = II+IZI-1
      IZC = JZC
C
C---- GET Z INTO ACTUAL SET COMPUTED
C
  343 IF(JZC.GE.JZI.AND.JZC.LE.JZF) GOTO 344
      IF(IFCZ.NE.0) GOTO 320
      JZC = JZC-ISIGN(IZ,JZC)
      GOTO 343
  344 IF(JZC.NE.KZC) GOTO 90
      JSECT(II+NUM2) = 0
      IYC = IYI
   40 IF(IYC.GT.IYF) GOTO 90
      JYC = IYC
C
C---- GET Y INTO ACTUAL SET COMPUTED
C
   41 IF(JYC.GE.JYI.AND.JYC.LE.JYF) GOTO 42
      IF(IFCY.NE.0) GOTO 320
      JYC = JYC-ISIGN(IY,JYC)
      GOTO 41
   42 INDEX = NUM+(IZC-IZI)*IYA+IYC-IYI+1
      X = A(2)*FLOAT(IYC)+A(3)*FLOAT(IZC)+A(4)
      J = (JYC-JYI)*JXA-IXI+1
      I = INT(X)
      FX=X-FLOAT(I)
      JDEX(1) = I-1
      JDEX(2) = I
      JDEX(3) = I+1
      JDEX(4) = I+2
      DO 60 I=1,4
   50 IF(JDEX(I).GE.IXI.AND.JDEX(I).LE.IXF) GOTO 60
      IF(IFC.NE.0) GOTO 70
      JDEX(I) = JDEX(I)-ISIGN(IX,JDEX(I))
      GOTO 50
   60 JDEX(I) = J+JDEX(I)
C
C---- FOUR POINT INTERPOLATION
C
      AA = -ILINE(IP1)/6.+ILINE(IP2)/2.-ILINE(IP3)/2.+ILINE(IP4)/6.
      BB = ILINE(IP1)/2.-ILINE(IP2)+ILINE(IP3)/2.
      CC = -ILINE(IP1)/3.-ILINE(IP2)/2.+ILINE(IP3)-ILINE(IP4)/6.
      BUFFER(INDEX) = ((AA*FX+BB)*FX+CC)*FX+ILINE(IP2)
      GOTO 80
C
C---- IF POINT CANNOT BE INTERPOLATED, MARK THIS IN THE OUTPUT BY STARS.
C
   70 BUFFER(INDEX)=11111.
   80 IYC = IYC+1
      GOTO 40
   90 CONTINUE
C
C---- CHECK IF ANY SECTIONS LEFT TO FIND
C
      DO 91 II=1,IZA
      IF(JSECT(II+NUM2))3000,91,3000
   91 CONTINUE
  100 N = 0
C
C---- PREPARE OUTPUT IF OUTPUT IS REQUESTED.
C
      IF(NP.NE.0) GOTO 121
C
C---- CUT OUTPUT INTO STRIPS OF THIRTY COLUMNS.
C
      DO 120 I=1,IYA,30
      N = N+1
      L = MIN0(30,IYA-I+1)
      J = I+IYI-1
      M = 0
C
C---- WRITE OUT HEADING OF POINT ARRAY
C
      DO 105 K=1,L,2
      M = M+1
  105 FY(M) = FLOAT(J+K-1)
C
C---- PRINT HEADING OF POINT ARRAY
C
      WRITE(IOUT,4)TITLE,N,IZO,(FY(K),K=1,M)
C
C---- TRANSFORM VALUE TO INTEGER BY ROUNDING AND PREPARE FORMAT FOR
C     OUTPUT
C
      DO 120 J=1,IZA
      K  = NUM+(J-1)*IYA+I
      KK = K+L-1
      DO 110 M=K,KK
  110 LINE(M-K+1) = BUFFER(M)+SIGN(.5,BUFFER(M))
      II = J+IZI-1
C
C---- OMIT POINTS WITH A VALUE BEWEEN MINI AND MAXI
C
      F1Y  = FLOAT(II)
      IZAE = 0
      DO 9000 M=1,L
      NIMM = LINE(M)
      IF(NIMM)830,860,830
  830 IF(NIMM.GT.MINI .AND. NIMM.LT.MAXI) GOTO 860
      IZAE = IZAE+1
      LINE(IZAE)= LINE(M)
      FRMT(3+M) = NZRO
      GOTO  9000
  860 FRMT(3+M) = ZRO
 9000 CONTINUE
      FRMT(4+L) = ENDD
C
C---- PREPARE OUTPUT FORMAT IN CORRESPONDENCE TO SHEER ANGLE
C
      IF(IS)1021,1022,1023
 1021 LSTORE = IZAE
      ICHECK = (J-1)*IHILF+1
      FRMT(3)= IU(ICHECK)
      ICHECK = ICHECK/4 + 1
      IF(ICHECK+L-30) 1043,1043,1042
 1042 DO 1071 IO=34-ICHECK,3+L
      IF(FRMT(IO).EQ.NZRO) LSTORE = LSTORE-1
 1071 FRMT(IO) = LEER
 1043 IF(IZAE.EQ.0) GOTO  1205
      WRITE(IOUT,FRMT)FROT(ISPC),F1Y,(LINE(K),K=1,LSTORE)
      GOTO  120
 1022 FRMT(3) = IU(1)
      GOTO 877
 1023 IF(J.EQ.1) GOTO  1050
      IF(IHILF.EQ.3) GOTO  1201
      IF(LUECK.EQ.0) ISTART = ISTART+1
      IF(ISTART.EQ.IYA) GOTO 1205
      LUECK = 4+LUECK-IHILF
      LUECK = MOD(LUECK,4)
      FRMT(3) = IU(1+LUECK)
      ICOR = 0
      DO 1054 IKLJ=1,ISTART-1
      IF(FRMT(3+IKLJ).EQ.NZRO) ICOR = ICOR+1
 1054 FRMT(3+IKLJ) = LEER
      ISTAR = ICOR+1
 1045 IF(IZAE.EQ.0) GOTO  1205
      WRITE(IOUT,FRMT) FROT(ISPC),F1Y,(LINE(K),K=ISTAR,IZAE)
      GOTO  120
 1050 ISTART = 1
      LUECK = 0
      ISTAR = 1
      FRMT(3) = IU(1)
      GOTO 1045
 877  IF(IZAE.EQ.0) GOTO  1205
      WRITE(IOUT,FRMT) FROT(ISPC),F1Y,(LINE(K),K=1,IZAE)
 120  CONTINUE
 121  IF(IO.EQ.0) GOTO  900
      K = NUM+1
      L = L + 1
      ARBIT = 0.
C
      WRITE(ISC1) TITEL,TITLE,(ARBIT,I=1,3),ARB
C
C---- PREPARE NOW AN OUTPUT LIKE THAT OF THE FOURIER PROGRAM.
C

      WRITE(ISC1)IYA,IZA,IZO,L,IY,IYI,IYF,IZ,IZI,IZF,IZI,IZF
      WRITE(ISC1)(BUFFER(M),M=K,NUM2)
      GOTO  900
 1201 ISTART = ISTART+1
      IF(LUECK.EQ.0) LUECK = 4
      LUECK = LUECK-1
      GOTO 1043
 1205 WRITE(IOUT,1206) FROT(ISPC),F1Y
      GOTO 120
C
C---- ARE ONE MORE ARBSEC RUN DESIRED?
C
  900 RETURN
C
C---- END OF LIST REACHED
C
  901 WRITE(IOUT,902)
      RETURN
C
      END
C
                  SUBROUTINE TRANS(JACHS,POINTS)
C
C     TRANSFORMATION OF POINTS (DEFINING PLANE) IN CORRESPONDENCE
C     OF COORDINATE SYSTEM OF FOURIER PROGRAM
C
      DIMENSION POINTS(3,3),HILACH(3,3)
C
      DO 301 JXK=1,3
      DO 301 JYK=1,3
  301 HILACH(JXK,JYK) = POINTS(JXK,JYK)
C
      IF(JACHS)1,1,30
   30 GOTO (2,3,4,5,6),JACHS
    2 L1 = 1
      L2 = 3
      L3 = 2
      GOTO 31
C
    3 L1 = 2
      L2 = 1
      L3 = 3
      GOTO 31
C
    4 L1 = 2
      L2 = 3
      L3 = 1
      GOTO 31
C
    5 L1 = 3
      L2 = 2
      L3 = 1
      GOTO 31
C
    6 L1 = 3
      L2 = 1
      L3 = 2
C
   31 DO 32 I=1,3
      POINTS(L1,I) = HILACH(1,I)
      POINTS(L2,I) = HILACH(2,I)
   32 POINTS(L3,I) = HILACH(3,I)
C
    1 RETURN
      END
C
C
      SUBROUTINE SHERE(IALP,CC,ISPC,IOUT,IS,MINI,MAXI,MARK,IO,IHILF,NP)
C
C     CALCULATION OF INFORMATIONS ABOUT SHEERING OF THE OUTPUT
C
    5 FORMAT(42H0SECTION IS NOT SAVED FOR LATER PLOTTING.  )
    6 FORMAT(35H0SECTION SAVED FOR LATER PLOTTING.  )
  631 FORMAT(20H0ALL POINTS BETWEEN ,I6,5H AND ,I6,13H ARE OMITTED.)
  655 FORMAT(/18H0OUTPUT-PARAMETERS/1X,17(1H-))
C
      IF(NP.NE.0) GOTO 624
      IF(IALP.EQ.1) IHC2 = INT(CC)
      IF(IALP.GE.2) IHC2 = IALP
      IF(IHC2.GE.151.OR.IHC2.LE.29) GOTO 1002
 7054 IF (IHC2-90) 1003,1002,1001
 1002 IS = 0
      GOTO  624
 1001 HILF = IHC2-90
      IS = 1
 1005 IF(ISPC.NE.2) DEL = 15.0
      IF(ISPC.EQ.2) DEL = 30.0
      HILF  = HILF/DEL
      IHILF = INT(HILF)
      DIF = HILF-FLOAT(IHILF)
      IF (DIF.GE.0.5) IHILF = IHILF+1
      GOTO 624
 1003 HILF = ABS(IHC2-90)
      IS = -1
      GOTO  1005
  624 IF(MARK.EQ.0) WRITE(IOUT,655)
      IF(IO.EQ.0) WRITE(IOUT,5)
      IF(IO.NE.0) WRITE(IOUT,6)
      IF(MARK.EQ.0 .AND. (MINI.NE.0 .OR. MAXI.NE.0).AND.NP.EQ.0)
     & WRITE(IOUT,631) MINI,MAXI
      RETURN
      END
