C      PROGRAM RIPRO(NEUPAR,IOBS,EINRE,TAPE10,TAPE3,INPUT,OUTPUT,
C     1TAPE4=EINRE,TAPE5=INPUT,TAPE1=NEUPAR,TAPE2=IOBS)
C
C     BEREITET INPUT FILES FUER PROMETHEUS
C     TAPE10: PARAMETER
C     EINGABE: STEUERKARTEN
C     TAPE3: HKL-LISTE
C     AUS OUTPUT FILES VON PROFM (MEHRPHASEN-RIETVELD)
C     NEUPAR: PARAMETER
C     TAPE2: HKL-LISTE (FOBS**2)
C     BOYSEN, IM APRIL 1988
C
C.....TRANSFORMIERE OUTPUT VON PROFM  (NEUPAR) IN
C     INPUT FUER PROMETHEUS (TAPE10)
C
      DIMENSION IPREF(5),ISYM(5),NSY(5),NAT(5),LAB(3),NSC(5)
     1,IPH(60),ALAB(60,2),ITYP(60),CELLN(6),SC(60),ISC(60)
     2,IMX(5),NMAG(5),NROT(5)
      DIMENSION EGGY(6),FOMAX(9)
      DIMENSION ER(21,6),FR(28,6)
      DIMENSION KDEGN(2640)
C
      COMMON /A/ BETA(6,60),G(3,3),ISOT(60),NATOM,TAG(2,60),TITLE(18),
     & XYZ(3,60),PI,CR(10,60),DR(15,60),ALF(60),IPRINU
      COMMON /C/ CELLP(3,4),ICENT,JCELL,NSYM,RMAT(3,3,24),TRANS(3,24),
     & DMAX,DMIN
      COMMON /D/ ANOM(2,20),
     & ISCAT(2,60),ISCL,MFSEL,OCCA(60),OCCUP(60),SCALE(10),SCAT(20),
     & SITE(60)
      COMMON/EXTI/NEXMOD,NEXPRI,NEXSEK,NEXTYP,NEXANI,NEXANP,NEXANG,
     & NEXANR,NEXDIS,NEXDMP,NEXPAR,NEXSTO,INEUT,
     & NP1,NP2,NG1,NG2,NR1,NR2,ITXTEX(36),
     & EXTPAR(12),DRDE(12),KEXTRF(12)
      COMMON /FOUR/ WINKEL(3),RECELL(6),AG,BG,CG
      COMMON /G/ FCURVE(9,20)
      COMMON /LSMAT/ IPARA(1000),MRANK,KCYL,LABEL(3),JSCRF(10),
     & NRSF,SIGMA,MDEGN,MAXIMA,IALFA(60),RDAMP(200),IDAMP(200)
      COMMON /POL/ INTER(20),INTPOL
C
C
      DATA KCYL,MREF,DMIN,DMAX,IREJ,IREJEC,REJECA,REJECB,
     1UNTEN,OBEN,NWT,IWT1,IWT2,IWT3,FOMAX(9),FOMAX(1),
     2RHOMX,RHOMN,INEUT/0,0,.1,4.,1,1,1.,1.,0.,0.,1,1,0,0,
     30.,100000.,0.,100000.,1/
      DATA ANGLP,ANGLS,GAMMAP,GAMMAS,GAMMAZ,NEXMOD,NEXSTO,
     1KZWI,IFSGN,FISGN,IPRINU,NSF,NRSF,SCALE(1),JSCRF(1)/
     21.,1.,0.,0.,0.,0,0,0,0,1.,0,1,1,1.,1./
      DATA NEXPRI,NEXSEK,NEXTYP,NEXANI,NEXANP,NEXANG,NEXANR,
     1NEXDIS,NEXDMP,NEXPAR,NP1,NP2,NG1,NG2,NR1,NR2/16*0/
C
      OPEN(4,FILE="einre")
      OPEN(1,FILE="neupar")
      OPEN(2,FILE="iobs")
      READ(1,*)
      READ(1,*) IDU,NPAT
      IPAT=1
      IF(NPAT.EQ.1) GOTO 10
      PRINT*,' WELCHE PHASE?'
      READ(5,*) IPAT
   10 DO 20 I=1,NPAT
      READ(1,11) LAB
   11 FORMAT(3A4)
      IF(I.NE.IPAT) GOTO 20
      DO 17 L=1,3
   17 LABEL(L)=LAB(L)
   20 CONTINUE
      DO 30 I=1,NPAT
      READ(1,*) IMX(I),IPREF(I)
   30 CONTINUE
      READ(1,*) IDU
      READ(1,*) IDU
      NATT=0
      NSCA=0
      NMAGT=0
      NROTT=0
      DO 40 I=1,NPAT
      READ(1,*) ISYM(I),NSY(I),NAT(I),NSC(I),NMAG(I),NROT(I)
      NATT=NATT+NAT(I)
      NSCA=NSCA+NSC(I)
      NMAGT=NMAGT+NMAG(I)
      NROTT=NROTT+NROT(I)
      IF(I.NE.IPAT) GOTO 40
      ICENT=0
      IF(ISYM(I).EQ.1) ICENT=1
      NSYM=NSY(I)+1
      NATOM=NAT(I)
   40 CONTINUE
      READ(1,*) DU,WVLNTH
      DO 41 I=1,NPAT
      IF(IMX(I).EQ.2) READ(1,*) DU
   41 CONTINUE
      DO 50 I=1,NPAT
      IF(IPREF(I).NE.0) READ(1,*) DU
   50 CONTINUE
      K=1
      DO 100 I=1,3
      DO 100 J=1,3
      RMAT(I,J,K)=0.
      IF(I.EQ.J) RMAT(I,J,K)=1.
      TRANS(J,K)=0.
  100 CONTINUE
      DO 200 NP=1,NPAT
      IF(IPAT.EQ.NP) GOTO 210
      DO 220 K=1,NSY(NP)
      IF(NROT(NP).EQ.0) GOTO 220
      DO 221 I=1,NROT(NP)
  221 READ(1,*) DU
  220 READ(1,*) DU
      GOTO 200
  210 DO 230 K=2,NSYM
      READ(1,*) ((RMAT(J,I,K),I=1,3),J=1,3),(TRANS(J,K),J=1,3)
      IF(NROT(NP).EQ.0) GOTO 230
      DO 231 I=1,NROT(NP)
  231 READ(1,*) DU
  230 CONTINUE
  200 CONTINUE
      READ(1,*) (SC(I),I=1,NSCA)
      IF(NMAGT.EQ.0) GOTO 207
      DO 208 I=1,NMAGT
      READ(1,*) NUSC
      NZEI=NUSC/4
      RZEI=FLOAT(NUSC)/4
      RNZEI=FLOAT(NZEI)
      IF(RZEI.GT.RNZEI+.01) NZEI=NZEI+1
      DO 209 J=1,NZEI
  209 READ(1,*) DU
  208 CONTINUE
  207 IA=0
      NANI=0
      NAN3=0
      NAN4=0
      PRINT*,' GIB MULTIPLICITY Pour GENERAL POSITION'
      READ(5,*) MGEN
      DO 300 KK=1,NATT
      IF (IMX(1).GE.4) THEN
      READ(1,165) (ALAB(KK,J),J=1,2),IPH(KK),ISC(KK),X,Y,Z,BT,OC,
     1MTYP,ITYP(KK)
      GOTO 299
      ENDIF
      IF (IMX(1).EQ.0) THEN
      READ(1,165) (ALAB(KK,J),J=1,2),IPH(KK),ISC(KK),X,Y,Z,BT,OC,
     1ITYP(KK)
      GOTO 299
      ENDIF
      READ(1,165) (ALAB(KK,J),J=1,2),IPH(KK),ISC(KK),X,Y,Z,BT,OC,
     1MTYP,ITYP(KK)
  165 FORMAT(A3,A2,2(I2,1X),5(F10.6,1X),3(I2,1X))
      IF(MTYP.NE.0) READ(1,*) RKX,RKY,RKZ,ITYP(KK)
  299 IF(IPH(KK).NE.IPAT) GOTO 320
      IA=IA+1
      DO 310 J=1,2
  310 TAG(J,IA)=ALAB(KK,J)
      ISOT(IA)=ITYP(KK)
      IF(ISOT(IA).GT.1) ISOT(IA)=ISOT(IA)-1
C
      IF(IA.GT.1) GOTO 340
      NSCAT=1
      DO 330 ISS=1,NSCA
      IF(ISS.NE.ISC(KK)) GOTO 330
      FCURVE(9,NSCAT)=SC(ISS)
      ISCAT(1,IA)=NSCAT
  330 CONTINUE
  340 CONTINUE
      DO 332 ISS=1,NSCA
      IF(ISS.NE.ISC(KK)) GOTO 332
      DO 334 NSA=1,NSCAT
      IF(FCURVE(9,NSA).NE.SC(ISS)) GOTO 334
      ISCAT(1,IA)=NSA
      GOTO 333
  334 CONTINUE
      NSCAT=NSCAT+1
      ISCAT(1,IA)=NSCAT
      FCURVE(9,NSCAT)=SC(ISS)
  332 CONTINUE
  333 CONTINUE
C
      PRINT*,' GIB MULTIPLIZITAET FUER'
      PRINT '(1X,2A3)',(TAG(J,IA),J=1,2)
      READ(5,*) SITE(IA)
      OCCUP(IA)=OC/SITE(IA)
      SITE(IA)=SITE(IA)/MGEN
      OCCA(IA)=0.
      XYZ(1,IA)=X
      XYZ(2,IA)=Y
      XYZ(3,IA)=Z
      IF(ISOT(IA).EQ.0) BETA(1,IA)=BT
      GOTO 350
  320 IF(ITYP(KK).LT.1) GOTO 300
      READ(1,*) DU
      IF(ITYP(KK).LT.3) GOTO 300
      READ(1,*) DU
      IF(ITYP(KK).LT.4) GOTO 300
      READ(1,*) DU
      READ(1,*) DU
      GOTO 300
  350 IF(ITYP(KK).LT.1) GOTO 300
      NANI=NANI+1
      READ(1,*) (BETA(J,IA),J=1,6)
      IF(ITYP(KK).LT.3) GOTO 300
      NAN3=NAN3+1
      READ(1,*) (CR(J,IA),J=1,10)
C     C6=CR(5,IA)
C     C5=CR(6,IA)
C     CR(5,IA)=C5
C     CR(6,IA)=C6
      DO 353 J=1,10
  353 CR(J,IA)=1000.*CR(J,IA)
      IF(ITYP(KK).LT.4) GOTO 300
      NAN4=NAN4+1
      READ(1,*) (DR(J,IA),J=1,10)
      READ(1,*) (DR(J,IA),J=11,15)
      D9=DR(5,IA)
      D5=DR(6,IA)
      D12=DR(7,IA)
      D13=DR(8,IA)
      D15=DR(9,IA)
      D6=DR(10,IA)
      D8=DR(11,IA)
      D14=DR(12,IA)
      D7=DR(13,IA)
      D10=DR(14,IA)
      D11=DR(15,IA)
      DR(5,IA)=D5
      DR(6,IA)=D6
      DR(7,IA)=D7
      DR(8,IA)=D8
      DR(9,IA)=D9
      DR(10,IA)=D10
      DR(11,IA)=D11
      DR(12,IA)=D12
      DR(13,IA)=D13
      DR(14,IA)=D14
      DR(15,IA)=D15
      DO 354 J=1,15
  354 DR(J,IA)=10000.*DR(J,IA)
  300 CONTINUE
      DO 400 I=1,NPAT
  400 READ(1,*) DU
      READ(1,*) DU
      DO 410 I=1,NPAT
  410 READ(1,*) DU
      DO 450 I=1,NPAT
      READ(1,*) A,B,C,AL,BE,GA
      IF(I.NE.IPAT) GOTO 450
      AG=A
      CELLN(1)=A
      BG=B
      CELLN(2)=B
      CG=C
      CELLN(3)=C
      WINKEL(1)=AL
      CELLN(4)=AL
      WINKEL(2)=BE
      CELLN(5)=BE
      WINKEL(3)=GA
      CELLN(6)=GA
  450 CONTINUE
C
C     ENDE LESEN VON NEUPAR
C
      PRINT*,' GIB GITTER-TYP'
      PRINT*,' P=1,A=2,B=3,C=4,F=5,I=6,R=7'
      READ(5,*) IGT
      DO 8 I=1,3
      DO 8 J=1,4
    8 CELLP(I,J)=0.
      GOTO (1,2,3,4,5,6,7) IGT
    1 JCELL=1
      GOTO 500
    2 JCELL=2
      CELLP(2,2)=.5
      CELLP(3,2)=.5
      GOTO 500
    3 CELLP(1,2)=.5
      CELLP(3,2)=.5
      JCELL=2
      GOTO 500
    4 CELLP(1,2)=.5
      CELLP(2,2)=.5
      JCELL=2
      GOTO 500
    5 CELLP(1,2)=.5
      CELLP(2,2)=.5
      CELLP(1,3)=.5
      CELLP(3,3)=.5
      CELLP(2,4)=.5
      CELLP(3,4)=.5
      JCELL=4
      GOTO 500
    6 CELLP(1,2)=.5
      CELLP(2,2)=.5
      CELLP(3,2)=.5
      JCELL=2
      GOTO 500
    7 CELLP(1,2)=1./3.
      CELLP(2,2)=2./3.
      CELLP(3,2)=2./3.
      CELLP(1,3)=2./3.
      CELLP(2,3)=1./3.
      CELLP(3,3)=1./3.
      JCELL=3
  500 CONTINUE
C
      DO 600 I=4,6
  600 CELLN(I)=COSD(CELLN(I))
      DO 610 I=1,3
      DO 610 J=1,3
      IJ=I+J
      FAC=1.
      IF(I.NE.J) FAC=CELLN(9-IJ)
      G(I,J)=CELLN(I)*CELLN(J)*FAC
  610 CONTINUE
C
      CALL TRCL1(CELLN,RECELL,VOL)
C
      IHIGH=0
      IZAEHL=0
      MODELL=2
C
      NSCAT=NSCAT+1
      DO 700 I=1,NATOM
      ISCAT(2,I)=0
  700 CONTINUE
      DO 720 I=1,NSCAT
      INTER(I)=0
      DO 721 J=1,8
  721 FCURVE(J,I)=0.
      DO 722 J=1,2
  722 ANOM(J,I)=0.
  720 CONTINUE
      FCURVE(9,NSCAT)=0.
      INTPOL=0
      NPARA=4*NATOM+6*NANI+10*NAN3+15*NAN4
      DO 730 I=1,NPARA
  730 IPARA(I)=0
      NPAR=0
      MRANK=0
      LDEGN=0
C
      EGGY(1)=4./RECELL(1)**2
      EGGY(2)=4./RECELL(2)**2
      EGGY(3)=4./RECELL(3)**2
      EGGY(4)=4./(RECELL(1)*RECELL(2))
      EGGY(5)=4./(RECELL(1)*RECELL(3))
      EGGY(6)=4./(RECELL(2)*RECELL(3))
C
      WRITE(10)
     & LABEL,AG,BG,CG,WINKEL,VOL,G,RECELL,EGGY,JCELL,((CELLP(I,J),
     & I=1,3),J=1,JCELL),ICENT,NSYM,(((RMAT(I,J,K),I=1,3),TRANS(J,K),
     & J=1,3),K=1,NSYM),MODELL,NATOM,((TAG(J,I),J=1,2),ISOT(I),OCCA(I),
     & OCCUP(I),(XYZ(J,I),J=1,3),(BETA(J,I),J=1,6),ALF(I),(CR(J,I),
     & J=1,10),(DR(J,I),J=1,15),I=1,NATOM),
     & IHIGH,((ER(J,I),J=1,21),(FR(J,I),J=1,28),I=1,IHIGH),
     & (SITE(I),IALFA(I),I=1,NATOM),IZAEHL
       N=2
      WRITE(10)
     & KCYL,MREF,DMIN,DMAX,IREJ,IREJEC,REJECA,REJECB,UNTEN,OBEN,NWT,
     & IWT1,IWT2,IWT3,FOMAX(9),FOMAX(1),RHOMX,RHOMN,INEUT,WVLNTH,
     & ANGLP,ANGLS,GAMMAP,GAMMAS,GAMMAZ,NEXMOD,NEXSTO,KZWI,IFSGN,
     & FISGN,IPRINU,NSF,NRSF,(SCALE(I),JSCRF(I),I=1,NSF),
     & ((ISCAT(J,I),J=1,2),I=1,NATOM),
     & NSCAT,(INTER(I),(FCURVE(J,I),J=1,9),(ANOM(J,I),J=1,2),I=1,NSCAT),
     & INTPOL,
     & NPARA,(IPARA(I),I=1,NPARA),
     & NPAR,
     & MRANK,(RDAMP(I),IDAMP(I),I=1,MRANK),LDEGN,(KDEGN(I),I=1,LDEGN)
       N=3
       WRITE(10)
     & NEXPRI,NEXSEK,NEXTYP,NEXANI,NEXANP,NEXANG,NEXANR,NEXDIS,NEXDMP,
     & NEXPAR,NP1,NP2,NG1,NG2,NR1,NR2,ITXTEX,
     & (EXTPAR(I),DRDE(I),KEXTRF(I),I=1,NEXPAR)
C
C     PRINT*,
C    & LABEL,AG,BG,CG,WINKEL,VOL,G,RECELL,EGGY,JCELL,((CELLP(I,J),
C    & I=1,3),J=1,JCELL),ICENT,NSYM,(((RMAT(I,J,K),I=1,3),TRANS(J,K),
C    & J=1,3),K=1,NSYM),MODELL,NATOM,((TAG(J,I),J=1,2),ISOT(I),OCCA(I),
C    & OCCUP(I),(XYZ(J,I),J=1,3),(BETA(J,I),J=1,6),ALF(I),(CR(J,I),
C    & J=1,10),(DR(J,I),J=1,15),I=1,NATOM),
C    & IHIGH,((ER(J,I),J=1,21),(FR(J,I),J=1,28),I=1,IHIGH),
C    & (SITE(I),IALFA(I),I=1,NATOM),IZAEHL
       N=2
C     PRINT*,
C    & KCYL,MREF,DMIN,DMAX,IREJ,IREJEC,REJECA,REJECB,UNTEN,OBEN,NWT,
C    & IWT1,IWT2,IWT3,FOMAX(9),FOMAX(1),RHOMX,RHOMN,INEUT,WVLNTH,
C    & ANGLP,ANGLS,GAMMAP,GAMMAS,GAMMAZ,NEXMOD,NEXSTO,KZWI,IFSGN,
C    & FISGN,IPRINU,NSF,NRSF,(SCALE(I),JSCRF(I),I=1,NSF),
C    & ((ISCAT(J,I),J=1,2),I=1,NATOM),
C    & NSCAT,(INTER(I),(FCURVE(J,I),J=1,9),(ANOM(J,I),J=1,2),I=1,NSCAT),
C    & INTPOL,
C    & NPARA,(IPARA(I),I=1,NPARA),
C    & NPAR,
C    & MRANK,(RDAMP(I),IDAMP(I),I=1,MRANK),LDEGN,(KDEGN(I),I=1,LDEGN)
       N=3
C      PRINT*,
C    & NEXPRI,NEXSEK,NEXTYP,NEXANI,NEXANP,NEXANG,NEXANR,NEXDIS,NEXDMP,
C    & NEXPAR,NP1,NP2,NG1,NG2,NR1,NR2,ITXTEX,
C    & (EXTPAR(I),DRDE(I),KEXTRF(I),I=1,NEXPAR)
C
C     CREATE INPUTFILE FUER REFINE (EINGABE)
C
      WRITE(4,1001)
 1001 FORMAT('NTITLE',/,'REFINE')
      WRITE(4,11) LABEL
      WRITE(4,1003)
 1003 FORMAT('******')
      WRITE(4,1010)
 1010 FORMAT('T 3411 00000 00000011 00     .000    .000    .000
     1.000')
      WRITE(4,1020)
 1020 FORMAT('1')
      DO 1100 I=1,NATOM
      WRITE(4,1110)
 1110 FORMAT('0000000000')
      IF(ISOT(I).LT.2) GOTO 1100
      WRITE(4,1110)
      IF(ISOT(I).LT.3) GOTO 1100
      WRITE(4,1111)
 1111 FORMAT('000000000000000')
 1100 CONTINUE
      WRITE(4,1030)
 1030 FORMAT('O')
      WRITE(4,1040)
 1040 FORMAT('STAN')
      WRITE(4,1050)
 1050 FORMAT('030000       0.00')
      INEUT=1
      IF(IMX(1).GE.4) INEUT=0
      LPCORP=0
      TBAR=999999.
      WRITE(4,1060) INEUT,LPCORP,WVLNTH,TBAR
 1060 FORMAT(2I1,F8.4,F8.0)
      WRITE(4,1210)
 1210 FORMAT('110',/,'******',/,
     1'T 3411 00000 00000000 00    .000    .000    .000    .000')
      WRITE(4,1065)
 1065 FORMAT('110',/,'******',/,
     1'P 3411 20002 00000000 00    .000    .000    .000    .000')
      WRITE(4,1070)
 1070 FORMAT('010',/,'FINISH')
C
C     WRITE HKL-LISTE (TAPE2 VON PROFM --> TAPE3 FUER REFINE)
C
      FMAX=0.
 2000 READ(2,2010,END=2051) NP,IH,IK,IL,FOBSI,FESDI
      IF(IPAT.EQ.NP)THEN
      IF(FOBSI.GT.FMAX) FMAX=FOBSI
      ENDIF
      GOTO 2000
 2051 REWIND(2)
 2001 READ(2,2010,END=2050) NP,IH,IK,IL,FOBSI,FESDI
 2010 FORMAT(4I3,2F14.0)
C     PRINT*,NP,IH,IK,IL,FOBSI,FESDI
      IF(IPAT.EQ.NP) THEN
      MREJ=0
      IF(FOBSI.EQ.0.) MREJ=1
      FOBSI=FOBSI/FMAX*99000.
      FESDI=FESDI/FMAX*99000.
      IF(FESDI.LT..1) FESDI=.1
      IF(FESDI.GT.999.) THEN
      FMAX=FMAX*10.
      REWIND(3)
      GOTO 2051
      ENDIF
      WRITE(3,2020) IH,IK,IL,MREJ,FOBSI,FESDI
 2020 FORMAT(13X,3I3,3X,I3,3X,F9.3,9X,F5.1)
      ENDIF
      GOTO 2001
 2050 WRITE(3,2060)
 2060 FORMAT('END')
      END
      SUBROUTINE TRCL1(CELLN,RCELLN,V)                                    T
C     **************************************************************    T
C     TRANSFORMS REAL CELL TO RECIPROCAL OR VICE VERSA                  T
C     INPUT CELL IS IN ARRAY CELL AS LENGTHS AND COSINES                T
C     **************************************************************    T
C                                                                       T
      DIMENSION CELLN(6),RCELLN(6),SINA(3)                                T
C                                                                       T
      ABC=1.0                                                           T
      PROD=2.0                                                          T
      V=-2.0                                                            T
      DO 10 I=1,3                                                       T
      L=I+3                                                             T
      SINA(I)=1.0-CELLN(L)**2                                            T
      V=V+SINA(I)                                                       T
      SINA(I)=SQRT(SINA(I))                                             T
      PROD=PROD*CELLN(L)                                                T
10    ABC=ABC*CELLN(I)                                                  T
      V=ABC*SQRT(V+PROD)                                                T
C      V IS CELL VOLUME                                                 T
C     PUT INVERTED CELL INTO RCELL                                      T
      DO 20 I=1,3                                                       T
      CALL PERM1(I,J,K)                                                  T
      RCELLN(I)=CELLN(J)*CELLN(K)*SINA(I)/V                             T
      L=I+3                                                             T
20    RCELLN(L)=(CELLN(J+3)*CELLN(K+3)-CELLN(L))/(SINA(J)               T
     2 *SINA(K))                                                        T
      RETURN                                                            T
      END                                                               T
      SUBROUTINE PERM1(I,J,K)                                            P
      PARAMETER (ML=80,MP=99,MX=103)
C     **************************************************************    P
C     PERMS USEFUL COMBINATIONS OF INTEGERS IN THE RANGE 1 TO 3         P
C     **************************************************************    P
      IF(I-2)10,20,30                                                   P
10    J=2                                                               P
      K=3                                                               P
      RETURN                                                            P
20    J=3                                                               P
      K=1                                                               P
      RETURN                                                            P
30    J=1                                                               P
      K=2                                                               P
      RETURN                                                            P
      END                                                               P
