C      PROGRAM MAIN(EINMP  ,LPMUL ,TAPE5=EINMP  ,TAPE6=LPMUL ,TAPE2,
C     &TAPE10,TAPE11,TAPE12,TAPE13,ZZZG67,TAPE67=ZZZG67)
C                            MAINPROGRAM
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + THE MAINPROGRAM  READS THE SELECTION CARDS (SPSCAN,TDSCOR,ABSORB,  +
C + SPHERE,AVERAG,REFINE,FOURIE,ERRMAP,PDFMAP,POTCAL,ARBSEC,PLOTTE,    +
C + BONVIB,LISTFC,MULPD,FINISH,NTITEL,INFO## AND CALLS THE             +
C + CORRESPONDING OVERLAYS.                                             +
C + WRITTEN BY E. PERENTHALER AND U. ZUCKER MPI-FKF (1979)             +
C +                                                                    +
C + (LAST UPDATE FEBRUARY 1982)                                        +
C +                                                                    +
C + IN ADDITION THE FOLLOWING SUBROUTINES ARE CALLED                   +
C + TITEL, TIME, ANFANG (ENTRY 'ENDE')                                 +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- DIMENSION DECLARATION FOR PROGRAMS   OF THE NEW GENERATION
C
C   - IN THE ARRAY  LINE  ONE MAY WRITE THE NAME OF THAT PERSON,
C     WHO IS RESPONSIBLE FOR CORRECT RUNNING OF PROMETHEUS
C   - MAXLIN  IS THE NUMBER OF LINES PER PAGE FOR THE PRINTER USED.
C   - IN  IS LOGICAL NUMBER OF STANDARD INPUT UNIT
C   - SAME FOR OUTPUT-UNIT
C   - NUMBER  IS THE DIMENSION OF FIELDS IN COMMON/OVNAM/
C
      DIMENSION LINE(11)
C
      CHARACTER ISTAR1*4,ISTAR2*2,IAY(21)*2
      CHARACTER*4 IOVERL(21)
      COMMON /ALL/IN,IOUT,LINE,MAXLIN,ISTAR3,IREW19
C
C---- DATA STATEMENTS
C
C---- DIMENSION OF FIELDS IN COMMON /OVNAM/
C
      DATA NUMBER/21/
C
C---- NAME OF RESPONSIBLE MAN
C
      DATA LINE/4HSTEU,4HRER ,4H    ,4H    ,4H    ,4H    ,
     &          4HZIMM,4HER 2,4H42  ,4H    ,4H    /
C
C---- LOGICAL UNITS FOR INPUT (IN) AND OUTPUT (IOUT)
C
      DATA IN,IOUT/05,06/
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/'SPSC','TDSC','ABSO','SPHE','AVER','REFI','FOUR',
     &'ERRM','PDFM','POTC','ARBS','PLOT','BONV','LIST','PRED','FINI',
     &'NTIT','INFO','OPTI','    ','MULP'/
      DATA IAY/'AN','OR','RB','RE','AG','NE','IE','AP','AP','AL','EC',
     &'TE','IB','FC','ES','SH','LE','  ','ON','  ','DF'/
C
C---- INITIALIZE
C
      OPEN(5,FILE="einmp")
      OPEN(6,FILE="lpmul")
      OPEN(67,FILE="ZZZG67")
      OPEN(02,FILE="ftn02",FORM="UNFORMATTED")
      OPEN(10,FILE="ftn10",FORM="UNFORMATTED")
      OPEN(11,FILE="ftn11",FORM="UNFORMATTED")
      OPEN(12,FILE="ftn12",FORM="UNFORMATTED")
      OPEN(13,FILE="ftn13",FORM="UNFORMATTED")
C---- LOGICAL UNIT OF THAT FILE ON WHICH PLOTTING ORDERS TO BE
C     WRITTEN.
C
      IPLOT=19
C
C---- MAXIMUM LINES PER PAGE OF PRINTER USED.
C
      MAXLIN = 63
C
C---- OTHERS
C
      IREW19=0
      IZAEHL=0
      ILAB = 0
      IERR = 0
      M    = 0
      ITITEL = 0
      ISHORT = 0
C
C---- THE VARIABLE ITOP IS SET TO 1, IF COVER IS PRINTED. OTHERWISE
C     IT COULD HAPPEN THAT ERRORMESSAGES WILL BE PRINTED INSIDE COVER.
C
      ITOP = 0
C
C---- READ LABEL OF OVERLAY. COMPARE WITH TABLE OF LEGAL NAMES AND
C     SWITCH.
C
C---- SET CLOCK TO START
C
   01 CONTINUE
      IF(ITITEL.EQ.1) ITOP = 1
C

   02 READ (IN,10,END=2050) ISTAR1,ISTAR2,ISTAR3
   10 FORMAT (A4,A2,I1)
C
      IF(ISTAR3.NE.1) ISTAR3=0
      IF(ISTAR1.EQ.IOVERL(19)) ISHORT=1
      IF(ISHORT.EQ.1) ISTAR3 = 1
      IOVERL (NUMBER) = ISTAR1
      DO 20 I = 1,NUMBER
      ILAB = I
   20 IF (ISTAR1 .EQ.IOVERL(I)) GO TO 30
C
C---- IF THIS IS THE FIRST REQUEST AND IS IT NOT EQUAL *NTITLE*
C     PRINT THE MAINCOVER
C
   30 IF(ITITEL.EQ.0 .AND. I.NE.17) CALL TITEL(IOUT)
C
      IF(I.NE.17)M=1
      ITITEL = 1
C
      GO TO (100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,
     &1400,1500,3000,02,02,02,2000,1600),ILAB
  100 CONTINUE
      GO TO 01
  200 CONTINUE
      GO TO 01
  300 CONTINUE
      GO TO 01
  400 CONTINUE
      GO TO 01
  500 CONTINUE
      GO TO 01
  600 CONTINUE
C     CALL CALREF
      GO TO 01
  700 CONTINUE
C     CALL FOURIE
      GOTO 01
  800 CONTINUE
      GOTO 01
  900 CONTINUE
C     CALL PDFMAPS
      GOTO 01
 1000 CONTINUE
      GO TO 01
 1100 CONTINUE
C     CALL ARBSEC
      GOTO 01
 1200 CONTINUE
      GOTO 01
 1300 CONTINUE
      GOTO 01
 1400 CONTINUE
      GOTO 01
 1500 CONTINUE
      GO TO 01
 1600 CONTINUE
      CALL MULPDF
      GO TO 01
C
C---- ERROR MESSAGES
C
 2000 IF(ITOP.EQ.0) WRITE(IOUT,2010)
      ITOP = 1
      WRITE (IOUT,2020) ISTAR1,ISTAR2
 2010 FORMAT(1H1)
 2020 FORMAT(/1X,5(1H*),37HWARNING - INSTEAD OF A PROGRAM   NAME,
     & 2H ",A4,A2,40H" WAS READ.    THE CARD WILL BE IGNORED.)
C
      IZAEHL=IZAEHL+1
      IF(IZAEHL.GT. 3) GOTO 2030
      GO TO 02
 2030 WRITE(IOUT,2040)
 2040 FORMAT(//,1X,34HTHERE ARE TOO MANY ILLEGAL CARDS. /
     & 55H THE PROGRAM   SUPPOSE A FATAL ERROR - JOB TERMINATED. )
      IERR = 1
      GO TO 3000
C
 2050 WRITE(IOUT,2060)
 2060 FORMAT(5(/),1X,45H*END OF FILE* WAS READ ON STANDARD INPUT UNIT,
     & 17H. JOB TERMINATED.)
      IERR = 1
C
 3000 IF(IREW19.EQ.0)GOTO 3020
      WRITE(IOUT,3010) IPLOT
 3010 FORMAT(44H0*END OF FILE* WRITTEN TO THE PLOTTING FILE. ,
     & 14H (LOG.-NO. IS ,I4,1H) )
C
C---- THERE ARE TWO POSSIBILITIES OF GENERATING END OF FILE ON PLOTTER
C     FILE IPLOT. THE FIRST WAY IS BY CALLING OVERLAY PLOTT AGAIN  AND
C     AND DO IT THERE. (NOT POSSIBLE ON HONEYWELL BULL). THE SECOND IS
C     BY DOING IT HERE. ON SOME COMPUTERS LIKE UNIVAC 1110 ON EXEC  IT
C     IS NOT RECOMMENDABLE, BECAUSE OF  THE GREAT  CORE ALLOCATION  OF
C     THE PLOTTING SOFTWARE.
C
C     CALL LLINK("PLOTT")
C     CALL PLOTTE(IREW19,1)
C     CALL PLOT(0.,0.,999)
 3020 CONTINUE
C     CALL TIME (100,IOVERL,IAY,TTINI,TOVINI)
      IF(IERR.EQ.0) WRITE(IOUT,3030)
      IF(IERR.EQ.1) WRITE(IOUT,3040)
 3030 FORMAT(19H0NORMAL TERMINATION)
 3040 FORMAT(4(/),21H ABNORMAL TERMINATION)
C
C
      STOP
      END
                         SUBROUTINE TITEL(IOUT)
C
C       THIS ROUTINE GENERATES THE COVER OF THE SYSTEM PROMETHEUS
C
C             PROGRAMMERS   E. PERENTHALER AND U. ZUCKER
C
C                             NOVEMBER 1980
C
C----            IOUT IS LOGICAL NUMBER OF OUTPUT UNIT
C
C---- PRINT COVER. (THERE ARE MORE THAN ONE FORMAT STATEMENT, BECAUSE
C      OF A POSSIBLE MAXIMUM NUMBER OF CONTINUATION CARDS ALLOWED)
C
      WRITE(IOUT,1)
      WRITE(IOUT,2)
      WRITE(IOUT,3)
      WRITE(IOUT,4)
      WRITE(IOUT,5)
C
C---- WRITE COVER.   FIRST IN GREAT LETTERS    PROMETHEUS
C
C---- FIRST LINE
    1 FORMAT(1H1,4(/),10X,8(1HX),3X,8(1HX),5X,6(1HX),3X,3(1HX),4X,3(1HX
     & ),1X,10(1HX),1X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX
     & ),4X,3(1HX),3X,8(1HX)/
C---- SECOND LINE
     & 10X,9(1HX),2X,9(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1
     & X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,10(1HX)/
C---- THIRD LINE
     & 10X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,3(1HX),4X,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3
     & (1HX),8X,3(1HX),4X,3(1HX),1X,3(1HX)/
C---- FOURTH LINE
     & 10X,3(1HX),4X,3(1HX),2(1X,3(1HX),4X,3(1HX)),1X,4(1HX),2X,4(1HX)
     & ,1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3(1HX),4
     & X,3(1HX),1X,3(1HX)/
C---- FIFTH LINE
     & 10X,9(1HX),2X,9(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),2X,5(1HX))
C
C---- SIXTH LINE
   2  FORMAT(
     & 10X,8(1HX),3X,6(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),4X,6(1HX)/
C---- SEVENTH LINE
     & 10X,3(1HX),8X,3(1HX),1X,3(1HX),4X,3(1HX),4X,3(1HX),1X,3(1HX),1
     & X,2(1HX),2(1X,3(1HX)),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX)
     & ,8X,3(1HX),4X,3(1HX),8X,3(1HX)/
C---- EIGHTH LINE
     & 10X,3(1HX),8X,3(1HX),2X,3(1HX),3X,3(1HX),4X,3(1HX),1X,3(1HX),4X
     & ,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3
     & (1HX),4X,3(1HX),8X,3(1HX)/
C---- NINETH LINE
     & 10X,3(1HX),8X,3(1HX),3X,3(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),2X,8(1HX),2
     & X,9(1HX)/
C---- TENTH LINE
     & 10X,3(1HX),8X,3(1HX),4X,3(1HX),3X,6(1HX),3X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),3X,6(1HX),3
     & X,8(1HX),5(/))
C
C---- PRINT NOW     THE FIRE BEARING
C
C---- FIRST LINE
    3 FORMAT(21X,1HX,4X,1HX,18X,2(1HX),2X,1HX,18X,1HX,27X,1HX/
C---- SECOND LINE
     & 21X,1HX,4X,1HX,17X,1HX,23X,1HX/
C---- THIRD LINE
     & 19X,5(1HX),2X,4(1HX),4X,3(1HX),5X,5(1HX),2X,1HX,2X,1HX,1X,
     & 3(1HX),2X,3(1HX),6X,4(1HX),4X,3(1HX),4X,3(1HX),3X,1HX,1X,
     & 3(1HX),2X,1HX,2X,1HX,1X,2(1HX),4X,3(1HX)/
C---- FOURTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,3X,1HX,6X,1HX,4X,1HX,2X,2HXX,4X,
     & 1HX,3X,1HX,5X,1HX,3X,1HX,2X,1HX,3X,1HX,2X,1HX,2X,1HX,3X,2HXX,
     & 5X,1HX,2X,2(1HX),2X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,5(1HX),6X,1HX,4X,1HX,2X,1HX,5X,5(1HX)
     & ,5X,1HX,3X,1HX,2X,5(1HX),2X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,10X,1HX,4X,1HX,2X,1HX,5X,1HX,9X,
     & 1HX,3X,1HX,2X,1HX,6X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X,1HX,2X
     & ,1HX,3X,1HX/
C---  SEVENTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,3X,4(1HX),6X,1HX,4X,1HX,2X,1HX,6X,4(1HX)
     & ,5X,4(1HX),4X,4(1HX),3X,4(1HX),2X,1HX,6X,1HX,2X,1HX,3X,1HX,3X,
     & 4(1HX)/
C--- EIGHTH AND NINETH LINE
     & 110X,1HX/106X,4(1HX),5(/))
C
C---- PRINT NOW    TITAN GOD
C
C---- FIRST LINE
    4 FORMAT(39X,5(1HX),2X,1HX,4X,1HX,21X,3(1HX),14X,1HX/
C---- SECOND LINE
     & 41X,1HX,9X,1HX,20X,1HX,17X,1HX/
C---- THIRD LINE
     & 41X,1HX,4X,1HX,2X,5(1HX),3X,3(1HX),3X,1HX,1X,3(1HX),4X,1HX,1X,
     & 3(1HX),3X,3(1HX),4X,4(1HX)/
C---- FOURTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,2(1HX),2X,1HX,4X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SEVENTH LINE  (THANKS HEAVEN)
     & 41X,1HX,4X,1HX,4X,1HX,5X,4(1HX),2X,1HX,3X,1HX,5X,3(1HX),4X,
     & 3(1HX),4X,4(1HX),5(/))
C
C---- PRINT REST OF COVER
C
    5 FORMAT(38X,45HPROGRAM   SYSTEM FOR SOPHISTICATED STRUCTURE ,
     & 10HREFINEMENT,7(/),
C
C---- PRINT DATE OF LAST UPDATE
C
     & 52X,24HVERSION OF NOVEMBER 1980,7(/),
C
C---- AUTHORS
     & 32X,66HU.H. ZUCKER, E. PERENTHALER, W.F. KUHS, R. BACHMANN, AND H
     &. SCHULZ)
      RETURN
      END
                          SUBROUTINE SPACE
     &                  (N,IOV,IB,IO,MAXLIN)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + SUBROUTINE SPACE PRINTS THE FIRST AND THE LAST LINE OF THE COVER   +
C + FOR EACH PROGRAM   AND POSITIONES THE TEXT BLOCK OF THE COVER      +
C + DEPENDING ON THE MAXIMUM NUMBER OF LINES PER PAGE (MAXLIN).        +
C + WRITTEN BY E. PERENTHALER  MPI-FKF (DECEMBER 1980)                 +
C +                                                                    +
C + THIS PROGRAM   IS CALLED BY EACH PROGRAM  OF THE SYSTEM            +
C + PROMETHEUS.                                                        +
C +                                                                    +
C + THIS PROGRAM   DO NOT CALL ANY OTHER SUBROUTINE.                   +
C +                                                                    +
C + IN CASE OF AN OVERLAY STRUCTURE IT IS PART OF THE MAIN-OVERLAY     +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- INPUT VARIABLES
C     ---------------
C
C   - N       FIRST OR SECOND CALL BY ONE OF THE PROGRAM  S
C             (BEGIN OR END OF THE COVER TO BE PRINTED)
C   - IOV     NUMBER OF THE CALLING PROGRAM
C   - IB      LENTH OF THE TEXT BLOCK ON THE COVER OF THIS PROGRAM
C
C---- DIMENSION STATEMENTS
C     --------------------
C
      DIMENSION IOVERL(14),IAY(14)
C
C---- DATA STATEMENTS
C     ---------------
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/4HSPSC,4HTDSC,4HABSO,4HSPHE,4HAVER,4HREFI,4HFOUR,
     &4HERRM,4HPDFM,4HPOTC,4HARBS,4HPLOT,4HBONV,4HLIST/
C
      DATA IAY/2HAN,2HOR,2HRB,2HRE,2HAG,2HNE,2HIE,2HAP,2HAP,2HAL,2HEC,
     &2HTE,2HIB,2HFC/
C
C---- FORMAT STATEMENTS
C     -----------------
C
   10 FORMAT (1H1,3X,18(A4,A2,1X))
   40 FORMAT (1X)
   70 FORMAT (4X,18(A4,A2,1X))
C
C---- EXECUTABLE STATEMENTS
C     ---------------------
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 20
C
C---- FIRST LINE OF THE COVER
      WRITE (IO,10) (IOVERL(IOV),IAY(IOV),I=1,18)
C
C---- NUMBER OF EMPTY LINES TILL START OF TEXT BLOCK
   20 IS = MAXLIN / 3
      IF (MAXLIN - IS - IB - 4 .LT. 4) IS = MAXLIN - IB - 8
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 50
C
C---- EMPTY LINES
      DO 42 I=1,IS
42    WRITE (IO,40)
C
      RETURN
C
C---- NUMBER OF EMPTY LINES BEHIND THE TEXT BLOCK
   50 IS = MAXLIN - IS - IB - 4
C
C---- EMPTY LINES
      DO 43 I=1,IS
43    WRITE (IO,40)
C
C---- LAST LINE OF THE COVER
      WRITE (IO,70) (IOVERL(IOV),IAY(IOV),I=1,18)
C
      RETURN
      END
C     OVERLAY (MAI,5,0)
C     PROGRAM MULPDF (EINGABE,OUTPUT,TAPE5=EINGABE,TAPE6=OUTPUT,
C    &TAPE10,TAPE11,TAPE9)
      SUBROUTINE MULPDF
C
C   PROGRAM   FOR  CALCULATING     JOINT  PROBABILTY  DENSITY      MAPS.
C
C   THE PROGRAM PDFMAP WRITTEN BY UDO ZUCKER HAS BEEN EXTENDED  SO  THAT
C   ONE CAN NOW COMBINE PDFS OF SEVERAL  POSITIONS TO A  JOINT PDF. THIS
C   ALLOWS TO CALCULTE A CONTINUOUS DITRIBUTION THROUGOUT A CRYSTAL  AND
C   TO  USE SPLIT POSITIONS FOR DESCRIBING  ANHARMONIC  THERMAL  MOTION.
C
C
C              WRITTEN BY    ROLF BACHMANN         DEC  1981
C              MAX PLANCK INSTITUT FUER FESTKOERPERFORSCHUNG
C              HEISENBERGSTR.1,   7000  STUTTGART  80,   FRG
C                          (SEPTEMBER  1979)
C
C
C   INPUT FILES ARE
C   ---------------
C                   MAINFILE   OF PROGRAM REFINE            UNIT   ISC1
C                   HARMO FILE OF PROGRAM REFINE            UNIT IHARMO
C                   STANDARD    INPUT       UNIT            UNIT     IN
C
C   OUTPUT FILES ARE
C   ----------------
C
C                   PLOT OUTPUT UNIT FOR ARBITRARY
C                   MAPS AND PLOTS                          UNIT     S2
C                   STANDARD   OUTPUT         UNIT          UNIT   IOUT
C
C    DEFINITION OF OTHER INPUT VARIABLES
C    -----------------------------------
C
C    LINE   ARRAY OF DIM. 11.  IT CARRIES INFORMATION ABOUT THAT MAN WHO
C           TAKES CARE ON THE PROGRAMME SYSTEM AT YOUR COMPUTING CENTER.
C    NPAGE  MAXIMUM  NUMBER  OF  LINES  PER PAGE AT THE CURRENT PRINTER.
C    MARK   0/1  DO NOT/DO REDUCE THE OUTPUT TO A MINIMUM
C
      INTEGER              S2,ZRO,ENDD,TITLE,FRMT
      REAL                 MIROR3,ISKEW
C
      DIMENSION   JCUM(5),IAUSG(5),IFUENF(21),ISECHS(28),FRMT(50),IU(50)
     &,LABEL(3), RECELL(6), G(3,3), RMAT(3,3,24),TRANS(3,24),CELLP(3,4),
     &EGGY(6),TAG(2,60),ER(21,6),FR(28,6),
     &ISOT(60),OCCA(60),OCCUP(60),XYZ(3,60),BETA(6,60),
     &CR(10,60),DR(15,60),IPDFF(6),XH(3,60),BH(6,60),
     &R1(3), R2(6), HJKLM(15),  X(3),  IP(43),  FX(21), TITLE(18), IPLOT
     &(60),CELL(6), IDAT(5), ISEC(6), ISER(20),IDATA(11),IORIGN(2),ITYPE
     &(12),ALF(60), IOUTP(8),IPRI(34),OUTP(2),JFIVE(21),JSIX(28),LOOP(6)
     &,JTHREE(10),JFOUR(15),LINE(11),E1(3),E2(3),E3(3),MTYP(3),VECTR1(3)
     &,VECTR2(3), POUT(3), XHELP(3), DXY(3),DXZ(3), XP(3),XXP(3),XYP(3),
     &YP(3),XPR(3,100),NXX(6), VECTO1(3),VECTO2(3), UTRANS(3),UMAT(3,3),
     &ORI(3)
C
C
      COMMON /ALL/IN,IOUT,LINE,MAXLIN,ISTAR3
      COMMON           /PRINT/WINKEL(3),ISELEC,ISECT,IS,IHILF,LSPCH,GAM
      COMMON           /INVBET/Q(3,3)
      COMMON           /WQ/W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON           /BACH/POINT(3),RADIUS,IOVERL,ARRAY(39995)
      COMMON           /APLANE/AA(3),AB(3),AXI,AYI
C
      EQUIVALENCE  (WINKEL(1),ALFA),(WINKEL(2),BET),(IOUTP(1),OUTP(1))
      EQUIVALENCE  (DR(1,41),ER),(DR(7,49),FR)
      EQUIVALENCE  (NXX(1),NXL),(NXX(2),NYL),(NXX(3),NZL),(NXX(4),NXU)
     &,(NXX(5),NYU),(NXX(6),NZU)
C
C----------------- ASSIGNEMENT OF LOGICAL UNIT NUMBERS ----------------
C
      DATA            ISC1,IHARMO,S2  /10,9,11/
      DATA XYZ,ALF,BH,ER,FR,FX,OCCA,OCCUP,OUTP/1037*0./
      DATA R2,VECTR1,VECTR2,XH/192*0./
      DATA IOUTP,IP,ISOT,JFIVE,JSIX/160*0/
C
C----------------------------------------------------------------------
C
      DATA     ISPC,IBNK,TITLE(18),JNOT,IARB/1H0,1H ,4HPDF ,1H ,4HARB /
      DATA     LEER ,ZRO,NZRO,ENDD              /1H ,3H,4X,3H,I4,1H)/
      DATA     IDAT /4HNO  ,4HYES ,4HDOUB,4HSING,4HLE  /
      DATA     KLVIN,MCENTR /1HK,4HCENT/
      DATA     ISEC   /4HXYZD, 4HXZYU, 4HYXZU, 4HYZXD, 4HZYXU,4HZXYD/
      DATA     ISER/4HEDGE,4H-WOR,4HTH-S,4HERIE,4H    ,4HGRAM,4H-CHA,
     &        4HRLIE,4HR-SE,4HRIE ,4HALPH,4HA-FO,4HRM. ,4HEDGE,4HW.  ,
     &        4HALPH,4HA-FO,4HRM. ,4HGRAM,4H-CH./
      DATA     JCUM/7H  TWO  ,7H THREE ,7H  FOUR ,7H FIVE  ,7H  SIX  /
      DATA IORIGN,TWOPI3,TWOPI4,TWOPI6/4HZERO,4HATOM,248.050214,1558.
     &         54546,61528.908/
C
C---- IF YOU THINK ABOUT INCONSISTENCY INTERPRET TWOPI2,TWOPI3,.......
C
      DATA     TWOPI2,EINDRI,ZWIDRI/19.7392088,0.33333333,0.66666666/
      DATA     ITYPE  /4H  FI, 4HRST , 4H SEC, 4HOND , 4H  TH,4HIRD ,
     &         4H  FO,4HRTH ,4H  FI,4HFTH ,4H  SI,4HXTH /
      DATA    IPRI/2HX=,2HY=,2HZ=,4HB11=,4HB22=,4HB33=,4HB12=,4HB13=,
     & 4HB23=,4HC111,4HC222,4HC333,4HC112,4HC122,4HC113,4HC133,4HC223
     &,4HC233,4HC123,4H1111,4H2222,4H3333,4H1112,4H1113,4H1122,4H1123
     &,4H1133,4H1222,4H1223,4H1233,4H1333,4H2223,4H2233,4H2333/
      DATA  IFUENF/7HE11111=,7HE22222=,7HE33333=,7HE11112=,7HE11113=,
     &             7HE11122=,7HE11123=,7HE11133=,7HE11222=,7HE11223=,
     &             7HE11233=,7HE11333=,7HE12222=,7HE12223=,7HE12233=,
     &   7HE12333=,7HE13333=,7HE22223=,7HE22233=,7HE22333=,7HE23333=/
      DATA  ISECHS/7HF111111,7HF222222,7HF333333,7HF111112,7HF111113,
     &   7HF111122,7HF111123,7HF111133,7HF111222,7HF111223,7HF111233,
     &   7HF111333,7HF112222,7HF112223,7HF112233,7HF112333,7HF113333,
     &   7HF122222,7HF122223,7HF122233,7HF122333,7HF123333,7HF133333,
     &   7HF222223,7HF222233,7HF222333,7HF223333,7HF233333/
      DATA LOOP   /3,6,10,15,21,28/
      DATA FRMT     /4H(A1,,4HF4.0,3H,1X,47*1H /
      DATA IU       /3H,1X,3H,2X,3H,3X,3H,4X,3H,5X,3H,6X,3H,7X,3H,8X,
     & 3H,9X,4H,10X,4H,11X,4H,12X,4H,13X,4H,14X,4H,15X,4H,16X,4H,17X,
     &4H,18X,4H,19X,4H,20X,4H,21X,4H,22X,4H,23X,4H,24X,4H,25X,4H,26X,
     &4H,27X,4H,28X,4H,29X,4H,30X,4H,31X,4H,32X,4H,33X,4H,34X,4H,35X,
     &4H,36X,4H,37X,4H,38X,4H,39X,4H,40X,4H,41X,4H,42X,4H,43X,4H,44X,
     &4H,45X,4H,46X,4H,47X,4H,48X,4H,49X,4H,50X/
C
C
C   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C   +               QUASI DYNAMICAL CORE ALOCATION                    +
C   +    MAXIMA MUST BE EQUAL TO THE DIMENSION OF THE ARRAY NAMED     +
C   +                   "ARRAY" OF COMMON BACH.                       +
C   +                                                                 +
                             MAXIMA=  39995
C   +                                                                 +
C   +     WARNING. MAXIMA MAY BE NOT LESS THAN 1760 ELEMENTS.         +
C   +                                                                 +
C   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- STANDARD OUTPUT ANGLE BETWEEN AXIS IS GAM=90. DEGREES
C     IEXT=0/1 MEANS NORMAL/EXTENDED   PDF-MAP
C
      GAM   = 90.
      IEXT  = 0
C
C---- INDICES FOR STANDARD SELECTION OF A XYZ(DOWN) SECTION
C
      INDEX1= 1
      INDEX2= 2
      INDEX3= 3
C
      MIROR3=-1.
C---- CAUTION  MIROR3 IS REAL VARIABLE. MINUS ONE MEANS Z IS DOWN.
C
C---- READ THE CONTROL CARD.
C
      READ(IN,1)(TITLE(L),L=1,17),IPDFMO,IOVERL,IPDFF,ISECT,IOR,
     &       IX,IXI,IXF,IY,IYI,IYF,IZ,IZI,IZF,MAIN,S2,IPLT,NPNT,LSPC,
     &       EXXAG,IMINI,IMAXI,ISELEC,ICCH,T,KELVIN,PNORM
C
C---- IF ISECT=6 A SPECIAL PLANE SHOULD BE CALCULATED.  READ POINTS
C     DEFINING THE PLANE.
      IF(ISECT.EQ.6) READ(IN,2)MTYP(1),E1,MTYP(2),E2,MTYP(3),E3
C
C---- IF IOVERL=1 READ REGION DEFINE CARD
      IF(IOVERL.GT.0)READ(IN,5)POINT,RADIUS
C
C---- READ ATOM SELECTION SWITCHES.
 6120 READ(IN,3)IPLOT
    1 FORMAT(17A4,/,2I1,1X,5I1,1X,3I1,1X,9I5,/,2I3,1X,3I1,1X,F9.0,4I5,
     &F8.0,A1,F8.0)
    2 FORMAT(A4,2X,3F8.0)
    3 FORMAT(60I1)
    5 FORMAT(6X,4F8.0)
C
C---- SAVE EXXAGERATIONFACTOR
C
      EXXAGE=EXXAG
C
C---- IF IPDFMO=1 THE POTENTIAL ISTEAD OF THE PDF SHOULD BE CALCULATED
C
      IPOTET = 0
      INORM  = 1
      IF(IPDFMO.NE.1)GOTO 4
      IPOTET = 1
      IF(KELVIN.NE.KLVIN) T = T + 273.16
      IF(PNORM.LT.1.E-4) INORM = 0
C
C---- IF ISECT=6 SPECIAL PLANE SHOULD BE CALCULATED.
C
    4 IPLANE = 0
      IF(ISECT.NE.6) GOTO 128
C---- SET PARAMETERS FOR SPECIAL PLANE TO SENSEFUL VALUES.
C     INITIALIZE VALUES.
      IPLANE = 1
      ISECT  = 0
      ISELEC= 90
      ITYP1  = 0
      IOR    = 1
      IZI    = 0
      IZF    = 0
      CELL(3)= 0.
      XORG   = 0.
      YORG   = 0.
      ZORG   = 0.
      JNDEX  = 0
      IERR   = 0
C
C---- IF ICCH=0 INCLUDE C(IJK)*C(PQR)*H(IJKPQR) IN CALCULATION OF
C     AN EDGEWORTH MAP OF FOURTH ORDER.
C     IF ICCH=1  DO NOT INCLUDE THIS EQUATION.
C     IF ICCH=2  DO ONLY INCLUDE THIS EQUATION.
C
  128 ICCH1=0
      IF(ICCH.EQ.2) ICCH1=1
      IF(ICCH.EQ.2) ICCH =0
C
C---- SPECIAL INPUT UNIT READ IN ?
C
      IF(MAIN)129,130,129
  129 ISC1 = MAIN
C
C---- READ BINARY OUTPUT UNIT 'MAIN' OF THE PROGRAM REFINE.
C
  130 REWIND ISC1
       READ  (ISC1)
     & LABEL,AG,BG,CG,WINKEL,VOL,G,RECELL,EGGY,JCELL,((CELLP(I,J),
     & I=1,3),J=1,JCELL),ICENT,NSYM,(((RMAT(I,J,K),I=1,3),TRANS(J,K),
     & J=1,3),K=1,NSYM),MODELL,NATOM,((TAG(J,I),J=1,2),ISOT(I),OCCA(I),
     & OCCUP(I),(XYZ(J,I),J=1,3),(BETA(J,I),J=1,6),ALF(I),(CR(J,I),
     & J=1,10),(DR(J,I),J=1,15),I=1,NATOM),
     & IHIGH,((ER(J,I),J=1,21),(FR(J,I),J=1,28),I=1,IHIGH)
C
C---- PRINT COVER OF THE PROGRAM
C
      IF(MARK.NE.0) WRITE(IOUT,1112)
 1112 FORMAT(1H1,6HMULPDF/1X,6(1H-)//)
C
      IF(MARK.NE.0) GOTO 1113
      CALL SPACE(1,9,33,IOUT,NPAGE)
      WRITE(IOUT,1111)LINE
 1111 FORMAT( 28X,42H P R O M E T H E U S  HAS BEEN CALLED FOR ,
     &    50HCALCULATION OF A JOINT PROBABILITY DENSITY MAP       //
     &40X,50H        BY  ROLF BACHMANN                            ///
     &40X,51H PROGRAMM FOR CALCULATING JOINT PROBABILITY DENSITY  /
     &40X,51H MAPS OR THE CORREPONDING POTENTIAL.                 /
     &40X,51H INFORMATIONS  ABOUT  THIS  PROGRAMME ARE AVAILABLE  /
     &40X, 7H FROM  ,11A4)
      WRITE(IOUT,240)LABEL
  240 FORMAT(6(/),39X,41H FILE-LABEL OF THE LOGICAL UNIT MAIN =   ,
     &3A4,10(/),35X,11HSUBSTANCE =,13X,13HTEMPERATURE =,13X,9HSPECIAL =)
      CALL SPACE(2,9,33,IOUT,NPAGE)
C
C---- IS FOR THE USED STRUCTURE FACTOR EQUATION A PDF PROGRAMMED?
C
 1113 IF (MODELL.EQ.3) GOTO 912
C
C---- SAVE LENGTH OF CELL FOR OUTPUT
C
      CELLA=AG
      CELLB=BG
      CELLC=CG
C
C---- TRANSFORM LATTICE PARAMETERS IN CORRESPONDENCE TO THE SELECTED
C     SECTION.
C
      CALL ARB2(ISECT,CELL,ALFA,BET,WINKEL(3),AG,BG,CG,JACHS)
C
C---- SAVE GRID SELECTION FOR OUTPUT.
C
      MX  = IX
      MXI = IXI
      MXF = IXF
      MY  = IY
      MYI = IYI
      MYF = IYF
      MZ  = IZ
      MZI = IZI
      MZF = IZF
C
C---- TRANSFORM INPUT PARAMETERS IN CORRESPONDENCE TO SELEC. SECTION.
C
      CALL ACHSE2(ISECT,IX,IXI,IXF,IY,IYI,IYF,IZ,IZI,IZF)
C
C---- EXTENDED OR NORMAL MAP TO BE CALCULATED?
C
      IPDF=IPDFF(6)
      IF(IPDF.EQ.0) GOTO 241
C
C---- EXTENDED REQUIRED. IS IT AN EDGEWORTH MAP?
C
      IF(MODELL.NE.1) GOTO 908
C
C---- YES IT IS. READ FILE CONTAINING HARMONIC PARAMETERS.
C
      REWIND IHARMO
      READ  (IHARMO) ((XH(I,J),I=1,3),(BH(L,J),L=1,6),J=1,NATOM)
      IEXT = 1
C
C---- IS FIFTH AND/OR SIXTH ORDER CUMULANT COEF. DESIRED BUT NOT
C     AVAILABLE?
C
  241 IF(MODELL.EQ.2) GOTO 242
      IF(IPDFF(4)+IPDFF(5)) 242,242,917
C
C---- PREPARE PARAMETERS FOR POINTARRAY OUTPUT, IF DESIRED.
C
  242 IF (NPNT.EQ.0) CALL SHERE2
C
C---- PREPARE FILE S2, IF DATAS SHOULD SAVED FOR LATER PLOTTING.
C     IN CASE OF SPECIAL PLANE RECORD WILL BEEN WRITTEN LATER.
C
      IF(IPLT.EQ.0 .OR. IPLANE.EQ.1) GOTO 101
      REWIND S2
      WRITE(S2)LABEL,TITLE,CELL,JACHS
C
C---- PRINT LABEL,TITLE AND STARTING TIME.
C
  101 IF(MARK.NE.0) GOTO 1114
      WRITE(IOUT,50)(TITLE(L),L=1,17),LABEL
   50 FORMAT(1H1,25HTITLE OF THE THIS PROGRAM//,1X,25(1H-)/1X,17A4//
     &  35H0TITLE OF THE LEAST-SQUARES-PROGRAM//1X,34(1H-)/1X,3A4//)
      WRITE(IOUT,43)
   43 FORMAT(14H0STARTING TIME/1X,13(1H-)//)
C
C---- PRINT PARAMETERS READ IN.
C
      WRITE(IOUT,41)
   41  FORMAT(17H0INPUT-PARAMETERS/1X,16(1H-)//)
C
C---- WHICH CUMULANTS SHOULD BE INCLUDED?
C
 1114 II=1
      DO 4111 I = 1,5
      IAUSG(I ) = JNOT
      IF(IPDFF(I).EQ.0) GO TO 4111
      IAUSG(II) = JCUM(I)
      II = II+1
 4111 CONTINUE
C
C---- IS AT LEAST ONE CUMULANT SELECTED?
C
      II = II-1
      IF(II.EQ.0) GOTO 612
C
C---- YES IT IS. ASSIGN TEXT CORRESPONDING TO IPUT PARAMETERS.
C
C---- SECTION TO BE SAVED FOR LATER PLOTTING?
  414 IDATA(1) = IDAT(IPLT+1)
C---- POINT ARRAY TO BE PRINTED?
      IDATA(2) = IDAT(NPNT+2)
      IF(NPNT.NE.0) IDATA(2) = IDAT(NPNT)
C---- DOUBLE OR SINGLE SPACED OUTPUT?
      IDATA(3) = IDAT(LSPC+3)
      IDATA(4) = IDAT(5)
C---- WHAT KIND OF STRUCTURE FACTOR EQUATION HAD BBEN USED?
      DO 51 I=1,5
   51 IDATA(I+4)=ISER((MODELL-1)*5+I)
      DO 6010 I=1,3
      DXZ(I)=0.
 6010 DXY(I)=0.
C
C---- FOR OVERLAPPING PDFS CALCULATE DXY
      IF(IOVERL)6040,6040,6020
 6020 DO 6030 I=1,3
      DXZ(I)=POINT(I)-RADIUS*RECELL(I)
 6030 DXY(I)=POINT(I)+RADIUS*RECELL(I)
 6040 NUM=1
      IF(ICENT.EQ.0)NUM=2
C
C---- IF SPECIAL PLANE SELECTED, CALCULATE PARAMETERS OF PLANE.
C
      IF(IPLANE.EQ.0) GOTO 511
       CALL PLANE        (E1,E2,E3,MX,MY,MXI,MXF,MYI,MYF,ITYP1,
     & G,XORG,YORG,ZORG,CELLA,CELLB,IERR)
C
C---- WRITE FIRST RECORD FOR SPECIAL PLANE ON PLOTTING FILE, SAVE
C     ORIGIN, AND VECTORS SPANNING THE PLANE AA, AB
C
      DO 6050 I=1,3
      VECTO1(I)=AA(I)
 6050 VECTO2(I)=AB(I)
      ORI(1)=XORG
      ORI(2)=YORG
      ORI(3)=ZORG
C
      IF(IPLT.EQ.0) GOTO 511
      ZERO = 0.
      ANGLE = 90.
      REWIND S2
      WRITE(S2)LABEL,TITLE,CELLA,CELLB,ZERO,ZERO,ZERO,ANGLE,JACHS
C
C---- HOW MANY ANGSTOEM PER GRID IN EACH DIRECTION.
C
  511 IF(MX.EQ.0) MX = 1
      SCX=CELLA/FLOAT(MX)
      IF(MY.EQ.0) MY = 1
      SCY=CELLB/FLOAT(MY)
      IF(MZ.EQ.0) MZ = 1
      SCZ=CELLC/FLOAT(MZ)
      IF(IPLANE.EQ.1) MZ=0
C
C---- PRINT IT NOW.
C
 512  WRITE(IOUT,52) (IDATA(4+I),I=1,5),IDAT(1 +IEXT),IDAT(IPOTET+1),
     & ISEC(ISECT+1),(IDATA(I),I=1,4), GAM, EXXAG, IMINI, IMAXI,IDAT(
     & IPOTET+1),IDAT(IPLANE+1),MXI,MXF,MX,IORIGN(IOR+1),SCX,MYI, MYF,MY
     & ,SCY,MZI,MZF,MZ,SCZ
C
   52 FORMAT           (17H0SERIES-EXPANSION,11X,8HEXTENDED,12X,9HPOTENT
     &IAL,12X,7HSECTION,13X,9HPLOT-FILE,15X,11HPOINT-ARRAY,//,1X,5A4,10X
     &,A4,16X,A4,16X,A4,17X,A4,20X,A4//
     &11H0LINE-SPACE,17X,12HOUTPUT-ANGLE, 8X,12HEXXAGERATION, 9X,16HOMIT
     &TED - POINTS,4X,11HTEMPERATURE,13X,13HSPECIAL PLANE// 3X,2A4,18X,
     &F8.2,12X,F10.3, 9X,I4,5H TILL,I5,10X,A4,21X,A4//
     &                      13H0GRID-SPACING,4X,3H>>>,8X,4HAXIS,16X,4HFR
     &OM,12X,4HTILL,12X,4HUNIT,12X,6HORIGIN,10X,15HANGSTROEMS/GRID//28X,
     &6HX-AXIS,9X,I9,12X,I4,12X,I4,13X,A4,11X,F9.4/28X,6HY-AXIS,9X,I9,12
     &X,I4,12X,I4,28X,F9.4,/,28X,6HZ-AXIS,9X,I9,12X,I4,12X,I4,28X,F9.4//
     &//)
C
      WRITE(IOUT,525)IAUSG
 525  FORMAT(32H0INCLUDED CUMULANTS ARE OF RANK ,15X,5(A7,4X)///)
C
C---- IN CASE OF SPECIAL PLANE OUTPUT WILL BE DIFFERENT FROM NORM. PLANE
C
      IF(IPLANE) 5252,5251,5252
C
C---- NORMAL PLANE.
 5251 WRITE(IOUT,53)
      GOTO 5254
C---- SPECIAL PLANE.
 5252 WRITE(IOUT,531)
      JATOM=0
C---- MORE THAN ONE ATOM SELECTED?
 5254 DO 5253 I = 1,NATOM
 5253 IF(IPLOT(I).NE.0) JATOM=JATOM+1
      IWRITE=0
      IF(JATOM.EQ.1) IWRITE = 1
C
   53 FORMAT(30H0PDF-CALCULATION FOR THE ATOMS,3X,3H>>>,4X,5HLABEL,15X,
     &8HPOSITION,20X,16HGRID-COORDINATES, 8X,13HT-FACTOR TYPE//)
  531 FORMAT(30H0PDF-CALCULATION FOR THE ATOMS,3X,3H>>>,4X,5HLABEL,15X,
     &8HPOSITION,12X,23HXGRID  YGRID   DISTANCE, 7X,13HT-FACTOR TYPE//)
C
      DO 54 I=1,NATOM
C
C---- ARE THERE ATOMS BEEN SELECTED?
C
      IF(IPLOT(I).EQ.0)GOTO 54
C
      IF(IPLANE) 5256,5255,5256
C
C---- NORMAL PLANE
C
 5255 F1=FLOAT(IOR)
C
C---- PRINT SELECTED ATOMS.
C
      IF(IEXT.EQ.1)WRITE(IOUT,55)(TAG(J,I),J=1,2),(XH(J,I),J=1,3),XH(1
     &,I)*IX*F1,XH(2,I)*IY*F1,XH(3,I)*IZ*F1,(ITYPE(ISOT(I)*2+L),L=1,2)
      IF(IEXT.EQ.0)
     & WRITE(IOUT,55)(TAG(J,I),J=1,2),(XYZ(J,I),J=1,3),XYZ(1,I)*IX*F1,
     & XYZ(2,I)*IY*F1,XYZ(3,I)*IZ*F1,(ITYPE(ISOT(I)*2 +L),L=1,2)
      GOTO 54
C
C---- SPECIAL PLANE.
C
 5256 IF(IEXT) 5257,5258,5257
C
C---- EXTENDED MAP. (IF IERR=1 GOTO 9003 TO WRITE ERRORMESSAGE AND EXIT)
 5257 IF(IERR.EQ.1) GOTO 9003
      XHELP(1)=XH(1,I)
      XHELP(2)=XH(2,I)
      XHELP(3)=XH(3,I)
      CALL ATOPLA(E1,E2,E3,XHELP,MX,MY,G,POUT)
      WRITE(IOUT,5259)(TAG(J,I),J=1,2),(XH(J,I),J=1,3),POUT,(ITYPE(
     & ISOT(I)*2+L),L=1,2)
 5259 FORMAT(42X,2A3,9X,3(F5.3,2X),2X,2(F5.1,2X),F6.2,8X,2A4)
      GOTO 54
C
C---- NORMAL MAP (SPECIAL PLANE).
 5258 IF(IERR.EQ.1) GOTO 9003
      XHELP(1)=XYZ(1,I)
      XHELP(2)=XYZ(2,I)
      XHELP(3)=XYZ(3,I)
      CALL ATOPLA(E1,E2,E3,XHELP,MX,MY,G,POUT)
      WRITE(IOUT,5259)(TAG(J,I),J=1,2),(XYZ(J,I),J=1,3),POUT,(ITYPE(
     & ISOT(I)*2+L),L=1,2)
   54 CONTINUE
C
   55 FORMAT(42X,2A3,9X,3(F5.3,2X),8X,3(F5.1,2X), 8X,2A4)
  120 CONTINUE
C
C---- CORRESPONDING TO THE NON ZERO VALUES OF IPDFF CUMULANTS OF
C     ANY RANK ARE INCLUDED.
C     IPDFF(1) = 1 MEANS INCLUSION OF TENOR OF    RANK TWO.
C     IPDFF(2) = 2 MEANS INCLUSION OF TENSOR OF RANK THREE.
C     AND SO ON.
C
      ISKEW   =  1.
      ITHREE  =  1
      IFOUR   =  1
      IFIVE   =  1
      ISIX    =  1
      ICUM1   =  1
      ICUM2   =  1
C
      IF(IPDFF(1).NE.0) GOTO 13
C---- DO NOT INCLUDE THE SECOND RANK CUMULANT.
      ISKEW   = 0.
   13 IF(IPDFF(2).NE.0) GOTO 14
C---- DO NOT INCLUDE THE THIRD RANK TENSOR.
      ICUM1   = 0
      ITHREE  = 0
   14 IF(IPDFF(3).NE.0) GOTO 15
C---- DO NOT INCLUDE THE FOURTH RANK TENSOR.
      ICUM2   = 0
      IFOUR   = 0
   15 IF(IPDFF(4).NE.0) GOTO 16
C---- DO NOT INCLUDE THE FIFTH RANK TENSOR.
      IFIVE   = 0
   16 IF(IPDFF(5).NE.0) GOTO 17
      ISIX    = 0
   17 CONTINUE
C
C---- IN CASE OF POTENTIAL CALCULATION A SELECTION OF CUMULANTS
C     WITHOUT  SECOND ORDER IS MEANINGLESS.
C
      IF(IPOTET.EQ.0 .OR. ISKEW .GT. 0.) GOTO 18
      ILINE=12
      WRITE(IOUT,923)
      ISKEW=1.
C
C---- CALCULATE GRID SPACING.
C
  18  IF(IPLANE)181,181,182
 181  XX=1./FLOAT(IX)
      YY=1./FLOAT(IY)
      ZZ=1./FLOAT(IZ)
 182  IXA=IXF-IXI+1
      IYA=IYF-IYI+1
      IZA=IZF-IZI+1
C
C---- SHOULD THE OUTPUT ARRAY SINGLE OR DOUBLE SPACED?
C
      LSPCH=LSPC
      IF(LSPC.NE.0) GOTO 2222
      LSPC=ISPC
      GOTO 3333
 2222 LSPC=IBNK
 3333 CONTINUE
C
C---- CALCULATION OF NECESSARY AND AVAILABLE CORE ALLOCATIONS.
C
      ICORE=IXA*IYA
      IF(MARK.EQ.0 .OR. ICORE.GT.MAXIMA) WRITE(IOUT,4444)ICORE,MAXIMA
 4444 FORMAT(17H0REQUIRED STORAGE  ,/,1X,16(1H-)//,1X,   43HUSED ELEMENT
     &S OF THE ARRAY NAMED "ARRAY"    ,I6,1H.,15X,9HAVAILABLE,I6,1H.)
      IF(ICORE.GT.MAXIMA) GOTO 910
      ILINE=49+NATOM+ILINE
C
C---- WARNING IN CASE OF EDGEWORTH CALCULATIONS.
C
      IF(ILINE.LT.58 .AND. 58 .LT. NPAGE) GO TO 9001
      ILINE=1
      IF(MARK.EQ.0) WRITE(IOUT,9002)
 9002 FORMAT(1H1)
 9001 IF(MODELL.EQ.1 .AND. MARK.EQ.0) WRITE(IOUT,19)
   19 FORMAT(//18H0IMPORTANT NOTICE    /1X,16(1H-)//
     &61H0THE EDGEWORTH-SERIES EXPANSION USED IN THIS PROGRAM IS A BAD /
     &61H0BUT THE ONLY KNOWN APPROXIMATION FOR THE FOURIER - TRANSFORM /
     &61H0OF THE TEMPERATUREFACTOR. (MODEL NUMBER 1)                   /
     &61H0BE CAREFUL IN THE INTERPRETATION OF THE SKEW-MAP. THE EDGE - /
     &61H0WORTH-SERIES IS IN THIS CASE   N O T  DIFFERENT TO THE GRAM- /
     &27H0CHARLIER-SERIES EXPANSION. )
C
C---- WRITE INFO. ABOUT SPECIAL PLANE IF DESIRED.
C
 9003 IF(IPLANE.NE.0) CALL SRBPLA(E1,E2,E3, XORG,YORG,ZORG,
     &IOUT,IERR,ITYP1,POUT,MX,MY,IWRITE,MARK)
C
C---- WRITE LIST OF TENSOR-ELEMENTS OF EACH RANK.
C
      JUNK=0
C
      DO 300 I=1,NATOM
      IF(IPLOT(I).LE.0) GOTO 300
      JUNK=1
C
C---- IN CASE OF ISOTROPIC T-FACTOR CHANGE TO ANISOTROPIC FORM.
C
      IF(ISOT(I).NE.0) GOTO 319
      TEMP=BETA(1,I)
      BETA(6,I)=0.25*RECELL(2)*RECELL(3)*RECELL(4)*TEMP
      BETA(5,I)=0.25*RECELL(1)*RECELL(3)*RECELL(5)*TEMP
      BETA(4,I)=0.25*RECELL(1)*RECELL(2)*RECELL(6)*TEMP
      BETA(3,I)=0.25*RECELL(3)**2*TEMP
      BETA(2,I)=0.25*RECELL(2)**2*TEMP
      BETA(1,I)=0.25*RECELL(1)**2*TEMP
C
  319 IF(MARK.NE.0) GOTO 300
      IF(MODELL.NE.1) GOTO 500
C
C---- CALCULATION OF AN EDGEWORTH SERIES EXPANSION.
C     (THE EXISTENCE OF TWO OUTPUT PARTS IS HISTORICALLY)
C
       WRITE(IOUT,401)
C
       DO 310 JK=1,LOOP(ISOT(I)+1)
          DO 320 JL=1,8
 320      IOUTP(JL)=IBNK
       IF(JK.GT.1)GOTO 330
       OUTP(1)=TAG(1,I)
       OUTP(2)=TAG(2,I)
 330   IF(JK.GT.3) GOTO 340
       IF(IEXT.EQ.1) IOUTP(3)=IPRI(JK)
                     IOUTP(4)=IPRI(JK)
 340   IF(JK.GT.6) GOTO 350
       IF(IEXT.EQ.1) IOUTP(5)=IPRI(3+JK)
                     IOUTP(6)=IPRI(3+JK)
 350   IF(JK.GT.10) GOTO 360
                     IOUTP(7)=IPRI(9+JK)
 360   IF(ISOT(I).LT.3) GOTO 370
                     IOUTP(8)=IPRI(19+JK)
 370   IF(JK.GT.3) GOTO 380
       IF(IEXT.EQ.1)WRITE(IOUT,403)IOUTP(3),XH(JK,I),IOUTP(5),BH(JK,I)
       IF(IEXT.EQ.0)WRITE(IOUT,412)
       WRITE(IOUT,404)(OUTP(L),L=1,2),IOUTP(4),XYZ(JK,I),IOUTP(6),
     & BETA(JK,I),IOUTP(7),CR(JK,I)
       IF(ISOT(I).LT.3) GOTO 380
       WRITE(IOUT,405)IOUTP(8),DR(JK,I)
       GOTO 310
 380   IF(JK.GT.6)GOTO 390
       IF(IEXT.EQ.1) WRITE(IOUT,406)IOUTP(5),BH(JK,I)
       IF(IEXT.EQ.0) WRITE(IOUT,412)
       WRITE(IOUT,407)IOUTP(6),BETA(JK,I),IOUTP(7),CR(JK,I)
       IF(ISOT(I).LT.3) GOTO 310
       WRITE(IOUT,405) IOUTP(8),DR(JK,I)
       GOTO 310
 390   IF(JK.GT.10) GOTO 400
       WRITE(IOUT,408) IOUTP(7),CR(JK,I)
       IF(ISOT(I).LT.3) GOTO 310
       WRITE(IOUT,405) IOUTP(8),DR(JK,I)
       GOTO 310
 400   IF(ISOT(I).LT.3) GOTO 310
       WRITE(IOUT,409) IOUTP(8),DR(JK,I)
  310  CONTINUE
       GOTO 300
C
C----  OUTPUT FOR GRAM CHARLIER EXPANSION AND ALPHA FORM.(GC)
C
 500   CONTINUE
C
C----  PRINT HEADING.
C
       IF(MODELL.EQ.2) WRITE(IOUT,600)
       IF(MODELL.EQ.4) WRITE(IOUT,608)
C
       DO 510 JK=1,LOOP(ISOT(I)+1)
C
          WRITE(IOUT,412)
          IF(JK.GT.21) GOTO 585
          IF(JK.GT.15) GOTO 584
          IF(JK.GT.10) GOTO 583
          IF(JK.GT. 6) GOTO 582
          IF(JK.GT. 3) GOTO 581
          IF(JK.GT. 1) GOTO 580
C
C---- PRINT LABEL
C
          IF(MODELL.EQ.2) WRITE(IOUT,601)TAG(1,I),TAG(2,I)
          IF(MODELL.EQ.4) WRITE(IOUT,609)TAG(1,I),TAG(2,I),ALF(I)
C
C---- PRINT X-COORDINATES.
C
  580     WRITE(IOUT,602) IPRI(JK),XYZ(JK,I)
C
C---- PRINT B-TENSOR, C-TENSOR, D-TENSOR AND SO ON.
C
  581     WRITE(IOUT,603) IPRI(JK+ 3),BETA(JK,I)*100.
  582 IF(ISOT(I).GT.1)
     &    WRITE(IOUT,604) IPRI(JK+ 9),  CR(JK,I)
  583 IF(ISOT(I).GT.2)
     &    WRITE(IOUT,605) IPRI(JK+19),  DR(JK,I)
  584 IF(ISOT(I).GT.3)
     &    WRITE(IOUT,606) IFUENF (JK),  ER(JK,I)
  585 IF(ISOT(I).GT.4)
     &    WRITE(IOUT,607) ISECHS (JK),  FR(JK,I)
C
  510  CONTINUE
C
 300  CONTINUE
C
C---- FORMAT STATEMENTS FOR PARAMETER OUTPUT LIST.
C
 401  FORMAT(1H1,5HLABEL,9X,11HX(HARMONIC),10X,9HX -TENSOR,10X,
     & 11HB(HARMONIC),10X,9HB -TENSOR, 6X,15HC-TENSOR(*1000),4X,
     & 16HD-TENSOR(*10**4) //)
 403  FORMAT(1H0,13X,A2,F10.5,27X,A4,F9.5)
 404  FORMAT(1H+,2A4,26X,A2,F9.5,29X,A4,F7.5,6X,A4,1H=,F9.5)
 405  FORMAT(1H+,108X,1HD,A4,1H=,F9.5)
 406  FORMAT(1H0,52X,A4,F9.5)
 407  FORMAT(1H+,74X,A4,F7.5,6X,A4,1H=,F9.5)
 408  FORMAT(1H0,91X,A4,1H=,F9.5)
 409  FORMAT(1H0,108X,1HD,A4,1H=,F9.5)
 412  FORMAT(1H0)
C
 600  FORMAT(1H1,5HLABEL,     15X,10HX - COORD.,10X,10HB - TENSOR,10X,
     &10HC - TENSOR,10X,10HD - TENSOR,10X,10HE - TENSOR,10X,7HF - TEN,
     &3HSOR,   /,42X, 8H(*10**2)  ,12X, 8H(*10**3)  ,12X, 8H(*10**4)  ,
     &           12X, 8H(*10**5)  ,12X, 8H(*10**6)  ,/)
 601  FORMAT(1H+,2A4)
 602  FORMAT(1H+,20X,A2,F8.3)
 603  FORMAT(1H+,    40X    ,A4,F6.3)
 604  FORMAT(1H+,          60X      ,A4,1H=,F6.3)
 605  FORMAT(1H+,               79X             ,1HD,A4,1H=,F6.3)
 606  FORMAT(1H+,                   98X         ,A7,F6.3        )
 607  FORMAT(1H+,                         117X  ,A7,1H=,F6.3    )
 608  FORMAT(1H1,5HLABEL,     15X,10HX - COORD.,10X,10HB - TENSOR,10X,
     &10HC - TENSOR,10X,10HD - TENSOR,10X,10H  ALPHA   /
     & 42X, 8H(*10**2)  ,12X, 8H(*10**3)  ,12X, 8H(*10**4)/)
 609  FORMAT(1H+,2A4,95X,F6.3)
C
C---- ERRORMESSAGE, IN TWO CASES.  FIRST= NO ATOM FOR PDF-CALCULATION
C                                         HAD BEEN SELECTED.
C                                  SECOND = A PDF TYPE HAVE BEEN SELEC-
C                                         TED, WHICH IS NOT AVAILABLE.
C
      IF(JUNK.EQ.1) GOTO 410
      WRITE(IOUT,411)
  411 FORMAT(////13H0ERRORMESSAGE/1X,12(1H-)//
     &77H0ONLY ATOMS WITH INCONSISTENT TEMPERATURE FACTORS OR NO ATOM AT
     & ALL SELECTED. /26H I'M SORRY, I 'VE TO STOP.)
      CALL EXIT
C
 410  JATO=0
      IPRINT=0
      IF(IOVERL.GT.0)WRITE(IOUT,6002)
 6002 FORMAT(1H1,34H  THE FOLLOWING ATOMS ARE INCLUDED/1X)
      IF(IOVERL-1)6080,6080,6060
 6060 DO 6070 I=1,MAXIMA
 6070 ARRAY(I)=0.
C
C---- LOOP THROUGH SELECTED ATOMS.
C
 6080 DO 2400 IATOM =1,NATOM+1
C     IF OVERLAPPING PDFS PRINT AFTER ALL PDFS ARE INCLUDED
      IF(JATO.EQ.JATOM .AND. IOVERL.EQ.2)GOTO 6090
      IF(IPLOT(IATOM).LE.0) GOTO 2400
 6090 JATO=JATO+1
      IF(IATOM.GT.NATOM) GOTO 6220
      IHOLD=IEXT
      IF(ISOT(IATOM).EQ.0) IEXT=0
C
C---- CHECK FOR ZERO CUMULANT PRODUCTS.
C
 915  NO3=0
      NO4=0
      NO5=0
      NO6=0
C
      IAWAY=0
C
      IF(ISOT(IATOM).EQ.1) GOTO 420
C
C---- IS THE THIRD CUMULANT PRODUCT NECESSARY FOR DESIRED PDF-MAP?
C     IN CASE OF AN EDGEWORTH SERIES  FOURTH ORDER EQUATION  NEEDS
C     TENSOR OF THIRD ORDER.
C
      IF(ITHREE.EQ.0 .AND. MODELL.NE.1) GOTO 4201
C
C----  AND IS THIRD ORDER AVAILABLE?
C
      IF(ISOT(IATOM).LT.2) GOTO 420
C
C---- YES! IS IT A NULL PRODUCT?
C
      NO3=0
      SH=0.0
      DO 421 IE=1,10
  421 SH=SH+ABS(CR(IE,IATOM))
      IF(SH.LT.1.E-11) GOTO 4200
C---- NO, WHICH ELEMENTS ARE EXACTLY ZERO?
      NO3=1
      DO 4199 IE=1,10
      JTHREE(IE)=0
 4199 IF(ABS(CR(IE,IATOM)).GT.1.E-9) JTHREE(IE)=1
C
C---- ONLY IN CASE OF EDGEWORTH SERIES.
C     SHOULD THIRD ORDER BE OMITTED? (FOURTH ORDER NEEDS C(IJK))
C
 4200 IF(MODELL.NE.1) GOTO 4201
      IF(NO3.EQ.1 .AND. ITHREE.EQ.0) IAWAY=1
C
C---- HAS THE ATOM A FOURTH ORDER CUMULANT PRODUCT?
C
 4201 IF(IFOUR.EQ.0) GOTO 4202
C
C---- IS FOURTH CUMULANT PRODUCT AVAILABLE.
C
      IF(ISOT(IATOM).LT.3) GOTO 420
C
C---- IS THE FOURTH RANK TENSOR PRODUCT A NULL PRODUCT?
C
      NO4=0
      SH=0.0
      DO 422 IE=1,15
  422 SH=SH+ABS(DR(IE,IATOM))
      IF(SH.LT.1.E-11) GOTO 4202
      NO4=1
C---- NO, WHICH ELEMENTS ARE EXACTLY ZERO?
      DO 4220 IE=1,15
      JFOUR(IE)=0
 4220 IF(ABS(DR(IE,IATOM)).GT.1.E-10)JFOUR(IE)=1
C
C---- IS THE TEMPERATURE FACTOR OF AT LEAST FIFTH ORDER?
C
 4202 IF(ISOT(IATOM).EQ.3) GOTO 420
C
C---- IS FIFTH ORDER CUMULANT PRODUCT A NULL PRODUCT?
C
      IF(IFIVE.EQ.0) GOTO 4203
      NO5=0
      SH=0.0
      DO 423 IE=1,21
  423 SH=SH+ABS(ER(IE,IATOM))
      IF(SH.LT.1.E-7) GOTO 4203
      NO5=1
C
C---- NOT A NULL PRODUCT. WHICH ELEMENTS OF THE TENSOR OF FIFTH RANK
C     ARE EXACTLY ZERO.
C
      DO 4631 IE=1,21
      JFIVE(IE)=0
 4631 IF(ABS(ER(IE,IATOM)).GT.1.E-7) JFIVE(IE)=1
C
C---- IS THE TEMPERATURE FACTOR OF SIXTH ORDER?
C
 4203 IF(ISOT(IATOM).EQ.4) GOTO 420
C
C---- IS SIXTH ORDER CUMULANT PRODUCT A NULL PRODUCT?
C
      IF(ISIX.EQ.0) GOTO 420
      NO6=0
      SH=0.0
      DO 4232 IE=1,28
 4232 SH=SH+ABS(FR(IE,IATOM))
      IF(SH.LT.1.E-7) GOTO 420
      NO6=1
C
C---- NOT A NULL PRODUCT. WHICH ELEMENTS OF THE TENSOR OF SIXTH RANK
C     ARE EXACTLY ZERO.
C
      DO 4233 IE=1,28
      JSIX(IE)=0
 4233 IF(ABS(FR(IE,IATOM)).GT.1.E-7) JSIX(IE)=1
C
C---- CALCULATE FLAG FOR JUMP OVER ANHARMONIC PART.
C
 420  ITOT=NO3+NO4+NO5+NO6
C
C---- REMEMBER. IF YOU CALCULATE ONLY SECOND ORDER PDF, EXTENSION
C     IS MEANINGLESS FOR COMPUTATION.
C---- CLEAR ORIGIN TRANSLATION VECTOR.
C
      DO 989 I=1,3
 989  R1(I)=0.0
C
C---- SHUFFEL IATOM TO II TO PREVENT COMPILER WARNINGS.
      II=IATOM
C
C---- IF AN EDGEWORTH MAP TO BE CALCULATED CREATE TRANSFORMATIONS
C     AND PARAMETERS.
C
C---- INITIALIZE FLAG FOR   NO DIFFERENCE BETWEEN NORMAL AND EXTENDED
C     MAP.
C
      IEMAP1=0
      IEMAP2=0
C
C---- NO EXTENSION OR NO ANHARMONICITY?
C
      IF(IEXT.EQ.0 .OR.ITOT.EQ.0 ) GOTO 21
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
CEXTENDED MAP  EXTENDED MAP  EXTENDED MAP  EXTENDED MAP  EXTENDED MAP
C
C---- TRANSFORM TENSOR COMPONENTS CORRESPONDING TO SECTION SELECTION.
C
      IF(ISECT.EQ.0) GOTO 22
      CALL TRANSF(ISECT,INDEX1,INDEX2,INDEX3,MIROR3)
C
C---- DEVIATION OF TRANSLATION VECTOR DUE TO EXTENDED MAP.
C
   22 DO 23 I=1,3
   23 R1(I)=XYZ(I,II)-XH(I,II)
C
C---- CHANGE OF TENSOR OF RANK 2 DUE TO A EXTENDED MAP CALCULATION.
C
      IF(ISOT(II).LT.3 .OR. NO4.EQ.0) GOTO 2411
      DO 24 I=1,6
   24 R2(I)=(BETA(I,II)-BH(I,II))/TWOPI2
C
C---- CALCULATE INVERSE MATRIX OF HARMONIC TEMPERATURE PART.
C
 2411 CALL UMKEHR(BH,II,QDET)
C
C
C---- ARE THERE ANY CHANGES IN THE HARMONIC FACTOR DUE TO  EXTENSION OF
C     MAP.
C
      IF(ICUM1.EQ.0) GOTO 4231
      IEMAP=  1
      SH=ABS(R1(1))+ABS(R1(2))+ABS(R1(3))
      IF(SH.LT.1.E-7) IEMAP1 = 0
C
C---- IS THERE ANY CHANGE ON THE SECOND RANK TENSOR DUE TO EXTENSION OF
C     THE MAP AND IS EXTENDED MAP OF FOURTH ORDER?
C
 4231 IF(ISOT(II).LT.3 .OR. ICUM2.EQ.0  ) GOTO 25
C
      SH=0.0
      IEMAP2=1
      DO 426 I=1,6
  426 SH=SH+ABS(R2(I))
      IF(SH.LT.1.E-7) IEMAP2 = 0
      GOTO 25
C
C END OF FIRST PART OF EXTENDED MAP CALCULATION   END OF FIRST PART OF
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- SAME FOR NORMAL MAP AND GRAM-CHARLIER SERIES EXPANSION -------
C
   21 IF(ISECT.EQ.0) GOTO 26
      CALL TRANSF(ISECT,INDEX1,INDEX2,INDEX3,MIROR3)
C
C---- MATRIX INVERSE OF HARMONIC PART OF TEMPERATURE FACTOR.
C
   26 CALL UMKEHR(BETA,II,QDET)
C
C---- CALCULATE SMALL FORMULAS OFTEN USED IN THE FOLLOWING.
C     (NOT FOR MODEL NUMBER 4 (ALPHA FORMALISM (GC))
C
   25 IF(MODELL.EQ.4) GOTO 251
      CALL PREPAR(MODELL,II,CR)
C
C---- CALCULATE FLAGS FOR JUMPS
C
  251 JUMP1=1
      JUMP2=1
      JUMP3=1
      IF(NO3.EQ.0 .OR. IEMAP1.EQ.0 ) JUMP2=0
      IF(NO4.EQ.0 .OR. JUMP2.EQ.0  ) JUMP1=0
      IF(NO4.EQ.0 .OR. IEMAP1.EQ.0 .AND. IEMAP2.EQ.0 ) JUMP3=0
C---- IN CASE OF AN EXTENDED EDGEWORTH MAP ALL HERMITE POLYNOMS OF 4 TH
C     ORDER CAN BE NECESSARY. THEREFORE CALCULATE THESE.
      IF(JUMP1*JUMP3)100,100,99
   99 DO 102 IE=1,15
  102 JFOUR(IE)=1
  100 CONTINUE
C
C---- ROMAXT SHOULD BE MAXIMUM OF CALCULATED PDF OF FIRST SECTION.
      ROMAXT = - 1000000.
C
C
C---- ADD ATOM TO LIST, IF OVERLAPP CHANGE EXXAG BY OCCUPANCY
C
      IF(IOVERL)6220,6220,6210
 6210 OCUPT=OCCUP(IATOM)
      IF(ABS(OCCA(IATOM)).GT.10E-8) OCUPT=OCCA(IATOM)
      EXXAG=EXXAGE*OCUPT
 6220 LIST=0
C
C---- START LOOP THROUGH SYMMETRY OPERATIONS
C
      DO 6890 ISYM=1,NSYM
        DO 6250 L=1,3
        XP(L)=TRANS(L,ISYM)
        DO 6250 M=1,3
 6250   XP(L)=XP(L)+RMAT(L,M,ISYM)*XYZ(M,IATOM)
C
C---- LOOP FOR CENTER OF SYMMETRY
C
        AINV=1.
        DO 6890 ITY=1,NUM
        GO TO (6280,6260),ITY
 6260   DO 6270 L=1,3
 6270   XP(L)=-XP(L)
C
C---- LOOP THROUGH LATTICE POINTS
C
 6280   DO 6890 KK=1,JCELL
        DO 6290 L=1,3
 6290   XXP(L)=XP(L)+CELLP(L,KK)
C
C----- SET TRANSLATION LIMITS
C
        DO 6300 I=1,3
        NXX(I)=5-IFIX(XXP(I)-DXZ(I))
        NXX(I+3)=5.0+DXY(I)-XXP(I)
        IF(NXX(I)-NXX(I+3))6300,6300,6890
 6300   CONTINUE
        NXU=NXX(4)
        NYU=NXX(5)
        NZU=NXX(6)
C
C---- STEP THROUGH UNIT CELLS
C
        DO 6900 IA=NXL,NXU
        XYP(1)=XXP(1)+FLOAT(IA-5)
        DO 6900 IB=NYL,NYU
        XYP(2)=XXP(2)+FLOAT(IB-5)
        DO 6900 IC=NZL,NZU
        XYP(3)=XXP(3)+FLOAT(IC-5)
C
C---- PRINT ONLY IF OVERLAPPING PDFS AND LAST ATOM INCLUDED
C
        IF(JATO.LE.JATOM)GOTO 6301
        IRINT=1
        GOTO 6440
C
C---- CHECK IF ATOM WITHIN LIMITS
C
 6301   DO 6310 K=1,3
 6310   YP(K)=XYP(K)-POINT(K)
        S=0.
        DO 6330 N=1,3
        XZP=0.
        DO 6320 K=1,3
 6320   XZP=XZP+YP(K)*G(K,N)
 6330   S=S+XZP*YP(N)
        S=SQRT(S)
        IF(RADIUS-S)6900,6340,6340
C
C---- CHECK FOR ATOM DUPLICATION
C
 6340   DO 6360 I=1,LIST
        DO 6350 L=1,3
        IF(ABS(XYP(L)-XPR(L,I))-.0004)6350,6360,6360
 6350   CONTINUE
        GOTO 6900
 6360   CONTINUE
C
C---- ADD ATOM TO LIST AND PRINT
C
        LIST=LIST+1
        DO 6370 I=1,3
 6370   XPR(I,LIST)=XYP(I)
        WRITE(IOUT,6001)TAG(1,II),TAG(2,II),XYP,OCUPT
 6001   FORMAT(1H ,2X,2A4,4H  AT,3F10.4,3X,F10.4)
C
C---- INSTEAD OF TRANSFORMING HIGH RANK TENSORS, THE INVERSE TRANSFOR-
C     MATION  IS  APPLIED TO  SPECIAL PLANE.  FIRST THE INVERSE OF THE
C     ROTATION  UMAT  IS CALCULATED,  THEN APPLIED  TO  THE DIFFERENCE
C     VECTORS  VECTO1, VECTO2 AND ORI-XYP. THE NEW ORIGIN OF THE PLANE
C     IS THEN XYZ(IATOM) + UMAT(ORI-XYP).
C
        DO 6380 I1=1,3
        DO 6380 I2=1,3
        L1=MOD(I1,3)+1
        L2=MOD(I1+1,3)+1
        M1=MOD(I2,3)+1
        M2=MOD(I2+1,3)+1
 6380   UMAT(I2,I1)=RMAT(L1,M1,ISYM)*RMAT(L2,M2,ISYM)-
     &              RMAT(L1,M2,ISYM)*RMAT(L2,M1,ISYM)
        D=(UMAT(1,1)*RMAT(1,1,ISYM)+UMAT(2,1)*RMAT(1,2,ISYM)+
     &     UMAT(3,1)*RMAT(1,3,ISYM))*AINV
        IF(ITY-2)6400,6390,6400
 6390   D=-D
 6400   DO 6410 I1=1,3
        DO 6410 I2=1,3
 6410   UMAT(I1,I2)=UMAT(I1,I2)/D
C
C---- TRANSFORM VECTO1, VECTO2 AND ORI-XPY, XPR AUTOMATICALLY ADDED
C
        DO 6420 I=1,3
 6420   UTRANS(I)=ORI(I)-XYP(I)
        XORG=XYZ(1,IATOM)
        YORG=XYZ(2,IATOM)
        ZORG=XYZ(3,IATOM)
        DO 6430 I=1,3
        AA(I)=VECTO1(1)*UMAT(I,1)+VECTO1(2)*UMAT(I,2)+VECTO1(3)*
     &            UMAT(I,3)
        AB(I)=VECTO2(1)*UMAT(I,1)+VECTO2(2)*UMAT(I,2)+VECTO2(3)*
     &            UMAT(I,3)
        XORG=XORG+UTRANS(I)*UMAT(1,I)
        YORG=YORG+UTRANS(I)*UMAT(2,I)
 6430   ZORG=ZORG+UTRANS(I)*UMAT(3,I)
C
 6440 CONTINUE
C POINT BY POINT CALCULATION OF THE PROBABILITY MAP IN DESIRED SECTIONS.
C
C ========= LOOP OVER SECTIONS =========================================
C
       DO 890  JZSEC=1,IZA
       IF(IRINT.EQ.1)GOTO6820
       ROMIN = 100000.
       ROMAX =-100000.
       IZAEHL= 0
C
C----  IN CASE OF A SPECIAL PLANE CALC. X,Y,Z WILL BE CALC. BY CORD.
       IF(IPLANE)891,891,892
  891  X(INDEX3)=ZZ*FLOAT(JZSEC+IZI-1)
       IF(IOR.NE.0) X(INDEX3)=X(INDEX3)-XYZ(INDEX3,II)-R1(INDEX3)
       X(INDEX3) = MIROR3*X(INDEX3)
  892  CONTINUE
       JNDEX=0
C
C   ========== LOOP OVER VERTICAL AXIS =================================
C
        DO 2200 JYSEC=1,IYA
C
        IF(IPLANE) 2201,2201,2202
 2201   X(INDEX2)=YY*FLOAT(JYSEC+IYI-1)
        IF(IOR.NE.0) X(INDEX2)=X(INDEX2)-XYZ(INDEX2,II)-R1(INDEX2)
 2202   CONTINUE
C
C      ====== LOOP OVER HORIZONTAL AXIS ================================
C
         DO 2100 JXSEC=1,IXA
C
         IF(IPLANE) 2101,2101,2102
 2101    X(INDEX1)=XX*FLOAT(JXSEC+IXI-1)
         IF(IOR.NE.0) X(INDEX1)=X(INDEX1)-XYZ(INDEX1,II)-R1(INDEX1)
         GOTO 2103
C
C----- SPECIAL COORDINATES BY ROUTINE CORD.
C
 2102    CALL CORD(MXI,MXF,MYI,MYF,JNDEX,XORG,YORG,ZORG,X(1),X(2),X(3))
         X(1)=X(1)-XYZ(1,II)
         X(2)=X(2)-XYZ(2,II)
         X(3)=X(3)-XYZ(3,II)
C
C CALCULATE HARMONIC PART OF PDF. IF THIS FACTOR IS ABOUT ZERO NO AN-
C HARMONIC MODIFICATIONS ARE NECESSARY.
C        HARMONIC PART IS     EXP(-0.5*Q(IK)*U(I)*U(K))
C
 2103    EXPO  = Q(1,1)*X(1)**2 + Q(2,2)*X(2)**2 + Q(3,3)*X(3)**2 +
     &  2.*(  Q(1,2)*X(1)*X(2) + Q(1,3)*X(1)*X(3) + Q(2,3)*X(2)*X(3) )
C
         IF(EXPO.LT.84.)GOTO 2553
C
C---- TO LARGE NEGATIVE EXPONENT OF EXP-FUNCTION. SET RESULT TO ZERO.
C
         RO=0.
         GOTO 5000
C
C---- EXPONENTIAL FACTOR IS NOT ZERO.
C
 2553    EXPO = -EXPO*0.5
         RO=EXP(EXPO)
C
C---- ANHARMONICITY TO BE CALCULATED?
C
         IF(ITOT.NE.0) GOTO 2004
C
C---- NO ANHARMONIC PARTS DESIRED.  FINISH ONLY THE HARMONIC RESULT.
C
         RO=QDET*RO
         GOTO 5000
C
C---- ANHARMONIC PART NECESSARY. CLEAR VARIABLES OF CUMULANT PRODUCTS.
C
 2004   CUMEX = 0.0
        CUM3  = 0.0
        CUM4  = 0.0
        CUM5  = 0.0
        CUM6  = 0.0
C
C----  CALCULATE THE PRODUCT     Q(I,K)*X(K)   (EINSTEIN-CONVENTION)
C
        W(1)=Q(1,1)*X(1) + Q(1,2)*X(2) + Q(1,3)*X(3)
        W(2)=Q(2,1)*X(1) + Q(2,2)*X(2) + Q(2,3)*X(3)
        W(3)=Q(3,1)*X(1) + Q(3,2)*X(2) + Q(3,3)*X(3)
C
C
C----  IN CASE OF ALPHA FORMALISM (GC) GOTO LABEL 4000. REMEMBER THAT
C      FOR THIS STRUCTURE FACTOR MODEL NO HERMIT POLYNOMS  ARE NECES-
C      SARY. (OF CORSE THERE WILL BE A SELECTION IN  HERMITE POLYNOMS
C      AND A REST FUNCTION, BUT FOR COMPUTATION IT  SHOULD  BE BETTER
C      NOT TO SEPERATE THE COMPLETE FUNCTION.
C
       IF(MODELL.EQ.4) GOTO 4000
C
C---- CALCULATE HERMITE POLYNOMS OF FOURTH ORDER AND CUMULANT PROD.
C
C     FROM NOW ON ONLY EDGEWORTH OR GRAM-CHARLIER POSSIBLE.
C
                         CALL HERMIT
     &  (W,Q,ITHREE,JTHREE,CR,IFOUR,JFOUR,DR,II,CUM3,CUM4,HJKLM)
C
C---- CUM3 IS THIRD RANK CUMULANT PRODUCT , I.E.  C(IJK)*H(IJK)
C
         IF(IAWAY.EQ.1) CUM3 = 0.
C
C---- EXTENDED MAP TO BE CALCULATED?
C
 2009    IF(IEXT.EQ.0) GOTO 2112
C
C---- YES!
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C SECOND PART OF EXTENDED MAP  SECOND PART OF EXTENDED MAP  SECOND
C
C---- CALCULATE   L1(I) * HERMIT1(I)
C      AT WHICH   L1(I)= X(I) - X.HARMONIC(I)
C
         CUM1=0.0
         IF(JUMP2.EQ.0) GOTO 2069
         DO 2007 I=1,3
 2007    CUM1=CUM1+R1(I)*W(I)
C
C---- FOURTH RANK CUMULANT PRODUCT AVAILABLE?
C
 2069    CUM2 = 0.0
         CUM13= 0.0
         IF(JUMP3.EQ.0)  GOTO 2111
C
C---- YES. CALCULATE 1/2*( L1(J)*L1(K) + L2(JK) ) * HERMIT2(J,K)
C     AT WHICH       L2(J,K)=( B.TENSOR(J,K) - B.HARMONIC(J,K) )/F
C     AND            F = 2.PI**2
C
         DO 2070 ID=1,3
         IDD=ID
C---- IDD JUST TO PREVENT COMPILER WARNINGS.
 2070    CUM2=0.5*(R1(IDD)**2+R2(IDD))*HJK(IDD)+CUM2
         CUM2=CUM2+(R1(1)*R1(2)+R2(4))*HJK(4)
         CUM2=CUM2+(R1(1)*R1(3)+R2(5))*HJK(5)+(R1(2)*R1(3)+R2(6))*
     &   HJK(6)
C
C---- JUMP1=0 MEANS CUM13 HAS TO BE ZERO.
C
         IF(JUMP1.EQ.0)  GOTO 2111
C
C---- CALCULATE THE PRODUCT L1(I)*C(JKL)*H(IJKL) (EINSTEIN CONVENTION)
C

         CUM13=4*(HJKLM(1)*R1(1)*CR(1,II) + HJKLM(2)*R1(2)*CR(2,II) +
     &            HJKLM(3)*R1(3)*CR(3,II))
         CUM13=CUM13 +HJKLM(4)* ( R1(1)*CR(4,II)+CR(1,II)*R1(2) )
         CUM13=CUM13 +HJKLM(5)* ( R1(1)*CR(6,II)+CR(1,II)*R1(2) )
         CUM13=CUM13 +HJKLM(6)* ( R1(1)*CR(5,II)+CR(4,II)*R1(2) )*ZWIDRI
         CUM13=CUM13 +HJKLM(7)* ( R1(1)*CR(10,II)+CR(6,II)*R1(2)+
     &            CR(4,II)*R1(3) )*EINDRI
         CUM13=CUM13 +HJKLM(8)* ( R1(1)*CR(7,II)+CR(6,II)*R1(3) )*ZWIDRI
         CUM13=CUM13 +HJKLM(9)* ( R1(1)*CR(2,II)+CR(5,II)*R1(2) )
         CUM13=CUM13+HJKLM(10)* ( R1(1)*CR(8,II)+CR(10,II)*R1(2)+
     &            CR(5,II)*R1(3) )*EINDRI
         CUM13=CUM13+HJKLM(11)* ( R1(1)*CR(9,II)+CR(10,II)*R1(3)+
     &            CR(7,II)*R1(2) )*EINDRI
         CUM13=CUM13+HJKLM(12)* ( R1(1)*CR(3,II)+CR(7,II)*R1(3) )
         CUM13=CUM13+HJKLM(13)* ( R1(2)*CR(8,II)+CR(2,II)*R1(3) )
         CUM13=CUM13+HJKLM(14)* ( R1(2)*CR(9,II)+CR(8,II)*R1(3) )*ZWIDRI
         CUM13=CUM13+HJKLM(15)* ( R1(2)*CR(3,II)+CR(9,II)*R1(3) )
         CUM13=CUM13*1.E-3
C
C---- CALCULATE CONTRIBUTION OF THE EXTENSION OF EDGEWORTH EXPANSION.
C
 2111    CUMEX= CUM1 + CUM2 + CUM13/TWOPI3
C
C END OF PART OF EXPANSION   END OF PART OF EXPANSION   END OF PART OF
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C SAME FOR NORMAL AND EXTENDED MAPS.
C
C---- CUM4ISTHE FOURTH  CUMULANT PRODUCT.   D(IJKL)*H(IJKL)
C
 2112    CONTINUE
C
 2589 IF(NO5.EQ.0) GOTO 2010
C
C ---- FIFTH RANK CUMULANT PRODUCT IS NOT ZERO. CALCULATE IT. --------
C
         CUM5 = RANK5(ER,JFIVE,II)
C
C ---- SIXTH ORDER CUMULANT PRODUCT IS NOT ZERO? -----------------------
C
 2010  IF(NO6.EQ.0) GOTO 999
C
C----  YES IT IS! CALCULATE IT.
C
       CUM6 = RANK6(FR,JSIX,NO5,II)
C
C---- ACCORDING TO THE STRUCTUR FACTOR MODEL COMPUTE BRANCH.
C
  999 GOTO(1000,2000,3000),MODELL
C
C---- EDGEWORTH-SERIES EXPANSION.-------
C
 1000 CCH=0.0
C
C---- CALCULATE THE PRODUCT  C(I,J,K)*C(Q,P,R)*H(I,J,K,Q,P,R)
C
      IF(NO4.EQ.0 .OR.NO3.EQ.0) GOTO 1001
C
      IF(ICCH .EQ.0) CALL   PRODUK(CCH)
      IF(ICCH1.EQ.1) CUM4 = 0.
C
C---- SUMMATION OF ALL CUMULANTS.
C
 1001 RO=QDET*RO*(ISKEW  + CUMEX  + CUM3/TWOPI3 + CUM4/TWOPI4 +
     &  0.5*CCH/TWOPI6)
C
      GOTO 5000
C
C
C---- GRAM-CHARLIER-SERIES EXPANSION. -----
C
 2000 RO=QDET*RO*(ISKEW +CUM3/6.+CUM4/24.+CUM5/120.+CUM6/720.)
      GOTO 5000
C
C---- MODIF. EDGEWORTH SERIES EXPANSION. -----
C
 3000 GOTO 5000
C
C---- MODIF. GRAM-CHARLIER SERIES EXPANSION.-----
C     NOW BACK TO THE ALPHA FORMALISM (GC)
C
 4000 SFACT = 0.0
                         CALL JOHN
     &(W,Q,ITHREE,JTHREE,CR,IFOUR,JFOUR,DR,ALF(II),II,CUM3,CUM4,
     &                     SFACT)
      RO=QDET*RO*(ISKEW+CUM3/6.+CUM4/24.)/(1.+SFACT)
      GOTO 5000
C
C---- MULTIPLY WITH EXXAGERATION FACTOR.
C
 5000    RO=EXXAG*RO
C
C---- COUNTING OF COMPUTED POINTS AND STORING OF ITS VALUE. IN
C     CASE IF OVERLAP ADD
C
         IZAEHL=IZAEHL+1
         IF(IOVERL-1)6810,6810,6800
 6800    ARRAY(IZAEHL)=ARRAY(IZAEHL)+RO
         GOTO 2100
 6810    ARRAY(IZAEHL)=RO
C
C---- CALCULATE MINIMUM AND MAXIMUM OF THE PROBABILITY FUNCTION.
C
         IF(RO.GT.ROMAX)ROMAX=RO
         IF(RO.LT.ROMIN)ROMIN=RO
C
 2100    CONTINUE
 2200   CONTINUE
C
C---- SAVE MAXIMUM OF PDF OF FIRST SECTION
C
      IF(JZSEC-1) 6820,6820,781
C
 6820 IF(IOVERL-1)777,777,6830
 6830 IF(JATO.LE.JATOM)GOTO 890
      IF(IPRINT.EQ.2)GOTO 2400
      IPRINT=2
      DO 6840 I=1,MAXIMA
      IF(ARRAY(I).GT.ROMAX)ROMAX=ARRAY(I)
 6840 IF(ARRAY(I).LT.ROMIN)ROMIN=ARRAY(I)
C
  777 IF(ROMAX.GT.0.) GOTO 780
      IPOTET = 0
      INORM  = 1
      GOTO 781
  780 ROMAXT = ROMAX
      IF(INORM) 781,781,779
  779 ROMAXT = ABS(PNORM)
C---- PRINT SECTION AS A POINT-ARRAY, IF NPNT.NE.0 .
C
  781 IF(NPNT.NE.0) GOTO 881
C
C---- DIVIDE SECTION IN STRIPS OF A MAXIMUM OF 30 COLUMNS.
C
      DO 880 ISPALT=1,IXA,30
      IXX=ISPALT+IXI-1
      NXA=MIN0(30,IXF-IXX+1)
      NX=0
C
C---- PRINT HEADING OF SECTION.
C
            DO 782 I=1,NXA,2
            NX=NX+1
  782       FX(NX)=I+IXX-1
      J=JZSEC+IZI-1
      IF(IOVERL.GT.0) GOTO 783
      IF(IPOTET.EQ.0)
     &WRITE(IOUT,8)(TITLE(L),L=1,17),J,IZ,(TAG(J,II),J=1,2),ROMIN,ROMAX,
     & (FX(I),I=1,NX)
    8 FORMAT(1H1,17A4,29X,7HSECTION,I4,1H/,I4//38X,41H PROBABILITY-MAP O
     &F THE ATOM LABELED       ,2A4,//32X,41H FLUCTUATION OF THE PDF IN
     &THIS SECTION       ,F8.0,4X,3H-  ,F8.0//F10.0,14F8.0,//)
      IF(IPOTET.EQ.1)
     &WRITE(IOUT,9)(TITLE(L),L=1,17),J,IZ,(TAG(J,II),J=1,2),T,ROMIN,
     & ROMAX,(FX(I),I=1,NX)
    9 FORMAT(1H1,17A4,29X,7HSECTION,I4,1H/,I4//38X,37H POTENTIAL - MAP O
     &F THE ATOM LABELED ,4X,2A4,//38X,28H MEASURING  TEMPERATURE  WAS,
     &F8.0,2X,6HKELVIN //38X,35H OUTPUT SHOWS THE POTENTIAL IN MEV.
     &///32X,43H FLUCTUATION OF THE PDF IN THIS SECTION WAS
     & ,F8.0,4X,3H-  ,F8.0//F10.0,14F8.0,//)
      GOTO 784
  783 IF(IPOTET.EQ.0)WRITE(IOUT,6003)(TITLE(L),L=1,17),ROMIN,ROMAX,
     &(FX(I),I=1,NX)
 6003 FORMAT(1H1,17A4//32X,39H FLUCTUATION OF THE PDF IN THIS SECTION,
     &2X,F8.0,4X,3H-  ,F8.0//F10.0,14F8.0//)
      IF(IPOTET.EQ.1)WRITE(IOUT,6004)(TITLE(L),L=1,17),T,ROMIN,ROMAX,
     &(FX(I),I=1,NX)
 6004 FORMAT(1H1,17A4//38X,28H MEASURING  TEMPERATURE  WAS,F8.0,2X,
     &6HKELVIN //38X,36H OUTPUT SHOWS THE POTENTIAL  IN MEV.///32X,
     &43H FLUCTUATION OF THE PDF IN THIS SECTION WAS,F8.0,4X,3H-  ,
     &F8.0,//F10.0,14F8.0//)
C
  784 DO 880 JYSEC=1,IYA
      IVORN=(JYSEC-1)*IXA
      FY=JYSEC+IYI-1
      L=0
            DO 870 JXSEC=ISPALT,ISPALT+NXA-1
            IPSV=IVORN+JXSEC-1
            JXX =JXSEC-ISPALT+1
  805       IPSV=IPSV+1
C
C----- CALCULATE POTENTIAL OUT OF PDF. RESTRICT IT TO SENSFUL VALUES.
C      IF PDF IS NEGATIVE MARK THE POTENTIAL WITH A SIGN.
C
               IF (IPOTET) 806,806,807
 807           RO=ARRAY(IPSV)
               RO=RO/ROMAXT
               IF(RO.LT.1.E-20) GOTO 808
               ARRAY(IPSV) = -0.08617*T*ALOG(ABS(RO))
               GOTO 806
C----          INSTEAD OF EXACTLY ZERO 1.E-25 SHOULD BEEN WRITTEN
C              TO PREVENT ERRORS OF THE PLOTTING PROGRAMME.
C808           ARRAY(IPSV)=1.E-25
 808           ARRAY(IPSV)=9999.
C
 806        RO=ARRAY(IPSV)
C
C---- CALCULATE OUTPUT AND OUTPUT FORMAT FOR EACH LINE.
C
            J=RO+SIGN(.5,RO)
            IF(J) 810,860,830
  810       IF(J+1000)820,820,850
  820       J=J+1000
            GO TO 810
  830       IF(J-10000)850,840,840
  840       J=J-10000
            GO TO 830
  850       IF(J.GT.IMINI.AND.J.LT.IMAXI) GOTO 860
            L=L+1
            IP(L)=J
            FRMT(JXX + 3)=NZRO
            GO TO 870
  860       FRMT(JXX + 3)=ZRO
  870       CONTINUE
  876 FRMT(NXA+4)=ENDD
C
C---- IN CORRESPONDENCE TO OUTPUT ANGLE BRANCHING.
C
      IF(IS)1021,1022,1023
 1021 LSTORE=L
      ICHECK=(JYSEC-1)*IHILF+1
      FRMT(3)=IU(ICHECK)
      ICHECK=INT(ICHECK/4)+1
      IF(ICHECK+NXA-30)1043,1043,1042
 1042 DO 1071 IO=34-ICHECK,3+NXA
      IF(FRMT(IO).EQ.NZRO)L=L-1
 1071 FRMT(IO)=LEER
 1043 IF(L.EQ.0)GOTO 872
      WRITE(IOUT,FRMT)LSPC,FY,(IP(I),I=1,L)
      GO TO 880
 1022 FRMT(3)=IU(1)
      GOTO 877
 1023 IF(JYSEC.EQ.1)GO TO 1050
      IF(IHILF.EQ.3) GOTO 1201
      IF(LUECK.EQ.0)ISTART=ISTART+1
      LUECK=MOD(4+LUECK-IHILF,4)
      FRMT(3)=IU(1+LUECK)
      ICOR=0
      IF(ISTART.GT.NXA)GOTO 880
      DO 1054 IKLJ=1,ISTART-1
      IF(FRMT(3+IKLJ).EQ.NZRO)ICOR=ICOR+1
 1054 FRMT(3+IKLJ)=LEER
      ISTAR=ICOR+1
 1045 IF(L.EQ.0)GOTO 872
      WRITE(IOUT,FRMT)LSPC,FY,(IP(I),I=ISTAR,L)
      GO TO 880
 1201 ISTART=ISTART+1
      IF(LUECK.EQ.0) LUECK=4
      LUECK=LUECK-1
      IF(ISTART.EQ.NXA) GOTO 872
      GOTO 1045
 1050 ISTART=1
      LUECK=0
      ISTAR=1
      FRMT(3)=IU(1)
      GOTO 1045
 877  IF(L.EQ.0) GO TO 872
      WRITE(IOUT,FRMT)LSPC,FY,(IP(I),I=1,L)
 880  CONTINUE
C
C----  SECTION NOW COMPLETE - DUMP PLOT  OUTPUT IF NEEDED
C
 881  IF(IPLT.EQ.0)GO TO 890
      J=JZSEC+IZI-1
C---- CHANGE OUTPUT FOR SPECIAL PLANE
C
      IF(IPLANE.EQ.0) GOTO 809
      J=1
  809 WRITE(S2)IXA,IYA,J,IZ,IX,IXI,IXF,IY,IYI,IYF,IZI,IZF,IATOM
      WRITE(S2)(ARRAY(I),I=1,IZAEHL)
C
  890 CONTINUE
 6900 CONTINUE
 6890 CONTINUE
C
C---- RESTORE EXTENSION PARAMETER
C
      IEXT=IHOLD
C
 2400 CONTINUE
C
C        END OF MAP.
C
  900 RETURN
C
C---- SOME AUXILLARY PARTS.
C
C---- OUTPUT OF A LINE, WHICH ELEMENTS ARE ALL ZERO.
C
  872 WRITE(IOUT,6)LSPC,FY
    6 FORMAT(A1,F4.0)
      GOTO 880
C
C---- ERRORMESSAGES, WHICH CAUSES CHANGES IN PROGRAMME FLOW.
C
  908 WRITE(IOUT,909) MODELL
  909 FORMAT(////13H0ERRORMESSAGE/1X,12(1H-)//23H FOR THE GIVEN STRUCTUR
     &,20HE FACTOR MODEL   NO.,I4,2X,30H IS NO EXTENDED MAP AVAILABLE.//
     &27H0INPUT RESET TO NORMAL MAP.//1H )
      GOTO 241
C
  910 WRITE(IOUT,911)
  911 FORMAT( 4(/),13H0ERRORMESSAGE/1X,12(1H-)//
     &        85H0YOU HAVE TO INCREASE THE DIMENSION OF THE ARRAY *ARRAY
     &* TO THE ABOVE PRINTED VALUE.   //32H0I'M SORRY, I'VE TO CALL  EXIT
     &   ,2X,1H.)
      CALL EXIT
C
  912 WRITE(IOUT,913)MODELL
  913 FORMAT(4(/),13H0ERRORMESSAGE/1X,12(1H-)//19H FOR THE STRUCTURE ,
     & 5HMODEL,I4,2X,38HTHERE IS NO PDF-CALCULATION AVAILABLE.//
     & 31HI'M SORRY, I'VE TO CALL 'EXIT'.)
      CALL EXIT
C
  917 WRITE(IOUT,918)MODELL
  918 FORMAT(4(/),13H0ERRORMESSAGE/1X,12(1H-)//
     & 31H FOR THE STRUCTURE-FACTOR MODEL ,I4,2X,18HTHERE IS NO FIFTH ,
     & 26HOR HIGHER ORDER AVAILABLE.//29H SELECTED TYPE WILL BE RESET.
     & //1H )
      IPDFF(4)=0
      IPDFF(5)=0
      GOTO 242
C
  612 WRITE(IOUT,919)
  919 FORMAT(4(/),13H0ERRORMESSAGE/1X,12(1H-)//21H NOT ANY CUMULANT HAS,
     & 15H BEEN SELECTED.//22H RESET TO 'TOTAL' MAP.//1H )
      DO 4139 I=1,5
 4139 IPDFF(I)=1
      GOTO 414
C
  921 WRITE(IOUT,922)
  922 FORMAT(4(/),13H0ERRORMESSAGE/1X,12(1H-)//19H THE SELECTED TENSO,
     &  48HR(S) IS (ARE) NULL. SO THIS MESSAGE IS A RESULT.//
     & 28H THAT'S ALL. JOB TERMINATED.)
      CALL EXIT
C
  923 FORMAT(4(/),13H0ERRORMESSAGE/1X,12(1H-)//19H CALCULATION OF POT,
     &  54HENTIAL WITHOUT  SECOND ORDER CUMULANTS IS MEANINGLESS./
     &  54H PROGRAMME ADD THE SECOND ORDER CUMULANT COEFFICIENTS.//1H )
C
      RETURN
      END
C
C
      SUBROUTINE ACHSE2(ISECT,IX,IXI,IXF,IY,IYI,IYF,IZ,IZI,IZF)
C
C     TRANSFORMATION OF GRIDS, WHICH IS ALWAYS  X,Y,Z DURING INPUT
C     TO THAT SEQUENCE, WHICH IS NECESSARY FOR SELECTED SECTIONS.
C
C                            BY UDO ZUCKER
C
      IF(ISECT)25,25,5
    5 GO TO (10,30,50,60,70),ISECT
C
C---- XZY SECTIONS
C
   10 IW  = IY
      IWI = IYI
      IWF = IYF
   20 IY =IZ
      IYI=IZI
      IYF=IZF
      IZ =IW
      IZI=IWI
      IZF=IWF
   25 RETURN
C
C---- YXZ SECTIONS
C
   30 IW = IY
      IWI=IYI
      IWF=IYF
   40 IY=IX
      IYI=IXI
      IYF=IXF
      IX=IW
      IXI=IWI
      IXF=IWF
      RETURN
C
C---- YZX SECTIONS
C
   50 IW=IX
      IWI=IXI
      IWF=IXF
      IX=IY
      IXI=IYI
      IXF=IYF
      GO TO 20
C
C---- ZYX SECTIONS
C
   60 IW=IX
      IWI=IXI
      IWF=IXF
      IX=IZ
      IXI=IZI
      IXF=IZF
      IZ=IW
      IZI=IWI
      IZF=IWF
      RETURN
C
C---- ZXY SECTIONS
C
   70 IW=IZ
      IWI=IZI
      IWF=IZF
      IZ=IY
      IZI=IYI
      IZF=IYF
      GO TO 40
C
      END
C
                          SUBROUTINE HERMIT
     &   (W,Q,ITHREE,JTHREE,CR,IFOUR,JFOUR,DR,II,CUM3,CUM4,HJKLM)
C
C     THIS ROUTINE CALCULATES THE  PRODUCTS OF  HERMITE  POLYNOMS  OF
C     THIRD AND FOURTH ORDER BY  CUMULANTS  OF  CORRESPONDING  ORDER.
C     NATURATELLY ONE COULD USE THE  SUBROUTINE  JOHN WITH ALF=0, BUT
C     THIS ROUTINE HERE IS FASTER.
C
C
C                    UDO ZUCKER  NOVEMBER 1980
C
C     IN THE ROUTINE 3 QUANTITYS WILL BE  CALCULATED  CUM3, CUM4 AND
C     THE ARRAY HJKLM HOLDING THE HERMITE POLYNOMS  OF FOURTH ORDER.
C
      DIMENSION W(3),Q(3,3),CR(10,60),DR(15,60),JTHREE(10),JFOUR(15)
     & ,HJKLM(15)
C
      W1    =  W(1)
      W2    =  W(2)
      W3    =  W(3)
      W11   = W1*W1
      W22   = W2*W2
      W33   = W3*W3
C
C
C---- NO THIRD ORDER PRODUCT,IF ITHREE EQUAL ZERO.
C
      IF(ITHREE.EQ.0) GOTO 3000
C
C---- INITIALIZE
C
      TERM  = 0.
      TERMZ = 0.
C
      IF(JTHREE(1))1,2,1
    1 TERM1 = W11*W1
      TERM2 = 3.*W1*Q(1,1)
      TERM  = (TERM1-TERM2)*CR(1,II)
    2 IF(JTHREE(2))3,4,3
    3 TERM1 = W22*W2
      TERM2 = 3.*W2*Q(2,2)
      TERM  = TERM + (TERM1-TERM2)*CR(2,II)
    4 IF(JTHREE(3))5,6,5
    5 TERM1 = W33*W3
      TERM2 = 3.*W3*Q(3,3)
      TERM  = TERM + (TERM1-TERM2)*CR(3,II)
    6 IF(JTHREE(4))7,8,7
    7 TERM1 = W11*W2
      TERM2 = (2.*W1*Q(1,2)+W2*Q(1,1))
      TERMZ = (TERM1-TERM2)*CR(4,II)
    8 IF(JTHREE(5))9,10,9
    9 TERM1 = W22*W1
      TERM2 = (W1*Q(2,2)+2.*W2*Q(1,2))
      TERMZ = TERMZ + (TERM1-TERM2)*CR(5,II)
   10 IF(JTHREE(6))11,12,11
   11 TERM1 = W11*W3
      TERM2 = (2.*W1*Q(1,3)+W3*Q(1,1))
      TERMZ = TERMZ + (TERM1-TERM2)*CR(6,II)
   12 IF(JTHREE(7))13,14,13
   13 TERM1 = W1*W33
      TERM2 = (W1*Q(3,3)+2.*W3*Q(1,3))
      TERMZ = TERMZ + (TERM1-TERM2)*CR(7,II)
   14 IF(JTHREE(8))15,16,15
   15 TERM1 = W22*W3
      TERM2 = (2.*W2*Q(2,3)+W3*Q(2,2))
      TERMZ = TERMZ + (TERM1-TERM2)*CR(8,II)
   16 IF(JTHREE(9))17,18,17
   17 TERM1 = W2*W33
      TERM2 = (W2*Q(3,3)+2.*W3*Q(2,3))
      TERMZ = TERMZ + (TERM1-TERM2)*CR(9,II)
   18 TERM  = TERM + TERMZ*3.0
      TERMZ = 0.0
      IF(JTHREE(10))19,20,19
   19 TERM1 = W1*W2*W3
      TERM2 = (W1*Q(2,3)+W2*Q(1,3)+W3*Q(1,2))
      TERMZ = (TERM1-TERM2)*CR(10,II)*6.0
   20 CUM3  = TERM + TERMZ
      CUM3  = CUM3 * 1.E-3
C
C---- IF IFOUR=0 FOURTH RANK PRODUCTS ARE NOT REQUIRED.
C
 3000 IF(IFOUR.EQ.0) GOTO 4000
C
      TERM  = 0.
      TERMZ = 0.
C
      IF(JFOUR(1))101,102,101
  101 TERM1    = W11*W11
      TERM2    = 6.*W11*Q(1,1)
      TERM3    = 3.*Q(1,1)**2
      HJKLM(1) = TERM1-TERM2+TERM3
      TERM     = HJKLM(1)*DR(1,II)
  102 IF(JFOUR(2))103,104,103
  103 TERM1    = W22*W22
      TERM2    = 6.*W22*Q(2,2)
      TERM3    = 3.*Q(2,2)**2
      HJKLM(2) = TERM1-TERM2+TERM3
      TERM     = TERM + HJKLM(2)*DR(2,II)
  104 IF(JFOUR(3))105,106,105
  105 TERM1    = W33*W33
      TERM2    = 6.*W33*Q(3,3)
      TERM3    = 3.*Q(3,3)**2
      HJKLM(3) = TERM1-TERM2+TERM3
      TERM     = TERM + HJKLM(3)*DR(3,II)
  106 IF(JFOUR(4))107,108,107
  107 TERM1    = W11*W1*W2
      TERM2    = (W11*Q(1,2)*3.+W1*W2*Q(1,1)*3.)
      TERM3    = 3.*Q(1,1)*Q(1,2)
      HJKLM(4) = TERM1-TERM2+TERM3
      TERMZ    = HJKLM(4)*DR(4,II)
      HJKLM(4) = HJKLM(4)*4.0
  108 IF(JFOUR(5))109,110,109
  109 TERM1    = W11*W1*W3
      TERM2    = (W11*Q(1,3)*3.+W1*W3*Q(1,1)*3.)
      TERM3    = 3.*Q(1,1)*Q(1,3)
      HJKLM(5) = TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(5)*DR(5,II)
      HJKLM(5) =HJKLM(5)*4.0
  110 IF(JFOUR(9))111,112,111
  111 TERM1    = W22*W2*W1
      TERM2    = (W22*Q(1,2)*3.+W2*W1*Q(2,2)*3.)
      TERM3    = 3.*Q(2,2)*Q(1,2)
      HJKLM(9) = TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(9)*DR(9,II)
      HJKLM(9) = HJKLM(9)*4.0
  112 IF(JFOUR(12))113,114,113
  113 TERM1    = W33*W3*W1
      TERM2    = (W33*Q(1,3)*3.+W1*W3*Q(3,3)*3.)
      TERM3    = 3.*Q(3,3)*Q(1,3)
      HJKLM(12)= TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(12)*DR(12,II)
      HJKLM(12)= HJKLM(12)*4.0
  114 IF(JFOUR(13))115,116,115
  115 TERM1    = W22*W2*W3
      TERM2    = (W22*Q(2,3)*3.+W2*W3*Q(2,2)*3.)
      TERM3    = 3*Q(2,2)*Q(2,3)
      HJKLM(13)= TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(13)*DR(13,II)
      HJKLM(13)= HJKLM(13)*4.0
  116 IF(JFOUR(15))117,118,117
  117 TERM1    = W33*W3*W2
      TERM2    = (W33*Q(2,3)*3.+W2*W3*Q(3,3)*3.)
      TERM3    = 3.*Q(3,3)*Q(2,3)
      HJKLM(15)= TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(15)*DR(15,II)
      HJKLM(15)= HJKLM(15)*4.0
  118 TERM     = TERM + TERMZ*4.0
      TERMZ    = 0.0
      IF(JFOUR(6))119,120,119
  119 TERM1    = W11*W22
      TERM2    = (W11*Q(2,2)+4.*W1*W2*Q(1,2)+W22*Q(1,1))
      TERM3    = Q(1,1)*Q(2,2)+2.*Q(1,2)**2
      HJKLM(6) = TERM1-TERM2+TERM3
      TERMZ    = HJKLM(6)*DR(6,II)
  120 IF(JFOUR(8))121,122,121
  121 TERM1    = W11*W33
      TERM2    = (W11*Q(3,3)+4.*W1*W3*Q(1,3)+W33*Q(1,1))
      TERM3    = Q(1,1)*Q(3,3)+2.*Q(1,3)**2
      HJKLM(8) = TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(8)*DR(8,II)
      HJKLM(8) = HJKLM(8)*6.0
  122 IF(JFOUR(14))123,124,123
  123 TERM1    = W33*W22
      TERM2    = (W33*Q(2,2)+4.*W3*W2*Q(2,3)+W22*Q(3,3))
      TERM3    = Q(3,3)*Q(2,2)+2.*Q(2,3)**2
      HJKLM(14)= TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(14)*DR(14,II)
      HJKLM(14)= HJKLM(14)*6.0
  124 TERM     = TERM + TERMZ*6.0
      TERMZ    = 0.0
      IF(JFOUR(10))125,126,125
  125 TERM1    = W22*W3*W1
      TERM2    = (W22*Q(1,3)+2.*W2*W3*Q(1,2)+2.*W2*W1*Q(2,3) +
     &           W3*W1*Q(2,2))
      TERM3    = Q(2,2)*Q(1,3)+2.*Q(2,3)*Q(1,2)
      HJKLM(10)= TERM1-TERM2+TERM3
      TERMZ    = HJKLM(10)*DR(10,II)
      HJKLM(10)= HJKLM(10)*12.0
  126 IF(JFOUR(11))127,128,127
  127 TERM1    = W1*W2*W33
      TERM2    = (W1*W2*Q(3,3)+W2*W3*Q(1,3)*2.+W33*Q(1,2) +
     &           2.*W1*W3*Q(2,3))
      TERM3    = Q(1,2)*Q(3,3)+2.*Q(1,3)*Q(2,3)
      HJKLM(11)= TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(11)*DR(11,II)
      HJKLM(11)= HJKLM(11)*12.0
  128 IF(JFOUR(7))129,130,129
  129 TERM1    = W11*W2*W3
      TERM2    = (W11*Q(2,3)+2.*W1*W2*Q(1,3)+2.*W1*W3*Q(1,2) +
     &           W2*W3*Q(1,1))
      TERM3    = Q(1,1)*Q(2,3)+2.*Q(1,2)*Q(1,3)
      HJKLM(7) = TERM1-TERM2+TERM3
      TERMZ    = TERMZ + HJKLM(7)*DR(7,II)
      HJKLM(7) = HJKLM(7)*12.0
  130 CUM4     = TERM + TERMZ*12.0
      CUM4     = CUM4 * 1.E-4
C
C
 4000 RETURN
      END
C
      SUBROUTINE UMKEHR(BETA,I,QDET)
C
C     INVERSION OF THE SYMETRIC TENSOR BETA.
C
C
      DIMENSION BETA(6,60)
C
      COMMON /INVBET/Q(3,3)
      DATA TWOPIQ/19.739208/
C
      Q(1,1)=BETA(2,I)*BETA(3,I)-BETA(6,I)**2
      Q(1,2)=-BETA(4,I)*BETA(3,I)+BETA(5,I)*BETA(6,I)
      Q(1,3)=BETA(4,I)*BETA(6,I)-BETA(5,I)*BETA(2,I)
      QDET  =BETA(1,I)*Q(1,1)+BETA(4,I)*Q(1,2)+BETA(5,I)*Q(1,3)
      Q(1,1)=Q(1,1)/QDET
      Q(1,2)=Q(1,2)/QDET
      Q(1,3)=Q(1,3)/QDET
      Q(2,2)=(BETA(1,I)*BETA(3,I)-BETA(5,I)**2)/QDET
      Q(2,3)=(-BETA(1,I)*BETA(6,I)+BETA(5,I)*BETA(4,I))/QDET
      Q(3,3)=(BETA(1,I)*BETA(2,I)-BETA(4,I)**2)/QDET
      Q(2,1)=Q(1,2)
      Q(3,1)=Q(1,3)
      Q(3,2)=Q(2,3)
      DO 1 J=1,3
C
C---- NORMALIZE TO A VALUE NEEDED IN THE PDF PROGRAM.
C
         DO 1 K=1,3
   1     Q(J,K)=TWOPIQ*Q(J,K)
C
      QDET=5.568328/SQRT(QDET)
C
      RETURN
      END
C
      SUBROUTINE PRODUK(CCH)
C
      COMMON /KUMU/C111,C222,C333,C112,C122,C113,C133,C223,C233,C123
C
C     THIS ROUTINE CALCULATES THE PRODUCT
C
C            JKL    QRS
C     CCH = C    * C    * H          (EINSTEIN CONVENTION)
C                          JKLQRS
C
C---- CALCULATE OFTEN NEEDED FORMULAAS.
C
      CALL START
C
C---- CALCULATE NOW THE PRODUCT. WHAT FUN !
C
      T1=C111*C111*H1(1)+C222*C222*H1(2)+C333*C333*H1(3)
      T2=C111*(C112*H2(1,2)+C113*H2(1,3))+C222*(C122*H2(2,1)+C223*
     &   H2(2,3))+C333*(C133*H2(3,1)+C233*H2(3,2))
      T3=(2.*C111*C122+3.*C112*C112)*H3(1,2)+(2.*C111*C133+3.*C113*
     &  C113)*H3(1,3)+(2.*C222*C112+3.*C122*C122)*H3(2,1)+(2.*C222
     &  *C233+3.*C223*C223)*H3(2,3)+(2.*C333*C113+3.*C133*C133)*H3
     &  (3,1)+(2.*C333*C223+3.*C233*C233)*H3(3,2)
      T4=(3.*C113*C112+2.*C111*C123)*H4(1,2,3)+(3.*C223*C122+2.*
     &  C222*C123)*H4(2,1,3)+(3.*C133*C233+2.*C123*C333)*H4(3,1,2)
      T5=(C111*C222+9.*C122*C112)*H7(1,2)+(C111*C333+9.*C133*C113)
     & *H7(1,3)+(C222*C333+9.*C223*C233)*H7(2,3)
      T6=(C111*C223+6.*C112*C123+3.*C122*C113)*H5(1,2,3)+(C111*C233
     & +6.*C113*C123+3.*C112*C133)*H5(1,3,2)+(C222*C113+6.*C122*C123
     & +3.*C112*C223)*H5(2,1,3)+(C133*C222+6.*C223*C123+3.*C122*C233
     & )*H5(2,3,1)+(C333*C112+6.*C133*C123+3.*C113*C233)*H5(3,1,2)+
     & (C333*C122+6.*C233*C123+3.*C223*C133)*H5(3,2,1)
      T7=(C112*C233+C113*C223+C133*C122+2.*C123*C123)*H6(1,2,3)
C
      CCH = T1 + 6.*T2 + 3.*T3 + 6.*T4 + 2.*T5 +  6.*T6 + 18.*T7
      CCH = CCH * 1.E-6
C
      RETURN
      END
C
      SUBROUTINE START
C
      COMMON /INVBET/ Q(3,3)
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
C
      DO 1 IT=1,3
      W2(IT)=W(IT)**2
      W3(IT)=W2(IT)*W(IT)
      W4(IT)=W3(IT)*W(IT)
      W5(IT)=W4(IT)*W(IT)
    1 CONTINUE
C
C---- THIS TERMS ARE OFTEN USED IN CALCULATION OF HERMIT POLYN.
C     OF HIGHER THAN FIFTH ORDER.
C
      RETURN
      END
C
C
      SUBROUTINE PREPAR(MODELL,II,CR)
C
C     CALCULATION OF SOME OFTEN USED VALUES.
C
      COMMON /INVBET/Q(3,3)
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /KUMU/C111,C222,C333,C112,C122,C113,C133,C223,C233,C123
C
      DIMENSION CR(10,60)
C
      DO 1 I=1,3
      P(I) = Q(I,I)
      P2(I) = P(I)**2
   1  P3(I) = P2(I)*P(I)
C
      IF(MODELL.NE.1) RETURN
C
      C111  = CR(1,II)
      C222  = CR(2,II)
      C333  = CR(3,II)
      C112  = CR(4,II)
      C122  = CR(5,II)
      C113  = CR(6,II)
      C133  = CR(7,II)
      C223  = CR(8,II)
      C233  = CR(9,II)
      C123  = CR(10,II)
C
      RETURN
      END
C
      FUNCTION HH1(J)
C
C     HERMIT POLYNOM OF FIFTH RANK   HH1=H(J,J,J,J,J)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      HH1 = W(J) * ( W4(J)-10.*P(J)*( W2(J)-1.5*P(J) )  )
C
      RETURN
      END
C
      FUNCTION HH2(J,L)
C
C     HERMIT POLYNOM OF FIFTH RANK   HH2=H(J,J,J,J,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
C
      HH2 = W(J)*( W(L)*(W3(J)-6.*P(J)*W(J)) - 4.*Q(J,L)*
     & (W2(J)-3.*P(J)) )  + 3.*P2(J)*W(L)
C
      RETURN
      END
C
      FUNCTION HH3(J,L)
C
C     HH3 = H(J,J,J,L,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
C
      HH3 = W(J)* ( W(L)*( W(L)*W2(J)-6.*Q(J,L)*W(J)-3.*P(J)*W(L) )
     & - P(L)* (W2(J)-3.*P(J)) ) + 6.*Q(J,L)*(Q(J,L)*W(J)+P(J)*W(L))
C
      RETURN
      END
C
      FUNCTION HH4(I,J,L)
C
C     HERMIT POLYNOM OF FIFTH RANK   HH4=H(I,I,I,J,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      HH4 = W(I)*( W2(I)*W(J)*W(L)-W(I)*(3.*Q(I,L)*W(J)+3.*Q(I,J)*
     & W(L)+Q(J,L)*W(I))  - 3.*(P(I)*(W(J)*W(L)-Q(J,L))-2.*Q(I,J)*
     & Q(I,L))) + 3.*P(I)*(Q(I,L)*W(J)+Q(I,J)*W(L))
C
      RETURN
      END
C
      FUNCTION HH5(I,J,L)
C
C     HERMIT POLYNOM OF FIFTH RANK   HH5 = H(I,I,J,J,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      HH5 = W(I)* (W(J)* (W(J)* (W(I)*W(L)-2.*Q(I,L)) -2.*Q(J,L)*W(I)
     & -4.*Q(I,J)*W(L)) -P(J)*W(I)*W(L) + 2.*P(J)*Q(I,L)+4.*Q(I,J)*
     & Q(J,L))  + W(J)* (4.*Q(I,J)*Q(I,L)-P(I)*(W(J)*W(L)-2.*Q(J,L)))
     & + W(L)* (2.*Q(I,J)**2 + P(I)*P(J) )
C
      RETURN
      END
C
      FUNCTION H1(I)
C
C     HERMIT POLYNOM OF SIXTH RANK     H1=H(I,I,I,I,I,I)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      H1=W4(I)* (W2(I)-15.*P(I))  +45.*W2(I)*P2(I)-15.*P3(I)
      RETURN
      END
C
      FUNCTION H2(I,J)
C
C     HERMIT POLYNOM OF SIXTH RANK     H2=H(I,I,I,I,I,J)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      H2=W3(I)*(W2(I)*W(J)-5.*W(I)*Q(I,J)-10.*W(J)*P(I))+15.*W(I)
C    & W(J)*P2(I)+30.*W2(I)*Q(I,J)*P(I)-15.*Q(I,J)*P2(I)
     & *W(J)*P2(I)+30.*W2(I)*Q(I,J)*P(I)-15.*Q(I,J)*P2(I)
C
      RETURN
      END
C
      FUNCTION H3(I,J)
C
C     HERMIT POLYNOM OF SIXTH RANK     H3 = H(I,I,I,I,J,J)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)

      H3=W4(I)*W2(J)-W4(I)*P(J)-8.*W3(I)*W(J)*Q(I,J)-6.*W2(I)*W2(J)*
     & P(I)+6.*W2(I)*P(I)*P(J)+12.*W2(I)*Q(I,J)*Q(I,J)+24.*W(I)*W(J)
     & *Q(I,J)*P(I)+3.*W2(J)*P2(I)-3.*P2(I)*P(J)-12.*Q(I,J)*Q(I,J)*P
     & (I)
C
      RETURN
      END
C
      FUNCTION H4(I,J,L)
C
C     HERMIT POLYNOM OF SIXTH RANK     H4=H(I,I,I,I,J,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      H4= W4(I)*W(J)*W(L)-W4(I)*Q(J,L)-4.*W3(I)*W(L)*Q(I,J)-4.*W3(I)*
     & W(J)*Q(I,L)-6.*W2(I)*W(J)*W(L)*P(I)+6.*W2(I)*P(I)*Q(J,L)+12.*
     & W2(I)*Q(I,L)*Q(I,J)+12.*W(I)*W(J)*P(I)*Q(I,L)+12.*W(I)*W(L)*P(
     & I)*Q(I,J)+3.*W(J)*W(L)*P(I)*P(I)-12.*P(I)*P(I)*Q(J,L)-3.*P(I)*
     & Q(I,L)*P(J)
      RETURN
      END
C
      FUNCTION H5(I,J,L)
C
C     HERMIT POLYNOM OF SIXTH RANK      H5 = H(I,I,I,J,J,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      T1= W3(I)*W2(J)*W(L)-2.*W3(I)*W(J)*Q(J,L)-W3(I)*W(L)*P(J)-3.*W2(
     &I)*W2(J)*Q(I,L)-6.*W2(I)*W(J)*W(L)*Q(I,J)-3.*W(I)*W2(J)*W(L)*P(I
     & )+6.*W2(I)*Q(J,L)*Q(I,J)+3.*W2(I)*Q(I,L)*P(J)+6.*W(I)*W(J)*P(I)
     & *Q(J,L)+12.*W(I)*W(J)*Q(I,J)*Q(I,L)+6.*W(I)*W(L)*Q(I,J)*Q(I,J)
      T2= 3.*W(I)*W(L)*P(I)*P(J)+3.*W2(J)*P(I)*Q(I,L)+6.*W(J)*W(L)*P(I
     & )*Q(I,J)-7.*P(I)*Q(I,J)*Q(J,L)-2.*P(I)*Q(I,L)*P(J)-6.*Q(I,J)*Q(
     & I,J)*Q(I,L)
      H5=T1+T2
C
      RETURN
      END
C
      FUNCTION H6(I,J,L)
C
C     HERMIT POLYNOM OF SIXTH ORDER      H6 = H(I,I,J,J,L,L)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      T1= W2(I)*W2(J)*W2(L)-W2(I)*W2(J)*P(L)-W2(I)*W2(L)*P(J)-W2(J)*W2
     & (L)*P(I)-4.*W2(I)*W(J)*W(L)*Q(J,L)-4.*W(I)*W2(J)*W(L)*Q(I,L)-4.
     & *W(I)*W(J)*W2(L)*Q(I,J)+W2(I)*P(J)*P(L)+W2(J)*P(I)*P(L)+W2(L)*P
     & (I)*P(J)+2.*W2(I)*Q(J,L)*Q(J,L)+2.*W2(J)*Q(I,L)*Q(I,L)
      T2=2.*W2(L)*Q(I,J)*Q(I,J)+4.*W(I)*W(J)*Q(I,J)*P(L)+4.*W(I)*W(L)*
     & Q(I,L)*P(J)+4.*W(J)*W(L)*Q(J,L)*P(I)+8.*W(I)*W(J)*Q(I,L)*Q(J,L)
     & +8.*W(I)*W(L)*Q(I,J)*Q(J,L)+8.*W(J)*W(L)*Q(I,L)*Q(I,J)
      T1=T1+T2
      T2=-P(I)*P(J)*P(L)-2.*P(I)*Q(J,L)*Q(J,L)-2.*P(J)*
     & Q(I,L)*Q(I,L)-2.*P(L)*Q(I,J)*Q(I,J)-8.*Q(I,J)*Q(I,L)*Q(J,L)
      H6=T1+T2
C
      RETURN
      END
C
      FUNCTION H7(I,J)
C
C     HERMIT POLYNOM OF SIXTH RANK      H7 = H(I,I,I,J,J,J)
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      H7= W3(I)*W3(J)-3.*W3(I)*W(J)*P(J)-9.*W2(I)*W2(J)*Q(I,J)-3.*W(I)
     & *W3(J)*P(I)+9.*W2(I)*Q(I,J)*P(J)+18.*W(I)*W(J)*Q(I,J)*Q(I,J)+9.
     & *W(I)*W(J)*P(I)*P(J)+9.*W2(J)*P(I)*Q(I,J)-9.*Q(I,J)*P(I)*P(J)-6
     & .*Q(I,J)**3
C
      RETURN
      END
C
      SUBROUTINE SHERE2
C
C---- CALCULATION OF OUTPUT ANGLE OF THE POINT ARRAY.
C
      COMMON /PRINT/WINKEL(3),ISELEC,ISECT,IS,IHILF,LSPCH,GAM
C
      GAM=WINKEL(3)
      IF(ISELEC.GE.2)GAM=FLOAT(ISELEC)
      IF(ISELEC.GE.2)GO TO 113
      IF(ISECT.EQ.1.OR.ISECT.EQ.5)GAM=WINKEL(2)
      IF(ISECT.EQ.3.OR.ISECT.EQ.4)GAM=WINKEL(1)
  113 IF(GAM.LT.30..OR.GAM.GT.160)GAM=90.
      IF (GAM-90.0) 114,115,116
  115 IS=0
      GO TO 117
  116 HILF=GAM-90.0
      IS=1
  118 IF(LSPCH.NE.0)DEL=30.0
      IF(LSPCH.EQ.0)DEL=15.0
      HILF=HILF/DEL
      IHILF=INT(HILF)
      DIF=HILF-FLOAT(IHILF)
      IF (DIF.GE.0.5) IHILF=IHILF+1
      IF(IHILF.EQ.0)IS=0
      GOTO 117
  114 HILF=ABS(GAM-90)
      IS=-1
      GO TO 118
  117 RETURN
      END
C
      SUBROUTINE ARB2(ISECT,CELL,ALF,BET,GAM,AG,BG,CG,JACHS)
C
C---- CHANGE SEQUENCE OF LATTICE PARAMETERS CORRESPONDING TO
C     SELECTED SECTIONS.
C
      DIMENSION CELL(6)
      IF(ISECT)1,1,30
   30 GOTO(2,3,4,5,6),ISECT
    1 CELL(1)=AG
      CELL(2)=BG
      CELL(3)=CG
      CELL(4)=ALF
      CELL(5)=BET
      CELL(6)=GAM
      JACHS=0
      RETURN
    2 CELL(1)=AG
      CELL(2)=CG
      CELL(3)=BG
      CELL(4)=ALF
      CELL(5)=GAM
      CELL(6)=BET
      JACHS=1
      RETURN
    3 CELL(1)=BG
      CELL(2)=AG
      CELL(3)=CG
      CELL(4)=BET
      CELL(5)=ALF
      CELL(6)=GAM
      JACHS=2
      RETURN
    4 CELL(1)=BG
      CELL(2)=CG
      CELL(3)=AG
      CELL(4)=GAM
      CELL(5)=BET
      CELL(6)=ALF
      JACHS=3
      RETURN
    5 CELL(1)=CG
      CELL(2)=BG
      CELL(3)=AG
      CELL(4)=GAM
      CELL(5)=ALF
      CELL(6)=BET
      JACHS=4
      RETURN
    6 CELL(1)=CG
      CELL(2)=AG
      CELL(3)=BG
      CELL(4)=GAM
      CELL(5)=ALF
      CELL(6)=BET
      JACHS=5
C
      RETURN
      END
C
      FUNCTION HJK(I)
C
C     CALCULATION OF SECOND ORDER HERMIT POLYNOMS IN THREE DIM.
C
      COMMON /WQ/ W(3),W2(3),W3(3),W4(3),W5(3),P(3),P2(3),P3(3)
      COMMON /INVBET/ Q(3,3)
C
      IF(I.GT.3) GOTO 1
      HJK =W(I)*W(I)-P(I)
      RETURN
    1 IF(I.GT.5) GOTO 2
      J=I-2
      HJK=W(1)*W(J)-Q(1,J)
      RETURN
    2 HJK=W(2)*W(3)-Q(2,3)
C
      RETURN
      END
C
      SUBROUTINE TRANSF(ISECT,I1,I2,I3,M3)
C
C
C     CELL TRANSFORMATION IN ACCORDANCE TO SELECTED SECTIONS
C
      REAL M3
C
      GOTO (2,3,4,5,6),ISECT
C
C     XZY DOWN
C
   2  I2=3
      I3=2
      M3=1.
      RETURN
C
C     YXZ
C
   3  I1=2
      I2=1
      M3=1.
      RETURN
C
C     YZX
C
   4  I1=2
      I2=3
      I3=1
      RETURN
C
C     ZYX
C
   5  I1=3
      I3=1
      M3=1.
      RETURN
C
C     ZXY
C
   6  I1=3
      I2=1
      I3=2
      RETURN
C
      END
C
      FUNCTION RANK5(ER,JFIVE,II)
C
C     CALCULATION OF
C
C                I J K L M
C     RANK5 = ER           * HERMIT5
C                                    I J K L M
C
C
C REMARK=  THE  FOLLOWING PROGRAMMING SEEMS TO BE  VERY  COMPLICATED AND
C          INEFFECTIVE.   BUT I SUPOSSE NOBODY WILL CALCULATED FIFTH  OR
C          SIXTH CUMULANTS  FOR ATOMS IN GENERAL POSITIONS. THAT   MEANS
C          THAT IN MOST OF ALL CASES A LOT OF CUMULANTS HAVE TO BE ZERO.
C          BECAUSE OF COMPLEXITY OF HERMIT POLYNOMS OF  FIFTH OR  HIGHER
C          ORDER, THIS WAY  OF PROGRAMMING SAVES A REASONABLE AMOUNT  OF
C          PROCESSING TIME.     TIME IS MONEY!!
C
       DIMENSION ER(21,6),JFIVE(21)
C
C      INITIALIZE
C
       CALL START
       CUM5 = 0.0
C
       IF(JFIVE(1))2900,2901,2900
 2900  CUM5 =        ER(1,II)*HH1(1)
 2901  IF(JFIVE(2))2902,2903,2902
 2902  CUM5 = CUM5 + ER(2,II)*HH1(2)
 2903  IF(JFIVE(3))2904,2905,2904
 2904  CUM5 = CUM5 + ER(3,II)*HH1(3)
 2905  TEMP = 0.0
       IF(JFIVE(4))2906,2907,2906
 2906  TEMP =        ER(4,II)*HH2(1,2)
 2907  IF(JFIVE(5))2908,2909,2908
C
 2908  TEMP = TEMP + ER(5,II)*HH2(1,3)
 2909  IF(JFIVE(13))2910,2911,2910
 2910  TEMP = TEMP + ER(13,II)*HH2(2,1)
 2911  IF(JFIVE(18))2912,2913,2912
 2912  TEMP = TEMP + ER(18,II)*HH2(2,3)
 2913  IF(JFIVE(17))2914,2915,2914
 2914  TEMP = TEMP + ER(17,II)*HH2(3,1)
 2915  IF(JFIVE(21))2916,2917,2916
 2916  TEMP = TEMP + ER(21,II)*HH2(3,2)
 2917  CUM5 = CUM5 + TEMP*5.
       TEMP = 0.0
       IF(JFIVE(6))2918,2919,2918
 2918  TEMP =        ER(6,II) * HH3(1,2)
 2919  IF(JFIVE(8))2920,2921,2920
 2920  TEMP = TEMP + ER(8,II) * HH3(1,3)
 2921  IF(JFIVE(19))2922,2923,2922
 2922  TEMP = TEMP + ER(19,II) * HH3(2,3)
 2923  IF(JFIVE(9)) 2924,2925,2924
 2924  TEMP = TEMP + ER( 9,II) * HH3(2,1)
 2925  IF(JFIVE(12))2926,2927,2926
 2926  TEMP = TEMP + ER(12,II) * HH3(3,1)
 2927  IF(JFIVE(20))2928,2929,2928
 2928  TEMP = TEMP + ER(20,II) * HH3(3,2)
 2929  CUM5 = CUM5 +TEMP*10.
       TEMP = 0.0
       IF(JFIVE( 7))2930,2931,2930
 2930  TEMP =        ER( 7,II) * HH4(1,2,3)
 2931  IF(JFIVE(14))2932,2933,2932
 2932  TEMP = TEMP + ER(14,II) * HH4(2,1,3)
 2933  IF(JFIVE(16))2934,2935,2934
 2934  TEMP = TEMP + ER(16,II) * HH4(3,1,2)
 2935  CUM5 = CUM5 + TEMP*20.
       TEMP = 0.0
       IF(JFIVE(10))2936,2937,2936
 2936  TEMP =        ER(10,II) * HH5(1,2,3)
 2937  IF(JFIVE(11))2938,2939,2938
 2938  TEMP = TEMP + ER(11,II) * HH5(1,3,2)
 2939  IF(JFIVE(15))2940,2941,2940
 2940  TEMP = TEMP + ER(15,II) * HH5(2,3,1)
 2941  CUM5 = CUM5 + TEMP*30.
C
       RANK5= CUM5 * 1.E-5
C
       RETURN
       END
C
       FUNCTION RANK6(FR,JSIX,NO5,II)
C
C      CALCULATE
C
C                I J K L M N
C      RANK6 = FR            * HERMIT6
C                                      I J K L M N
C
C
C
       DIMENSION FR(28,6),JSIX(28)
C
C----  INITIALIZE, IF NOT DONE BEFORE.
C
       IF(NO5.EQ.0) CALL START
             CUM6 = 0.
C
C----  IN CASE OF ASTONISHMENT SEE REMARK IN FUNCTION RANK5.
C
       DO 2011 ID=1,3
       IF(JSIX(ID).EQ.0) GOTO 2011
       CUM6 = CUM6 + FR(ID,II)*H1(ID)
 2011  CONTINUE
       TEMP = 0.0
       IF(JSIX( 4))2012,2013,2012
 2012  TEMP =        FR(4,II)*H2(1,2)
 2013  IF(JSIX( 5))2014,2015,2014
 2014  TEMP = TEMP + FR(5,II)*H2(1,3)
 2015  IF(JSIX(18))3016,3017,3016
 3016  TEMP = TEMP + FR(18,II)*H2(2,1)
 3017  IF(JSIX(24))2016,2017,2016
 2016  TEMP = TEMP + FR(24,II)*H2(2,3)
 2017  IF(JSIX(23))2018,2019,2018
 2018  TEMP = TEMP + FR(23,II)*H2(3,1)
 2019  IF(JSIX(28))2020,2021,2020
 2020  TEMP = TEMP + FR(28,II)*H2(3,2)
 2021  CUM6 = CUM6 + TEMP*6.
       TEMP = 0.0
       IF(JSIX( 6))2022,2023,2022
 2022  TEMP =        FR( 6,II)*H3(1,2)
 2023  IF(JSIX( 8))2024,2025,2024
 2024  TEMP = TEMP + FR( 8,II)*H3(1,3)
 2025  IF(JSIX(25))2026,2027,2026
 2026  TEMP = TEMP + FR(25,II)*H3(2,3)
 2027  IF(JSIX(13))2028,2029,2028
 2028  TEMP = TEMP + FR(13,II)*H3(2,1)
 2029  IF(JSIX(17))2030,2031,2030
 2030  TEMP = TEMP + FR(17,II)*H3(3,1)
 2031  IF(JSIX(27))2032,2033,2032
 2032  TEMP = TEMP + FR(27,II)*H3(3,2)
 2033  CUM6 = CUM6 + TEMP*15.
       TEMP = 0.0
       IF(JSIX( 7))2034,2035,2034
 2034  TEMP =        FR( 7,II)*H4(1,2,3)
 2035  IF(JSIX(19))2036,2037,2036
 2036  TEMP = TEMP + FR(19,II)*H4(2,1,3)
 2037  IF(JSIX(22)) 2038,2039,2038
 2038  TEMP = TEMP + FR(22,II)*H4(3,1,2)
 2039  CUM6 =CUM6 + TEMP*30.
       TEMP =0.0
       IF(JSIX( 9))2040,2041,2040
 2040  TEMP =        FR( 9,II)*H7(1,2)
 2041  IF(JSIX(12))2042,2043,2042
 2042  TEMP = TEMP + FR(12,II)*H7(1,3)
 2043  IF(JSIX(26))2044,2045,2044
 2044  TEMP = TEMP + FR(26,II)*H7(2,3)
 2045  CUM6 = CUM6 + TEMP*20.
       TEMP = 0.0
       IF(JSIX(10))2046,2047,2046
 2046  TEMP =        FR(10,II)*H5(1,2,3)
 2047  IF(JSIX(11))2048,2049,2048
 2048  TEMP = TEMP + FR(11,II)*H5(1,3,2)
 2049  IF(JSIX(14))2050,2051,2050
 2050  TEMP = TEMP + FR(14,II)*H5(2,1,3)
 2051  IF(JSIX(16))2052,2053,2052
 2052  TEMP = TEMP + FR(16,II)*H5(3,1,2)
 2053  IF(JSIX(20))2054,2055,2054
 2054  TEMP = TEMP + FR(20,II)*H5(2,3,1)
 2055  IF(JSIX(21))2056,2057,2056
 2056  TEMP = TEMP + FR(21,II)*H5(3,2,1)
 2057  CUM6 = CUM6 + TEMP*60.
       IF(JSIX(15))2058,2059,2058
 2058  CUM6 = CUM6 + FR(15,II)*H6(1,2,3)*90.
 2059  RANK6= CUM6*1.E-6
C
       RETURN
       END
                          SUBROUTINE JOHN
     &  (W,Q,ITHREE,JTHREE,CR,IFOUR,JFOUR,DR,ALF,II,CUM3,CUM4,NORM)
C
C     THIS ROUTINE CALCULATES THE FOURIER TRANSFORM OF THE  STRUCTURE
C     FACTOR  BASED ON THE  ALPHA FORMALISM.  THIS  STRUCTURE  FACTOR
C     EQUATION IS IN THE PROGRAMME SYSTEM PROMETHEUS CALLED  MODIFIED
C     GRAM-CHARLIER SERIES EXPANSION. (MODEL NO. FOUR)
C     THE FOURIER TRANSFORM HAD BEEN PUBLISHED BY JOHNSON IN  THE OAK
C     RIDGE REPORT 1980  DOE/TIC-11068 THEME=THERMAL MOTION ANALYSIS.
C     THE EQUATION (9) OF THIS REPORT IS INCORRECTLY NORMALIZED. THIS
C     WILL BE DONE HERE IN ADDITION. THE FOURIER TRANSFORM ARE RECAL-
C     CULATED BY THE AUTHOR OF THIS PROGRAMME AND FIND TO BE CORRECT.
C
C                    UDO ZUCKER  NOVEMBER 1980
C
C     IN THE ROUTINE 3 QUANTITYS WILL BE CALCULATED. CUM3,CUM4,NORM.
C
      REAL NORM
C
      DIMENSION W(3),Q(3,3),CR(10,60),DR(15,60),JTHREE(10),JFOUR(15)
C
      W1    =  W(1)
      W2    =  W(2)
      W3    =  W(3)
      W11   = W1*W1
      W22   = W2*W2
      W33   = W3*W3
C
C---- NORM IS A REAL VAIABLE WHICH CARRIES INFO. ABOUT NORMALIZATION
C
C---- THE VARIABLE ALPHA OF THE PROGRAMME SYSTEM PROMETHEUS IS ONE
C     HALF OF THE VARIABLE ALPHA BY JOHNSON. HERE A WILL BE SET TO
C     TWO ALF, TO USE THE FORMULAS BY JOHNSON. (Y  HAS BEEN REPLA-
C     CED BY  W  TO BE CONSISTENT WITH INTERNATIONAL TABLES OF X -
C     RAY CRYSTALLOGRAPHY NO.4)
C
      A     = 2.*ALF
      OMA   = 1.-A
      OMAQ2 = OMA**2
C
C---- NO THIRD ORDER PRODUCT,IF ITHREE EQUAL ZERO.
C
      IF(ITHREE.EQ.0) GOTO 3000
C
C---- INITIALIZE
C
      TERM  = 0.
      TERMZ = 0.
C
      IF(JTHREE(1))1,2,1
    1 TERM1 = W11*W1
      TERM2 = 3.*W1*Q(1,1)*OMA
      TERM  = (TERM1-TERM2)*CR(1,II)
    2 IF(JTHREE(2))3,4,3
    3 TERM1 = W22*W2
      TERM2 = 3.*W2*Q(2,2)*OMA
      TERM  = TERM + (TERM1-TERM2)*CR(2,II)
    4 IF(JTHREE(3))5,6,5
    5 TERM1 = W33*W3
      TERM2 = 3.*W3*Q(3,3)*OMA
      TERM  = TERM + (TERM1-TERM2)*CR(3,II)
    6 IF(JTHREE(4))7,8,7
    7 TERM1 = W11*W2
      TERM2 = (2.*W1*Q(1,2)+W2*Q(1,1))*OMA
      TERMZ = (TERM1-TERM2)*CR(4,II)
    8 IF(JTHREE(5))9,10,9
    9 TERM1 = W22*W1
      TERM2 = (W1*Q(2,2)+2.*W2*Q(1,2))*OMA
      TERMZ = TERMZ + (TERM1-TERM2)*CR(5,II)
   10 IF(JTHREE(6))11,12,11
   11 TERM1 = W11*W3
      TERM2 = (2.*W1*Q(1,3)+W3*Q(1,1))*OMA
      TERMZ = TERMZ + (TERM1-TERM2)*CR(6,II)
   12 IF(JTHREE(7))13,14,13
   13 TERM1 = W1*W33
      TERM2 = (W1*Q(3,3)+2.*W3*Q(1,3))*OMA
      TERMZ = TERMZ + (TERM1-TERM2)*CR(7,II)
   14 IF(JTHREE(8))15,16,15
   15 TERM1 = W22*W3
      TERM2 = (2.*W2*Q(2,3)+W3*Q(2,2))*OMA
      TERMZ = TERMZ + (TERM1-TERM2)*CR(8,II)
   16 IF(JTHREE(9))17,18,17
   17 TERM1 = W2*W33
      TERM2 = (W2*Q(3,3)+2.*W3*Q(2,3))*OMA
      TERMZ = TERMZ + (TERM1-TERM2)*CR(9,II)
   18 TERM  = TERM + TERMZ*3.0
      TERMZ = 0.0
      IF(JTHREE(10))19,20,19
   19 TERM1 = W1*W2*W3
      TERM2 = (W1*Q(2,3)+W2*Q(1,3)+W3*Q(1,2))*OMA
      TERMZ = (TERM1-TERM2)*CR(10,II)*6.0
   20 CUM3  = TERM + TERMZ
      CUM3  = CUM3 * 1.E-3
C
C---- IF IFOUR=0 FOURTH RANK PRODUCTS ARE NOT REQUIRED.
C
 3000 IF(IFOUR.EQ.0) GOTO 4000
C
      TERM  = 0.
      TERMZ = 0.
C
      IF(JFOUR(1))101,102,101
  101 TERM1 = W11*W11
      TERM2 = 6.*W11*Q(1,1)*OMA
      TERM3 = 3.*Q(1,1)**2
      NORM  = TERM3*DR(1,II)
      TERM3 = TERM3*OMAQ2
      TERM  = (TERM1-TERM2+TERM3)*DR(1,II)
  102 IF(JFOUR(2))103,104,103
  103 TERM1 = W22*W22
      TERM2 = 6.*W22*Q(2,2)*OMA
      TERM3 = 3.*Q(2,2)**2
      NORM  = NORM + TERM3*DR(2,II)
      TERM3 = TERM3*OMAQ2
      TERM  = TERM + (TERM1-TERM2+TERM3)*DR(2,II)
  104 IF(JFOUR(3))105,106,105
  105 TERM1 = W33*W33
      TERM2 = 6.*W33*Q(3,3)*OMA
      TERM3 = 3.*Q(3,3)**2
      NORM  = NORM + TERM3*DR(3,II)
      TERM3 = TERM3*OMAQ2
      TERM  = TERM + (TERM1-TERM2+TERM3)*DR(3,II)
  106 IF(JFOUR(4))107,108,107
  107 TERM1 = W11*W1*W2
      TERM2 = (W11*Q(1,2)*3.+W1*W2*Q(1,1)*3.)*OMA
      TERM3 = 3.*Q(1,1)*Q(1,2)
      NORM  = NORM + TERM3*DR(4,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = (TERM1-TERM2+TERM3)*DR(4,II)
  108 IF(JFOUR(5))109,110,109
  109 TERM1 = W11*W1*W3
      TERM2 = (W11*Q(1,3)*3.+W1*W3*Q(1,1)*3.)*OMA
      TERM3 = 3.*Q(1,1)*Q(1,3)
      NORM  = NORM + TERM3*DR(5,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(5,II)
  110 IF(JFOUR(9))111,112,111
  111 TERM1 = W22*W2*W1
      TERM2 = (W22*Q(1,2)*3.+W2*W1*Q(2,2)*3.)*OMA
      TERM3 = 3.*Q(2,2)*Q(1,2)
      NORM  = NORM + TERM3*DR(9,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(9,II)
  112 IF(JFOUR(12))113,114,113
  113 TERM1 = W33*W3*W1
      TERM2 = (W33*Q(1,3)*3.+W1*W3*Q(3,3)*3.)*OMA
      TERM3 = 3.*Q(3,3)*Q(1,3)
      NORM  = NORM + TERM3*DR(12,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(12,II)
  114 IF(JFOUR(13))115,116,115
  115 TERM1 = W22*W2*W3
      TERM2 = (W22*Q(2,3)*3.+W2*W3*Q(2,2)*3.)*OMA
      TERM3 = 3*Q(2,2)*Q(2,3)
      NORM  = NORM + TERM3*DR(13,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(13,II)
  116 IF(JFOUR(15))117,118,117
  117 TERM1 = W33*W3*W2
      TERM2 = (W33*Q(2,3)*3.+W2*W3*Q(3,3)*3.)*OMA
      TERM3 = 3.*Q(3,3)*Q(2,3)
      NORM  = NORM + TERM3*DR(15,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(15,II)
  118 TERM  = TERM + TERMZ*4.0
      TERMZ = 0.0
      IF(JFOUR(6))119,120,119
  119 TERM1 = W11*W22
      TERM2 = (W11*Q(2,2)+4.*W1*W2*Q(1,2)+W22*Q(1,1))*OMA
      TERM3 = Q(1,1)*Q(2,2)+2.*Q(1,2)**2
      NORM  = NORM + TERM3*DR(6,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = (TERM1-TERM2+TERM3)*DR(6,II)
  120 IF(JFOUR(8))121,122,121
  121 TERM1 = W11*W33
      TERM2 = (W11*Q(3,3)+4.*W1*W3*Q(1,3)+W33*Q(1,1))*OMA
      TERM3 = Q(1,1)*Q(3,3)+2.*Q(1,3)**2
      NORM  = NORM + TERM3*DR(8,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(8,II)
  122 IF(JFOUR(14))123,124,123
  123 TERM1 = W33*W22
      TERM2 = (W33*Q(2,2)+4.*W3*W2*Q(2,3)+W22*Q(3,3))*OMA
      TERM3 = Q(3,3)*Q(2,2)+2.*Q(2,3)**2
      NORM  = NORM + TERM3*DR(14,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(14,II)
  124 TERM  = TERM + TERMZ*6.0
      TERMZ =0.0
      IF(JFOUR(10))125,126,125
  125 TERM1 = W22*W3*W1
      TERM2 = (W22*Q(1,3)+2.*W2*W3*Q(1,2)+2.*W2*W1*Q(2,3) +
     &        W3*W1*Q(2,2)) *OMA
      TERM3 = Q(2,2)*Q(1,3)+2.*Q(2,3)*Q(1,2)
      NORM  = NORM + TERM3*DR(10,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = (TERM1-TERM2+TERM3)*DR(10,II)
  126 IF(JFOUR(11))127,128,127
  127 TERM1 = W1*W2*W33
      TERM2 = (W1*W2*Q(3,3)+W2*W3*Q(1,3)*2.+W33*Q(1,2) +
     &        2.*W1*W3*Q(2,3)) *OMA
      TERM3 = Q(1,2)*Q(3,3)+2.*Q(1,3)*Q(2,3)
      NORM  = NORM + TERM3*DR(11,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(11,II)
  128 IF(JFOUR(7))129,130,129
  129 TERM1 = W11*W2*W3
      TERM2 = (W11*Q(2,3)+2.*W1*W2*Q(1,3)+2.*W1*W3*Q(1,2) +
     &        W2*W3*Q(1,1)) *OMA
      TERM3 = Q(1,1)*Q(2,3)+2.*Q(1,2)*Q(1,3)
      NORM  = NORM + TERM3*DR(7,II)
      TERM3 = TERM3*OMAQ2
      TERMZ = TERMZ + (TERM1-TERM2+TERM3)*DR(7,II)
  130 CUM4  = TERM + TERMZ*12.0
      CUM4  = CUM4 * 1.E-4
C
C
      NORM = NORM * A*A / 24. * 1.E-4
C
C
 4000 RETURN
      END
C
C
C
                         SUBROUTINE PLANE
     &(P1,P2,P3,IX,IY,IXI,IXF,IYI,IYF,ITYPE,G,X,Y,Z,AGA,BGB,IERR)
C
C     THIS  PROGRAMME CALCULATES THE UNIT VECTORS OF A SPECIAL  PLANE
C           DEFINED BY THREE POINTS AND A GRID COORDINATES.
C
C                   BY   ROLF BACHMANN   DEC. 1980
C
C
C                         STUTTGART  FRG
C
C
C----INPUT    THREE  POINTS P1,P2,P3, THE GRID IX*IY
C             LIMITS OF THE PLANE IXI, IXF, IYI, IYF
C             TYPE ITYPE, AND THE METRIC G
C----OUTPUT   ORIGIN  FOR THE PLANE, X, Y, Z, LENGTHS AGA, BGB
C             IERR, IF THE THREE POINTS LIE ON A STRAIGHT LINE
C
      DIMENSION P1(3),P2(3),P3(3),A(3),B(3),G(3,3)
C
      COMMON /IWRITE/AL,BL,CL,CAL,CBE,CGA,AM(3),C,CD,ALANG,BLANG,IL,ILY
      COMMON /APLANE/AA(3),AB(3),AIX,AIY
C
C---- CALCULATING CELL CONSTANTS FROM G
C
      AL=SQRT(G(1,1))
      BL=SQRT(G(2,2))
      CL=SQRT(G(3,3))
      CAL=ACOS(G(2,3)/BL/CL)*57.295779
      CBE=ACOS(G(1,3)/AL/CL)*57.295779
      CGA=ACOS(G(1,2)/AL/BL)*57.295779
C
C---- VECTOR A=P2-P1, VECTOR B=P3-P1
C
      DO 10 I=1,3
      A(I)=P2(I)-P1(I)
   10 B(I)=P3(I)-P1(I)
C
C---- PRODUCT OF VECTORS A*A, A*B, B*B
C
      AGB=XGY(A,G,B)
      AGA=XGY(A,G,A)
      BGB=XGY(B,G,B)
      ALANG=SQRT(AGA)
C
C---- ARE THE POINTS LINEAR DEPENDENT?
C
      IF((AGA*BGB).LT.1.E-5)GOTO 20
C
C---- CALCULATING THE ANGLE BETWEEN A AND B, IF THE COSINE
C---- IS VERY CLOSE TO OR 1 -1 IERR=1
C
      CD= AGB/SQRT(AGA*BGB)
      C=ABS(CD)-1.
      IF(C.LT.-1.E-5)GOTO 30
   20 IERR=1
      RETURN
C
C---- THE VECTOR PERPENDICULAR TO P1-P2 THROUGH P3 IS CALCULATED
C
   30 C=AGB/AGA
      DO 40 I=1,3
   40 AM(I)=B(I)-A(I)*C
C
C---- IF P3 IS CENTERPOINT DOUBLE AM, AM IS THE Y AXIS OF THE PLANE
C
      IF(ITYPE.NE.1)GOTO 60
      DO 50 I=1,3
   50 AM(I)=AM(I)*2
C
C---- CALCULATING UNIT VECTORS
C
   60 DO 70 I=1,3
      AA(I)=AM(I)
   70 AB(I)=A(I)
      AIX=FLOAT(IX)
      AIY=FLOAT(IY)
      IL=IX
      ILY=IY
      AGA=SQRT(AGA)
      BGB=SQRT(XGY(AM,G,AM))
      BLANG=BGB
C
C---- ORIGIN OF THE PLANE
C
      AIXI=FLOAT(IXI)/AIX
      AIYI=FLOAT(IYI)/AIY
      X=P1(1)+A(1)*AIXI+AM(1)*AIYI
      Y=P1(2)+A(2)*AIXI+AM(2)*AIYI
      Z=P1(3)+A(3)*AIXI+AM(3)*AIYI
      RETURN
      END
C
C
                          SUBROUTINE SRBPLA
     &      (P1,P2,P3,X,Y,Z,IOUT,IERR,ITYPE,PP,IX,IY,IA,MARK)
C
C
C     THIS  PROGRAMM  WRITES THE  CONSTANTS  OF THE PLANE, CALCULATED
C     BY THE SUROUTINE PLANE, AS WELL AS THE CELL CONSTANTS AND G. IT
C     DOES ALSO GIVE YOU A ROUGH SKETCH OF HOW P1, P2 AND P3  LIE  IN
C     THIS PLANE AND  WRITES THEIR  FRACTIONAL  COORDINATES,  IT ALSO
C     SHOWS YOU THE POSITION OF AN ATOM.
C
C                  BY ROLF BACHMANN  DECEMBER 1980
C
C     INPUT      THE  ORIGIN OF THE PLANE  X,Y,Z,THE POINTS P1,P2,P3
C                OUTPUTUNIT IOUT, IERR IF P1, P2,P3 LIE ON A STRAIGT
C                LINE. ITYPE SPECIFIES THE TYPE OF THE DESIRED PLANE
C                THE GRID IX*IY,  PP THE GRID COORDINATES OF AN ATOM
C                AND  IA IF YOU WANT  THE ATOM TO BE DRAWN.  ALNU IS
C                JUST AN OUTPUT ARRAY. MARK=0/1 DO NOT/DO REDUCE
C
C                OUTPUT.
C
C---- ALNU IS EQUIVALENT TO ANOTHER ARRAY NOT USED AT THE MOMENT.
C
C
      DIMENSION ALNU(80,22),P1(3),P2(3),P3(3),PP1(2),PP2(2),PP3(2)
      DIMENSION PP(3),NAME(2)
C
      COMMON /IWRITE/AL,BL,CL,CAL,CBE,CGA,AM(3),C,CD,ALANG,BLANG,IL,ILY
      COMMON /APLANE/FF(3),FG(3),AIX,AIY
      COMMON /BACH/POINT(3),RADIUS,IOVERL,ARRAY(39995)
C
      EQUIVALENCE (ARRAY,ALNU)
C
      DATA AI,AB,AS,AP,AMI,AP1,AP2 /1HI,1H ,1H*,1HP,1H-,1H1,1H2/
      DATA ASS,AYY,AXX,AA,AP3 /1HS,1HY,1HX,1HA,1H3/
      DATA AMM,ATT,AOO,NAME /1HM,1HT,1HO,8H CORNER ,8H CENTER /
C
   11 FORMAT(1X//////6H ERROR//31H VECTORS DEFINING THE PLANE ARE,
     & 17H LINEAR DEPENDENT/34H ALL POINTS LIE ON A STRAIGHT LINE
     & //13H TAKE ANOTHER,14H SET OF POINTS)
   12 FORMAT(11H0   A=     ,3F10.4,10H   B=     ,3F10.4)
   13 FORMAT(28H0 VECTORS SPANNING THE PLANE)
   14 FORMAT(16H0 CELL CONSTANTS//5X,1HA,9X,1HB,9X,1HC,26X,
     &5HALPHA,6X,4HBETA,7X,5HGAMMA//1X,3F10.4,2X,10HANGSTROEMS,5X,
     &3F11.4,2X,7HDEGREES)
   15 FORMAT(21H0 ORIGIN OF THE PLANE//1X,3F10.4)
   16 FORMAT(34H0 AREA OF THE PLANE LENGTH * WIDTH//1X,F10.4
     &,5H    *,F10.4)
   17 FORMAT(1H0,27H  POINTS DEFINING THE PLANE//
     &30H     IN FRACTIONAL COORDINATES,19X,19HIN GRID COORDINATES//
     &1X,3(3F10.4,15X,2F10.4,7X,A8,2X,6HPOINT //1X))
   18 FORMAT(23H0 PLOT OF DEFINED PLANE//22(3X,80A1/))
   19 FORMAT(28H1PARAMETERS OF SPECIAL PLANE/1X,27(1H-)//)
   22 FORMAT(1H0,//1X,44H  PDFS OF SYMMETRICALLY EQUIVALENT ATOMS ARE,
     &18H CALCULATED AROUND,//35H     POINT (FRACTIONAL COORDINATES),
     &14X,12H WITH RADIUS,//1X,3F10.4,15X,F10.4,2X,10HANGSTROEMS)
   23 FORMAT(1H0,49H  ALL PDFS ARE COMBINED TO AN OVERALL PROBABILITY,
     &8H DENSITY)
C
      WRITE(IOUT,19)
C
      IF(IERR.EQ.0)GOTO 290
      WRITE(IOUT,11)
      CALL EXIT
C
  290 PP1(1)=0.
      PP1(2)=0.
      PP2(1)=FLOAT(IL)
      PP2(2)=0.
      PP3(2)=FLOAT(ILY)
      IF(ITYPE.EQ.1)PP3(2)=FLOAT(ILY)*0.5
      PP3(1)=C*FLOAT(IL)
C
      II1=IP1
      DO 300 N=1,21
      DO 300 M=2,80
  300 ALNU(M,N)=AB
      DO 400 N=1,22
  400 ALNU(1,N)=AI
      DO 500 M=1,80
  500 ALNU(M,22)=AMI
      ALNU(3,1)=AYY
      ALNU(5,1)=AA
      ALNU(6,1)=AXX
      ALNU(7,1)=AI
      ALNU(8,1)=ASS
      ALNU(71,21)=AXX
      ALNU(73,21)=AA
      ALNU(74,21)=AXX
      ALNU(75,21)=AI
      ALNU(76,21)=ASS
      II=3
      IF(ITYPE.EQ.1)II=11
      IF(C.LT.1)GOTO 600
      DO 510 N=3,19
      IP2=IFIX(60./C)+10
      ALNU(IP2,N)=AS
  510 ALNU(10,N)=AS
      DO 530 N=10,IP2
      ALNU(N,3)=AS
  530 ALNU(N,19)=AS
      ALNU(70,II)=AP
      ALNU(71,II)=AP3
      ALNU(10,19)=AP
      II1=10
      ALNU(11,19)=AP1
      ALNU(12,19)=AB
      ALNU(IP2,19)=AP
      ALNU(IP2+1,19)=AP2
      ALNU(IP2-1,19)=AB
      GOTO 800
  600 IF(CD.GT.0.)GOTO 700
      IP1=IFIX(60./(1.-C))
      IP1=70-IP1
      DO 610 N=IP1,70
      ALNU(N,19)=AS
  610 ALNU(N,3)=AS
      DO 620 N=3,19
      ALNU(IP1,N)=AS
  620 ALNU(70,N)=AS
      ALNU(10,II)=AP
      ALNU(11,II)=AP3
      ALNU(IP1,19)=AP
      II1=IP1
      ALNU(IP1+1,19)=AP1
      ALNU(IP1+2,19)=AB
      ALNU(70,19)=AP
      ALNU(71,19)=AP2
      ALNU(69,19)=AB
      GOTO 800
  700 IP3=IFIX(C*60.)+10
      DO 710 N=10,70
      ALNU(N,3)=AS
  710 ALNU(N,19)=AS
      DO 720 N=3,19
      ALNU(10,N)=AS
  720 ALNU(70,N)=AS
      ALNU(IP3-1,II)=AB
      ALNU(IP3,II)=AP
      ALNU(IP3+1,II)=AP3
      ALNU(IP3+2,II)=AB
      ALNU(10,19)=AP
      II1=10
      ALNU(11,19)=AP1
      ALNU(12,19)=AB
      ALNU(70,19)=AP
      ALNU(71,19)=AP2
      ALNU(69,19)=AB
C
  800 IF(IA.EQ.0)GOTO900
      XX=PP(1)/FLOAT(IX)*FLOAT(IP2-II1)
      IP1=IFIX(XX)
      YY=PP(2)/FLOAT(IY)*19.
      IP2=IFIX(YY)
      IP1=II1+IP1
      IP2=19-IP2
C     ALNU(IP1-2,IP2)=AA
C     ALNU(IP1-1,IP2)=ATT
C     ALNU(IP1,IP2)=AOO
C     ALNU(IP1+1,IP2)=AMM
C
  900 IF(MARK.NE.0) GOTO 901
      WRITE(IOUT,14)AL,BL,CL,CAL,CBE,CGA
      WRITE(IOUT,17)P1,PP1,NAME(1),P2,PP2,NAME(1),P3,PP3,
     & NAME(ITYPE+1)
      WRITE(IOUT,15)X,Y,Z
      WRITE(IOUT,16)ALANG,BLANG
      WRITE(IOUT,13)
      WRITE(IOUT,12)FG,AM
      IF(IOVERL.GT.0)WRITE(IOUT,22)POINT,RADIUS
      IF(IOVERL.EQ.2)WRITE(IOUT,23)
  901 WRITE(IOUT,18)ALNU
      RETURN
      END
C
C
      SUBROUTINE CORD(IXI,IXF,IYI,IYF,I,X,Y,Z,PIJ1,PIJ2,PIJ3)
C
C     SUBROUTINE CALCULATES COORDINATES OF SPECIAL PLANE  DEFINED
C                       BY ROUTINE PLANE.
C
C              BY ROLF BACHMANN    DECEMBER 1980
C
C
C     INPUT   THE  GRID  (IXF-IXI) * (IYF-IYI),  AN  INDEX I
C             THE  ORIGIN  OF  THE  PLANE  X,Y,Z
C     OUTPUT  THE COORDINATES OF  POINT PIJ PIJ1, PIJ2, PIJ3
C
      COMMON /APLANE/AB(3),AA(3),AIX,AIY
C
C---- NUMBER OF POINTS IN X, Y DIRCTION
C
      IX=IXF-IXI
      IY=IYF-IYI
C
C
C---- CALCULATES GRID COORDINATES
C
      IX1=MOD(I,(IX+1))
      C=FLOAT(I)/FLOAT(IX+1)
      IY1=INT(C)
      AX=FLOAT(IX1)/AIX
      AY=FLOAT(IY1)/AIY
C
C---- THE COORDINATES IN FRACTIONS
C
      PIJ1=X+AX*AA(1)+AY*AB(1)
      PIJ2=Y+AX*AA(2)+AY*AB(2)
      PIJ3=Z+AX*AA(3)+AY*AB(3)
C
C---- INDEX=INDEX+1
C
      I=I+1
C
      RETURN
      END
C
      FUNCTION XGY(X,G,Y)
C
      DIMENSION X(3),Y(3),G(3,3)
C
C ----SCALAR PRODUCT OR TWO VECTORS
C
      XGY=X(1)*(G(1,1)*Y(1)+G(1,2)*Y(2)+G(1,3)*Y(3))+
     &    X(2)*(G(2,1)*Y(1)+G(2,2)*Y(2)+G(2,3)*Y(3))+
     &    X(3)*(G(3,1)*Y(1)+G(3,2)*Y(2)+G(3,3)*Y(3))
      RETURN
      END
C
      SUBROUTINE ATOPLA(P1,P2,P3,ATO,IX,IY,G,PP)
C
C     PROGRAMME FOR  DETERMINIG THE  POSITION OF AN ATOM WITHIN
C     A SPECIAL PLANE
C
C                BY ROLF BACHMANN    DECEMBER 1980
C
C     INPUT    THREE  POINTS  DEFINING  THE PLANE  P1,P2,P3,THE
C              FRACTIONAL  COORDINATES  OF THE ATOM,  THE  GRID
C              IX*IY AND THE METRIC G
C     OUTPUT   A VECTOR PP GIVING  THE GRID  COORDINATES OF THE
C              ATOM AND ITS DISTANCE  FROM THE PLANE
C
      DIMENSION G(3,3),P1(3),P2(3),P3(3),ATO(3),E(3),C(3),PP(3)
      DIMENSION A(3)
C
      COMMON /APLANE/B(3),AB(3),AIX,AIY
C
C ----VECTOR C=ATO-P1,A=P2-P1
C
      A(1)=P2(1)-P1(1)
      A(2)=P2(2)-P1(2)
      A(3)=P2(3)-P1(3)
      C(1)=ATO(1)-P1(1)
      C(2)=ATO(2)-P1(2)
      C(3)=ATO(3)-P1(3)
C
C ----NORMAL VECTOR OF THE PLANE
C
      PP(1)=XGY(A,G,C)/(XGY(A,G,A))
      PP(2)=XGY(B,G,C)/(XGY(B,G,B))
      E(1)=C(1)-PP(1)*A(1)-PP(2)*B(1)
      E(2)=C(2)-PP(1)*A(2)-PP(2)*B(2)
      E(3)=C(3)-PP(1)*A(3)-PP(2)*B(3)
C
C ----GRID COORDINATES OF THE ATOM AND DISTANCE TO THE PLANE
C
      PP(1)=XGY(A,G,C)/XGY(A,G,A)*FLOAT(IX)
      PP(2)=XGY(B,G,C)/XGY(B,G,B)*FLOAT(IY)
      PP(3)=SQRT(XGY(E,G,E))
C
      RETURN
      END
