C      PROGRAM PLOTTE(EINPL  ,OUTPUT,ZZZG67,TAPE8=EINPL  ,
C     &TAPE6=OUTPUT,TAPE67=ZZZG67,TAPE11,TAPE12)
CX    SUBROUTINE PLOTTE
C           ROUTINE ZUR PROMETHEUS-VERSION STUTTGART/81
C           FUER LRZ-GRAPHIK GESCHRIEBEN VON R.ROSSMANN 8/89
C           GEAENDERT FUER RECHTSSYSTEM H.BOYSEN IM AUGUST 92
C-------------------------------------------------------------------------------
C
      DIMENSION  HS(50),HD(50),LPEN(50)
      DIMENSION  XL(50),YL(50),SL(50),JL(50)
      DIMENSION  XLI1(50),YLI1(50),XLI2(50),YLI2(50),JLI(50),LEV(50)
      DIMENSION  XK(50),YK(50),SK(50),KTYP(50),JK(50)
      DIMENSION  KURS(18),TITEL(3),AXIS(3)
      DIMENSION  C(350000),AXPKTX(501),AXPKTY(501)
C
      INTEGER NH(200)
C --- BMAXA,HMAXA: Breite und Hoehe des verfuegbaren Blattes
      REAL BMAXA,HMAXA
      REAL HSN(200)
C
      CHARACTER*1 BLNK
      CHARACTER*2 BX,BY
      CHARACTER*3 LINT(3),LITY(50),PROF
      CHARACTER*4 IPDF,IMUL,IFOUR,IARS,IENDE,KOPF1(12),KOPF2(12)
     &            ,IWAEHL,LH(50)
      CHARACTER*8 LABEL(50)
      CHARACTER*48 TITELP
C     CHARACTER*72 KURS
C
      COMMON /ALL/INN,IOUT
      COMMON /AUSG/TITEL,BX,BY,A,B,F
      COMMON /HOEH/SALF,CALF,D
      COMMON /HOHE/NA,NB,MX,MY,AXPKTX,AXPKTY,C,INTER
C
      DATA INN,IOUT/8,6/
CT    DATA IPDF,IMUL,IFOUR,IARS,IENDE
CT   &     /'PDFM','MULP','FOUR','ARBS','ENDE'/
      DATA BLNK,INF1,INF2/' ',11,12/
CT    DATA TITELP,/'    '/
      DATA LINT/'-F','.F','- F'/
      DATA BMAXA,HMAXA,SH/19.,27.,.6/
C
      OPEN(8,FILE="einpl")
      OPEN(67,FILE="ZZZG67")
      OPEN(11,FILE="ftn11",FORM="UNFORMATTED")
      OPEN(12,FILE="ftn12",FORM="UNFORMATTED")
C
C SH: Schrifthoehe des Titels in cm
      DATA MAXIMA/250000/
C                              MAXIMA  =  DIMENSION DES FELDES IC.
C     ! DIE DIMENSION VON AXPKT MUSS MINDESTENS BETRAGEN : SQRT(MAXIMA)
      BMAX=BMAXA-3.
      HMAX=HMAXA-7.
C************      LIES STEUERKARTE EIN.      *********************************
    1 READ(INN,*)IWAEHL,INRFIL,IFRAC,NRCROS
C
C************      EINGABE-EINHEIT     ?      *********************************
      IF(IWAEHL.EQ.'ENDE')                      GOTO 650
      IF(IWAEHL.EQ.'FOUR' .OR. IWAEHL.EQ.'PDFM'
     &                   .OR. IWAEHL.EQ.'MULP') IFILE=11
      IF(IWAEHL.EQ.'ARBS')                      IFILE=12
      IF(INRFIL.GT.0)  IFILE=INRFIL
          IF (IFILE.EQ.0) THEN
          WRITE(IOUT,*)'KEINE EINGABEEINHEIT SPEZIFIZIERT, IWAEHL=',IWAEHL
          GOTO 650
          END IF
C************         TITEL DES PLOTS         *********************************
      READ(INN,*) TITELP
      WRITE(IOUT,2001) TITELP
C************          LAYOUT - CARD          *********************************
      READ (INN,*) F,INTER,IGV,NCONT,NLABL,NLINE,NCROS
      WRITE(IOUT,2003)F,INTER,NCONT,NLABL,NLINE,NCROS
C************     HOEHENLINIEN - KARTE        *********************************
      READ (INN,*) HANF,HEND,DH,PROF,ISPEZ,HAMIN,HAMAX
      WRITE (IOUT,*) 'HOEHENLINIEN VON ',HANF,' BIS ',HEND
      WRITE (IOUT,*) 'ABSTAND ZWISCHEN DEN LINIEN: ',DH,'  ',PROF
C************ SPEZIELLE HOEHENLINIEN - KARTEN *********************************
      IF (NCONT.LE.0) GOTO 30
      IF (NCONT.GT.50) THEN
        WRITE (IOUT,*) 'ZU VIELE SPEZIELLE HOEHENLINIEN!'
        GOTO 600
      END IF
      WRITE (IOUT,*) 'SPEZIELLE HOEHENLINIEN BEI:'
      DO 21 I=1,NCONT
      READ(INN,*) HS(I),HD(I),LH(I),LPEN(I)
   21 WRITE(IOUT,*) HS(I)
C************           LABEL  CARDS          *********************************
   30 IF (NLABL.LE.0) GOTO 40
      IF (NLABL.GT.50) THEN
        WRITE (IOUT,*) 'ZU VIELE LABELS GEWAEHLT!'
        GOTO 600
      END IF
      WRITE (IOUT,*) 'LABELS BEI:'
      DO 31 I=1,NLABL
      READ (INN,*) XL(I),YL(I),SL(I),LABEL(I)
   31 WRITE (IOUT,*)XL(I),'  ',YL(I),'  ',SL(I),'  ',LABEL(I)
C************       LINE-DRAWING  CARDS       *********************************
   40 IF (NLINE.LE.0) GOTO 50
      IF (NLINE.GT.50) THEN
        WRITE (IOUT,*) 'ZU VIELE LINIEN GEWAEHLT!'
        GOTO 600
      END IF
      WRITE (IOUT,*) 'LINIEN VON      BIS:'
      DO 41 I=1,NLINE
      READ (INN,*) XLI1(I),YLI1(I),XLI2(I),YLI2(I),LITY(I),LEV(I)
   41 WRITE (IOUT,*)XLI1(I),'  ',YLI1(I),'  ',XLI2(I),'  ',YLI2(I)
C************           CROSS  CARDS          *********************************
   50 IF (NCROS.LE.0) GOTO 60
      IF (NCROS.GT.50) THEN
        WRITE (IOUT,*) 'ZU VIELE KREUZE GEWAEHLT!'
        GOTO 600
      END IF
      WRITE (IOUT,*) 'KREUZE BEI:'
      DO 51 I=1,NCROS
      READ (INN,*) XK(I),YK(I),SK(I),KTYP(I)
   51 WRITE (IOUT,*)XK(I),'  ',YK(I),'  ',SK(I),'  ',KTYP(I)
C************         SECTION  CARD           *********************************
   60 READ(INN,*) ISA,ISE,IDS
C-------- Schreibe, welche Sectionen gewaehlt wurden!
      WRITE(IOUT,2008) ISA,IDS,ISE
C-----------------------------------------------------------------------------
C>>>>>>>>>>>>   LIES DATEN FUER 1. SECTION UND BEREITE PLOT VOR   <<<<<<<<<<<<
C
      IERST=0
      REWIND IFILE
C**************************************************       INPUT-FILE I     *****
      READ(IFILE,END=1,ERR=640)TITEL,KURS,AXIS,AG,BG,CG,JACHS
      WRITE (IOUT,*) 'ERSTES MAL EINLESEN:'
      WRITE (IOUT,1020) TITEL
      WRITE (IOUT,1030) KURS
 1020 FORMAT(/6HTITEL /3A4/)
 1030 FORMAT(/6HKURS  /18A4/)
      WRITE (IOUT,*) AXIS,' ',AG,' ',BG,' ',CG,' ',JACHS
C
C   * STETS  TITEL(3)  REFINE TITEL.
C   *        KURS(18)  18A4 TITEL DES FOURIER,ARBSEC,PDFMAP PROGRAMMS.
C   * QUELLE FOURIER ODER PDFMAP :--AXIS(3) A,B,C GITTERKONSTANTE.
C   *                               AG,BG,CG ALPHA,BETA,GAMMA WINKEL.
C   * QUELLE ARBSEC :-------------- AXIS(3) NULLEN!
C   *                               AG=TRANS. X-ACHSE, BG=TRANS. Y-
C   *                               ACHSE. CG= WINKEL ZWISCHEN DEN
C   *                               ACHSEN.
C
C**************************************************       INPUT-FILE II    *****
    2 READ(IFILE,END=1,ERR=640)NA,NB,KIZ,KNZ,IA,IAI,IAF,IB,IBI,IBF
      WRITE (IOUT,*) 'ZWEITES MAL EINLESEN:'
      WRITE (IOUT,*) NA,' ',NB,' ',KIZ,' ',KNZ
      WRITE (IOUT,*) IA,' ',IAI,' ',IAF
      WRITE (IOUT,*) IB,' ',IBI,' ',IBF
C
C   * NA,NB : PUNKTE AUF DER 1.TEN, BZW. 2.TEN ACHSE
C   * KIZ :NUMMER DER SECTION : SCHNITTHOEHE*KNZ  FUER FOURIE
C                                              1  FUER JOINT PDF
C       IM ERZEUGENDEN PROGR. WILLKUERLICH ANGEG.  FUER ARBSEC
C   * KNZ : UNTERTEILUNG DER 3. ACHSE
C   * IA,IAI,IAF,IB,IBI,IBF : 1./2.TE ACHSE: UNTERTEILUNG, ANFANGS-, ENDWERT
C
C-------- SCHREIBE EINHEIT DER 3. ACHSE HERAUS
      WRITE(IOUT,2201)KNZ
C-------- BERECHNE SPEICHERPLATZANFORDERUNG, VERGLEICHE MIT BESTAND.
C         DIE SUBROUTINE BICUB BENOETIGT NTOT*4 PLAETZE ALS ARBEITSSPEICHER.
      NTOT=NA*NB
         WRITE(IOUT,2202) NTOT,(NTOT*4),MAXIMA
         IF((NTOT - MAXIMA).GT.0) CALL EXIT
         IF(NCP.GT.1.AND.(NTOT*4-MAXIMA).GT.0) CALL EXIT
C
C**************************************************       INPUT-FILE III   *****
      READ(IFILE,END=1,ERR=640)(C(I),I=1,NTOT)
C Stimmt die Nummer des gelesenen Schnittes (KIZ) mit der Nummer
C des gesuchten Schnittes (ISA) ueberein?
C falls nicht: weitersuchen
    4 IF (KIZ.LT.ISA) GOTO 2
      IF (KIZ.EQ.ISA) GOTO 3
C erster (naechster) angewaehlter Schnitt nicht gefunden
      ISA=ISA+IDS
C Welche nummer hat der naechste angewaehlte Schnitt?
      IF (ISA.GT.ISE) THEN
        WRITE (IOUT,*) 'KEINER DER AUSGEWAEHLTEN SCHNITTE VORHANDEN!'
        GOTO 1
      ELSE
        GOTO 4
C Passt der eingelesene Schnitt jetzt zum Angewaehlten?
      END IF
C Ein angewaehlter Schnitt wurde gelesen.
    3 WRITE (IOUT,*) 'Es wurde der Schnitt ',ISA,' gewaehlt.'
      WRITE (IOUT,*) 'Es wurde der Schnitt ',KIZ,' gelesen.'
C - Wenn es nicht der Erste war, so beginne gleich zu zeichnen!
      IF (IERST.EQ.1) GOTO 5
C Berechne die Achsenlaengen und korrigiere falls noetig
      IF(AXIS(1).LT.0.1) THEN
C ARBSEC-output wurde gelesen
C ALNG,BLNG: Seitenlaengen des Schnittes in ANGSTR.
      ALNG=AG
      BLNG=BG
                  ELSE
C FOURIE-output wurde gelesen
      ALNG=AXIS(1)*FLOAT(NA-1)/FLOAT(IA)
      BLNG=AXIS(2)*FLOAT(NB-1)/FLOAT(IB)
                  END IF
C ANGSTROEM pro Schrittintervall
      AA=ALNG/FLOAT(NA-1)
      BB=BLNG/FLOAT(NB-1)
C Grenzen des Schnittes in ANGSTROEM
      XA=IAI*AA
      YA=IBI*BB
      XE=XA+ALNG
      YE=YA+BLNG
C Ueberspringe diesen Teil falls Labels, Linien und Kreuze
C nicht eingezeichnet werden sollen!
      IF (NRCROS.LE.0) GOTO 100
C Umrechnen der Angaben fuer Labels, Linien und Kreuze
C in ANGSTROEM und Ausblenden falls noetig
C Berechnung der Umrechnungsfaktoren UMFX und UMFY
C Angaben in Rasterkoordinaten
      IF (IFRAC.EQ.0) THEN
        UMFX=AA
        UMFY=BB
        GOTO 110
      END IF
C Angaben in relativen Gitterkoordinaten
      IF (IFRAC.EQ.1) THEN
        UMFX=AA*IA
        UMFY=BB*IB
        GOTO 110
      END IF
C Angaben bereits in Angstroem
      UMFX=1
      UMFY=1
C Umrechnen der Labels und Ausblenden
  110 WRITE (IOUT,*) 'UMFX=',UMFX,'  UMFY=',UMFY,' NLABL=',NLABL,
     &'NLINE=',NLINE
      IF (NLABL.LE.0) GOTO 120
      DO 111 I=1,NLABL
      XL(I)=XL(I)*UMFX-XA
      YL(I)=YL(I)*UMFY-YA
      SL(I)=SL(I)*(UMFX+UMFY)/2
      WRITE (IOUT,*) 'XL=',XL(I),' YL=',YL(I),' ',I
  111 IF (XL(I).LT.0. .OR. XL(I).GT.ALNG .OR.
     & YL(I).LT.0. .OR. YL(I).GT.BLNG)    JL(I)=1
C Umrechnen fuer Linien
  120 IF (NLINE.LE.0) GOTO 130
      DO 121 I=1,NLINE
C Punkt 1
      XLI1(I)=XLI1(I)*UMFX-XA
      YLI1(I)=YLI1(I)*UMFY-YA
C Punkt 1 ausserhalb, und wenn: in welchem Bereich?
      JL1=0
      IF (XLI1(I).LT.0) JL1=3
      IF (XLI1(I).GT.ALNG) JL1=6
      IF (YLI1(I).LT.0) JL1=JL1+1
      IF (YLI1(I).GT.BLNG) JL1=JL1+2
C Punkt 2
      XLI2(I)=XLI2(I)*UMFX-XA
      YLI2(I)=YLI2(I)*UMFY-YA
C Punkt 1 ausserhalb, und wenn: in welchem Bereich?
      JL2=0
      IF (XLI2(I).LT.0) JL2=3
      IF (XLI2(I).GT.ALNG) JL2=6
      IF (YLI2(I).LT.0) JL2=JL2+1
      IF (YLI2(I).GT.BLNG) JL2=JL2+2
C Differenzen zwischen den Punkten
      DX=XLI2(I)-XLI1(I)
      DY=YLI2(I)-YLI1(I)
C Beide Punkte liegen innerhalb - Linie wird gezeichnet.
      IF ((JL1+JL2).EQ.0) GOTO 122
C Punkt 1: innerhalb, Punkt 2: ausserhalb
      IF (JL1.EQ.0 .AND. JL2.GT.0) THEN
        CALL LIAUS (XLI2(I),YLI2(I),ALNG,BLNG,DX,DY,JL2)
        GOTO 122
      END IF
C Punkt 1: ausserhalb, Punkt 2: innerhalb
      IF (JL1.GT.0 .AND. JL2.EQ.0) THEN
        CALL LIAUS (XLI1(I),YLI1(I),ALNG,BLNG,DX,DY,JL1)
        GOTO 122
      END IF
C Punkt 1 und 2 ausserhalb
C Berechne die 4 Schnittpunkte mit den Begrenzungen
      DX=SIGN(1.,DX)*MAX(ABS(DX),1.E-10)
      DY=SIGN(1.,DY)*MAX(ABS(DY),1.E-10)
      write (iout,*) 'jl1=',jl1,' jl2=',jl2
      write (iout,*) '(272):',xli1(i),' ',yli1(i),' ',xli2(i),' ',
     &yli2(i),' ',dx,' ',dy,' ',jli(i)
      CALL LIAUS1 (XLI1(I),YLI1(I),XLI2(I),YLI2(I),ALNG,BLNG,
     & DX,DY,JLI(I))
      write (iout,*) '(274):',xli1(i),' ',yli1(i),' ',xli2(i),' ',
     &yli2(i),' ',dx,' ',dy,' ',jli(i)
      GOTO 121
  122 JLI(I)=0
  121 CONTINUE
C Umrechnen der Kreuze und Ausblenden
  130 IF (NCROS.LE.0) GOTO 100
      DO 131 I=1,NCROS
      XK(I)=XK(I)*UMFX-XA
      YK(I)=YK(I)*UMFY-YA
      SK(I)=SK(I)*(UMFX+UMFY)/2
  131 IF (XK(I).LT.0. .OR. XK(I).GT.ALNG .OR.
     & YK(I).LT.0. .OR. YK(I).GT.BLNG)    JK(I)=1
C Zeichnung optimal auf's Blatt einpassen
C und verkleinern falls der Masstab zu gross ist.
C
C ALF:spitzer Winkel des Schnittparallelogramms in RAD
  100 do 1002 i=1,nlabl
 1002 WRITE (IOUT,*) '(286): umgerechnete Labelpositionen:  ',XL(I),
     &YL(I),jl(i)
      do 1000 i=1,ncros
 1000 WRITE (IOUT,*) 'umgerechnete Kreuzpositionen: ',XK(I),YK(I),JK(I)
      do 1001 i=1,nline
 1001 WRITE (IOUT,*) 'umgerechnete Linienpunkte: ',XLI1(I),YLI1(I),
     &XLI2(I),YLI2(I),JLI(I)
      ALF=CG*.017453
      CALF=COS(ALF)
      SALF=SIN(ALF)
C --- Rahmen einpassen und orientieren
      CALL ORIENT (ALNG,BLNG,ALF,BMAX,HMAX,F,D,DF)
      XB=BMAX/F
      YB=HMAX/F
      DV=0
      IF (CG .GT. 90.) DV=ALNG*CALF
C schreibe Achsenlaengen und Masstaebe
      WRITE(IOUT,2204) ALNG,BLNG,F
C Blatt reservieren
    5 CALL SETMOD(1)
      CALL SHEET (10,BMAXA,HMAXA)
      CALL WINDOW (0.,BMAXA,0.,HMAXA)
      CALL FRAME
      CALL WINDOW (1.5,(1.5+BMAX),1.5,(1.5+HMAX))
      CALL FRAME
C richtig skalieren
      IF (D.EQ.1.) THEN
        CALL USCALE (0.,XB,0,YB+DV,DV,0)
      ELSE
        CALL USCALE (0.,XB,0,DV,YB+DV,0)
      END IF
C Fenster vergroessern
      CALL WINDOW (0.1,18.9,0.1,22.9)
      CALL FRAME
C Beschriftung ermitteln
      CALL BESCHR (JACHS,BX,BY)
C Rahmen zeichnen und beschriften
      CALL RAHMEN (ALNG,BLNG,BX,BY,ALF,D,SH,JACHS,1.)
CT    WRITE (6,*) 'ALNG=',ALNG,'BLNG=',BLNG,'BX=',BX,'BY=',BY,
CT   & 'ALF=',ALF,'D=',D,'SH=',SH,'J=',J
      IF (NRCROS .LE. 0) GOTO 200
C falls Labels, Linien und Kreuze eingezeichnet werden:
      IF (IERST .NE. 0) GOTO 250
C Umrechnen der Labels, Linien und Kreuze auf Positionen die dem
C schiefwinkligen Koordinatensystem entsprechen.
C wird nur fuer die erste Zeichnung durchlaufen
C Labels
      IF (NLABL .LE. 0) GOTO 210
      DO 201 I=1,NLABL
      XZ=XL(I)
      YZ=YL(I)
      XL(I)=(XZ*SALF)*(1.-D)+(YZ+XZ*CALF)*D
  201 YL(I)=(XZ*SALF)*D+(YZ+XZ*CALF)*(1.-D)
C Linien
  210 IF (NLINE .LE. 0) GOTO 220
      DO 211 I=1,NLINE
      XZ=XLI1(I)
      YZ=YLI1(I)
      XLI1(I)=(XZ*SALF)*(1.-D)+(YZ+XZ*CALF)*D
      YLI1(I)=(XZ*SALF)*D+(YZ+XZ*CALF)*(1.-D)
      XZ=XLI2(I)
      YZ=YLI2(I)
      XLI2(I)=(XZ*SALF)*(1.-D)+(YZ+XZ*CALF)*D
  211 YLI2(I)=(XZ*SALF)*D+(YZ+XZ*CALF)*(1.-D)
C Kreuze
  220 IF (NCROS .LE. 0) GOTO 250
      DO 221 I=1,NCROS
      XZ=XK(I)
      YZ=YK(I)
      XK(I)=(XZ*SALF)*(1.-D)+(YZ+XZ*CALF)*D
  221 YK(I)=(XZ*SALF)*D+(YZ+XZ*CALF)*(1.-D)
C Einzeichnen der Labels, Linien und Kreuze
C Labels
  250 IF (NLABL .LE. 0) GOTO 260
      CALL FONT('SD',0)
      DO 251 I=1,NLABL
      IF (JL(I) .EQ. 0) THEN
        CALL MOVETO (XL(I),YL(I))
        CALL SHEAR (SL(I)*D,SL(I)*(1.-D),SL(I)*(D-1.),SL(I)*D)
        CALL MOVEON(1.,.0)
        WRITE (67,*) LABEL(I)
      END IF
  251 CONTINUE
C Linien
  260 IF (NLINE .LE. 0) GOTO 270
      DO 261 I=1,NLINE
      IF (JLI(I) .EQ. 0) THEN
        CALL LEVEL (LEV(I))
        CALL LINTYP (0.5,LITY(I))
        CALL MOVETO (XLI1(I),YLI1(I))
        CALL DRAWTO (XLI2(I),YLI2(I))
      END IF
  261 CONTINUE
      CALL LEVEL (5)
      CALL LINTYP (0.5,'-F')
C Kreuze
  270 IF (NCROS .LE. 0) GOTO 200
      CALL FONT ('SP',0)
      DO 271 I=1,NCROS
      IF (JK(I) .EQ. 0) THEN
        CALL MOVETO (XK(I),YK(I))
        CALL SHEAR (SK(I)*D,SK(I)*(1.-D),SK(I)*(D-1.),SK(I)*D)
        CALL MARK (KTYP(I))
      END IF
  271 CONTINUE
      CALL FONT ('TR',0)
C ++++++++ ZEICHNEN DER HOEHENLINIEN ++++++++++++++++++++++++++++++++++++++++
C Vorbereiten der Daten fuer BICUB, BICONT und LICONT
  200 DO 400 I=1,NA
  400 AXPKTX(I)=(I-1)*AA
      DO 401 I=1,NB
  401 AXPKTY(I)=(I-1)*BB
C Suche maximalen und minimalen Wert des Dichtefeldes
      BMI=100000
      BMA=-BMI
      DO 403 I=1,NTOT
         IF(BMI.GT.C(I)) BMI=C(I)
         IF(BMA.LT.C(I)) BMA=C(I)
  403 CONTINUE
      WRITE (IOUT,2403) BMI,BMA
C nur fuer kubische Interpolation
      IF (INTER .EQ. 2) THEN
        MX=1
        MY=1
        IF (IGV .NE. 0) THEN
C Gitterverdichtungsfaktoren
          MX=INT(200./FLOAT(NA-1))
          MY=INT(200./FLOAT(NB-1))
        END IF
        CALL BICUB (NA,NB,NA,NB,AXPKTX,AXPKTY,C,3333,IER)
      END IF
C Zeichnen der Hoehenlinien ************************************************
C -allgemeine Hoehenlinien
      IF (ISPEZ .EQ. 1) GOTO 450
      IF (PROF .EQ. 'LOG') THEN
C       S=0
C       CALL LINTYP(0.1,'.F')
C       CALL HOHENL(S)
        DHL=HANF
  410   S=10**DHL
        CALL LINTYP(.5,'-F')
        CALL HOHENL(S)
        CALL LINTYP(.1,'- F')
        CALL HOHENL(-S)
        DHL=DHL+DH
        IF (DHL.LE.HEND) GOTO 410
      ELSE
        S=HANF
  420   IF (S.GE.HAMIN .AND. S.LE.HAMAX) GOTO 421
        IF (S.LE.-1.E-9) CALL LINTYP(0.15,'- F')
        IF (S.GE.1.E-9) CALL LINTYP(0.5,'-F')
        IF(ABS(S).LT.1.E-9) CALL LINTYP(0.1,'.F')
        CALL HOHENL(S)
  421   S=S+DH
        IF (S.LE.HEND) GOTO 420
      END IF
C Zeichnen der speziellen Hoehenlinien
  450 IF (ISPEZ.EQ.0) GOTO 500
      IF (NCONT.LE.0) GOTO 500
      DO 451 I=1,NCONT
      S=HS(I)
      CALL LEVEL(HD(I))
      CALL SELECT(LPEN(I))
      WRITE (IOUT,*) 'LH(',I,')=',LH(I)
      CALL LINTYP(0.15,LH(I))
  451 CALL HOHENL(S)
      CALL LEVEL(5)
      CALL SELECT(1)
C++++++++++++Asgabe wichtiger Daten auf der Zeichnung
  500 CONTINUE
      CALL LINTYP (.5,'-F')
      CALL WINDOW (.1,18.9,23.,26.9)
      CALL FRAME
      CALL USCALE (0.,13.,0,0.,13.,0)
      CALL LEVEL (3)
      CALL FONT ('TR',0)
      CALL SHEAR (.25,0.,0.,.4)
      CALL MOVETO (.1,12.)
      CALL TEXT (TITELP)
      CALL MOVETO (.1,10.)
      WRITE (67,'(18A4)') KURS
      CALL SHEAR (.12,0.,0.,.18)
      CALL FONT ('SR',0)
      CALL MOVETO (.1,5.)
      WRITE (67,*) 'MASSTAB=',F,' cm/Angstrom'
      CALL MOVETO (.1,4.)
      WRITE (67,*) BX,' ACHSE VON ',XA,' BIS ',XE,' Angstrom'
      CALL MOVETO (.1,3.)
      WRITE (67,*) BY,' ACHSE VON ',YA,' BIS ',YE,' Angstrom'
      CALL MOVETO (.1,2.)
      WRITE (67,*) ' HOEHENLINIEN ',PROF,' EINGETEILT ',' VON ',HANF,
     &' BIS ',HEND,' IM ABSTAND VON ',DH
      CALL MOVETO (.1,1.)
      WRITE (67,*) ' SCHNITT NR ',KIZ
      CALL LEVEL(5)
C
C
C
      IERST=1
C************************* KONTUREN-PLOT   ENDE ***************************
C Ist noch ein Schnitt verlangt?
      ISA=ISA+IDS
C Weitere Schnitte werden eingelesen falls gewaehlt.
      IF (ISA.LE.ISE) GOTO 2
      WRITE (IOUT,*) 'ALLE ANGEWAEHLTEN SCHNITTE WURDEN BEARBEITET'
      GOTO 650
C
  600 WRITE (IOUT,*) 'FALSCHE DATEN IN DER HAUPT-EINGABEDATEI'
      GOTO 650
C-------- DA WAR KEIN SCHNITT MEHR IM INPUT-FILE
  640 WRITE (IOUT,*) 'FALSCHE DATEN IN DER DATEN-EINGABEDATEI'
  650 STOP
C
C-------------------------------------------------------------------------------
C
 2001 FORMAT(1H1,15HTITEL DES PLOTS/1X,15(1H-)//,1X,A48,/)
 2002 FORMAT(///13H0PROGRAMMENDE /
     & ,46H KEINE INPUT-UNIT SPEZIFIZIERT -- IWAEHL IST :,3X,A4)
 2003 FORMAT(//35H0EIGENSCHAFTEN DES GEWAEHLTEN PLOTS/1X,34(1H-)/,
     & 'GEWAEHLTE VERGROESSERUNG= ',F6.4,'  INTERPOLATION= ',I4/,
     & '  NCONT= ',I2,' NLABL= ',I2,' NLINE= ',I2,' NCROSS= ',I2//)
 2008 FORMAT (1H0,3X,35H SELECTED SECTION-NUMBERS :    FROM,
     &       I4, 13H IN STEPS OF ,I4,  4H TO ,I4)
 2201 FORMAT(/6X,38HSECTION INTERVALS OF THIRD AXIS  : 1 /,I4)
 2202 FORMAT(/24X,24HELEMENTE IM PUNKTARRAY :,I6,/,3X,
     & 45HDIE SUBROUTINEN "BICUB","BICONT" BENOETIGEN :,I6,/
     &  20X,28HAN SPEICHERPLATZ VORHANDEN :,I6)
 2204 FORMAT(/,3X,37HPLOT-GROESSE IN ANGSTR.:  - ACHSE A :,F6.2,5X,
     &  11H- ACHSE B :,F6.2,/ 15X,24HMASS-STAB IN CM/ANGSTR.:,6X,F6.3)
 2401 FORMAT(1H0,3X,8HSECTION ,I5,9H SELECTED,
     & 26H  UNIT FOR S.-NUMBER : 1 /,I4)
 2402 FORMAT (1X, 41H SELECTED AND READ SECTION NUMBERS DIFFER,/1X,2I6,
     &7H READ, ,2I4,  9H SELECTED)
 2403 FORMAT(/3X,41HMINIMUM  UND  MAXIMUM  DES DICHTEFELDES :,2F10.2)
 2404 FORMAT(/3X,12HKONTUREN NR.,I2,14H  ABGEARBEITET,
     & 26H  -  ANFANG,ENDE,SCHRITT :,3F10.3)
 2405 FORMAT(/3X,11HSCHNITT NR.,I3,31H - SUBROUTINE "BICUB" VERLASSEN,
     &  20H,  FEHLERPARAMETER :,I3)
      END
C-------------------------------------------------------------------------------
C-------------------------------------------------------------------------------
      SUBROUTINE BICURV(N,X,Y,TYPE,S)
      COMMON /HOEH/SALF,CALF,D
      INTEGER N
      REAL X(N),Y(N),TYPE,S
      REAL A
C   --X(I) UND Y(I) AUF DIE SCHIEFEN ACHSEN UMRECHNEN
      DO 1 I=1,N
      Y(I)=Y(I)+X(I)*CALF
    1 X(I)=X(I)*SALF
C   --FALLS NOETIG: ZEICHNUNG UM 90 GRAD DREHEN
      IF (D.NE.1.) GOTO 3
      DO 2 I=1,N
      A=X(I)
      X(I)=Y(I)
    2 Y(I)=A
    3 CONTINUE
      CALL CURVE (1,N,X,Y,TYPE)
      RETURN
      END
C
C-------------------------------------------------------------------------------
      SUBROUTINE LICURV(N,X,Y,S)
      COMMON /HOEH/SALF,CALF,D
      INTEGER N
      REAL X(N),Y(N),S
C
      REAL A
C   --X(I) UND Y(I) AUF DIE SCHIEFEN ACHSEN UMRECHNEN
      DO 1 I=1,N
      Y(I)=Y(I)+X(I)*CALF
    1 X(I)=X(I)*SALF
C   --FALLS NOETIG: ZEICHNUNG UM 90 GRAD DREHEN
      IF (D.NE.1.) GOTO 3
      DO 2 I=1,N
      A=X(I)
      X(I)=Y(I)
    2 Y(I)=A
    3 CALL CURVE (1,N,X,Y,'LINEAR')
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE ORIENT (A,B,ALF,BMAX,HMAX,F,D,DF)
C
C ----UNTERPROGRAMM ZUM EINFUEGEN EINES PARALLELOGRAMMS MIT DEN
C     SEITENLAENGEN A,B UND SPITZEM WINKEL ALF IN EIN RECHTECK
C     DER BREITE BMAX UND HOEHE HMAX IN DER DURCH SHEET DEFINIERTEN
C     EINHEIT.
C     F UMRECHNUNGSFAKTOR DER EINHEIT VON A,B NACH BMAX,HMAX
C     DF KORREKTURFAKTOR FUER F
C     D gibt an ob das Parallelogramm um 90 Grad gedreht werden
C     muss, damit es in das Rechteck passt.
C
      REAL A,B,ALF,BMAX,HMAX,F,D,DF,F1
C
      F1=F
      SALF=SIN(ALF)
      CALF=COS(ALF)
      ACM=A*SALF*F
      BCM=(B+A*ABS(CALF))*F
      D=0
      WRITE (6,*) '-1-  ','ACM=',ACM,' BCM=',BCM
      IF (ACM.LE.BMAX) THEN
        WRITE (6,*) '-2-  ','ACM <= BMAX',ACM,' ',BMAX
        IF (BCM.GT.HMAX) THEN
          CALL MASST (HMAX,BCM,ACM,F)
          WRITE (6,*) '-3-  ','BCM > HMAX',BCM,' ',HMAX
        END IF
      ELSE
        IF (ACM.GT.BCM) THEN
          WRITE (6,*) '-4-  ','ACM > BCM',ACM,' ',BCM
          D=1
          IF (ACM.GT.HMAX) THEN
            WRITE (6,*) '-5-  ','ACM > HMAX',ACM,' ',HMAX
            CALL MASST (HMAX,ACM,BCM,F)
          END IF
          IF (BCM.GT.BMAX) THEN
            WRITE (6,*) '-6-  ','BCM > BMAX',BCM,' ',BMAX
            CALL MASST (BMAX,BCM,ACM,F)
          END IF
          WRITE (6,*) 'D=',D
        ELSE
          WRITE (6,*) '-7-  ','ACM <= BCM ',ACM,' ',BCM
          CALL MASST (BMAX,ACM,BCM,F)
          IF (BCM.GT.HMAX) THEN
            CALL MASST (HMAX,BCM,ACM,F)
            WRITE (6,*) 'BCM > HMAX',BCM,' ',BMAX
          END IF
        END IF
      END IF
      DF=F/F1
      RETURN
      END
C --------------------------------------------------------------------
      SUBROUTINE MASST (X,A,B,F)
C  ---VERKLEINERUNG DES MASSTABES
C     X: HMAX ODER BMAX (GRENZE)
C     A: ACM ODER BCM (WAS ZU GROSS IST)
C     B: BCM ODER ACM (ZWEITE SEITE DES RECHTECKS)
C     F: ABBILDUNGS-MASSTAB
      FF=X/A
      A=A*FF
      B=B*FF
      F=F*FF
      RETURN
      END
C ---------------------------------------------------------------------
      SUBROUTINE RAHMEN (A,B,BX,BY,ALF,D,SH,J,DF)
C
C --- UNTERPROGRAMM ZUM ZEICHNEN EINES PARALLELEOGRAMMS MIT DEN
C     SEITENLAENGEN A UND B UND DEM WINKEL ALF (=<90 GRAD) ZWISCHEN
C     A UND B. A UND B MUESSEN IN DEN VORHER DURCH USCALE BE-
C     STIMMTEN GROESSEN ANGEGEBEN WERDEN, ALF IN RAD.
C     DURCH USCALE MUSS VORHER AUCH DIE POSITIVE X- UND Y-
C     RICHTUNG AUF DEM ZEICHENBLATT BESTIMMT WERDEN!
C     DAS PAR. WIRD UM 90 GRAD GEDREHT FALLS D=1
C     ANSCHLIESSEND WERDEN ZWEI SEITEN DES PAR. MIT BX ODER BY UND
C     EINEM PFEIL BESCHRIFTET
C     J GIBT DIE ORIENTIERUNG DES KOORDINATENSYSTEMS AN.
C
      INTEGER J
      REAL A,B,ALF,D,SH,X(4),Y(4),DF
      CHARACTER*2 BX,BY
C
      SALF=SIN(ALF)
      CALF=COS(ALF)
C
      X(4)=0
      Y(4)=0
      X(1)=A*SALF*DF
      Y(1)=A*CALF*DF
      X(2)=X(1)
      Y(2)=B*DF+Y(1)
      X(3)=0
      Y(3)=B*DF
C
      IF (D.EQ.1.)THEN
        DO 1 I=1,4
        XA=Y(I)
        Y(I)=X(I)
    1   X(I)=XA
      END IF
C  -- ZEICHNEN
      CALL MOVETO (X(4),Y(4))
      DO 2 I=1,4
    2 CALL DRAWTO (X(I),Y(I))
C  -- BESCHRIFTEN
      CALL MOVETO (X(4),Y(4))
      IF (D.NE.1.)THEN
        XX=SH*SALF
        XY=SH*CALF
      ELSE
        XX=SH*CALF
        XY=-SH*SALF
      END IF
      CALL SHEAR (XX,-XY,XY,XX)
      CALL FONT ('TR',0)
      CALL MOVEON (4.,-1.6*SH)
      CALL TEXT (BX)
      CALL MOVEON (2.,.0)
      CALL FONT ('MS',0)
      CALL MARK (20)
      CALL MOVETO (X(4),Y(4))
C --- Y-ACHSE BESCHRIFTEN
      CALL FONT ('TR',0)
      IF (D.NE.1.) THEN
        CALL SHEAR (0,-SH,SH,0)
      ELSE
        CALL SHEAR (SH,0,0,SH)
      END IF
      CALL MOVEON (4.,1.6*SH)
      CALL TEXT (BY)
      CALL MOVEON (2.,.0)
      CALL FONT ('MS',0)
      CALL MARK (20)
      CALL FONT ('TR',0)
      RETURN
      END
C-----------------------------------------------------------------
      SUBROUTINE BESCHR (J,BX,BY)
C  -- LEGT DIE BESCHRIFTUNG DER ACHSEN IN ABHAENGIGKEIT VON DER
C     ORIENTIERUNG J DES KOORDINATENSYSTEMS FEST.
C     ZU J SIEHE JACHS
      INTEGER J
      CHARACTER*2 BX,BY
      GOTO (1,2,3,4,5),J
      BX='X'
      BY='Y'
      GOTO 10
    1 BX='X'
      BY='Z'
      GOTO 10
    2 BX='Y'
      BY='X'
      GOTO 10
    3 BX='Y'
      BY='Z'
      GOTO 10
    4 BX='Z'
      BY='Y'
      GOTO 10
    5 BX='Z'
      BY='X'
C
   10 BX=BX//' '
      BY=BY//' '
      RETURN
      END
C-------------------------------------------------------------------
      SUBROUTINE HOHENL (S)
C Unterprogramm zum Zeichnen von Hoehenlinien mit BICONT bzw. LICONT
C Die Variablen werden groesstenteils ueber COMMON uebergeben.
      INTEGER INTER
      DIMENSION AXPKTX(501),AXPKTY(501),C(250000)
      COMMON /HOHE/NA,NB,MX,MY,AXPKTX,AXPKTY,C,INTER
      COMMON /HOEH/SALF,CALF,D
      COMMON /ALL/INN,IOUT
      IF(INTER.EQ.2) THEN
        CALL BICONT(NA,NB,NA,MX,NB,MY,AXPKTX,AXPKTY,C,S,IER)
        WRITE (IOUT,*) 'HOEHENLINIE BEI S=',S
        IF(IER.NE.0) WRITE(IOUT,10) S,IER
      END IF
      IER=0
      IF(INTER.NE.2) THEN
        CALL LICONT(NA,NA,NB,AXPKTX,AXPKTY,C,S,IER)
        WRITE (IOUT,*) 'HOEHENLINIE BEI S=',S
        IF(IER.NE.0) WRITE(IOUT,20) S,IER
      END IF
      IER=0
      RETURN
   10 FORMAT(/3X,36HSUBROUTINE "BICONT" FUER KONTUR BEI ,F9.2,
     &           30H  - ENDE -,  FEHLERPARAMETER :,I3)
   20 FORMAT(/3X,36HSUBROUTINE "LICONT" FUER KONTUR BEI ,F9.2,
     &           30H  - ENDE -,  FEHLERPARAMETER :,I3)
      END
C -----------------------------------------------------------------------
      SUBROUTINE LIAUS (X,Y,A,B,DX,DY,J)
C --- Unterprogramm zum Ausblenden von Linien (oder Teilen davon)
C     die ausserhalb des Schnittes liegen.
C --- X,Y: Endpunkte der Strecken
C     A,B: Begrenzungen des Schnittes
C     DX,DY: Differenz zwischen den Punkten in x bzw. y
C     J gibt an in welchem Bereich ausserhalb des Schnittes
C     sich der Punkt befindet.(J hat nach RETURN keine Bedeutung)
C
      DIMENSION D(8)
      DATA D/8*0./
      D(2)=B
      D(6)=A
      D(7)=A
      D(8)=A
C --- Gerade parallel zur y-Achse
      IF (ABS(DX).LT.1.E-10)THEN
        Y=D(J)
        GOTO 6
      END IF
C --- Gerade parallel zur x-Achse
      IF (ABS(DY).LT.1.E-10)THEN
        X=D(J)
        GOTO 6
      END IF
C --- Geradengleichungen nach x bzw. y
      XA=DY/DX
      XB=Y-XA*X
      YA=DX/DY
      YB=X-YA*Y
C --- Berechnen des neuen Punktes auf dem Rand des Schnittes
      GOTO (1,1,2,3,4,2,3,4),J
    1 Y=D(J)
      X=YA*Y+YB
      GOTO 6
    2 X=D(J)
      Y=XA*X+XB
      GOTO 6
    3 X=D(J)
      Y=XA*X+XB
      IF (Y.LT.0) THEN
        J=1
        GOTO 1
      ELSE
        GOTO 6
      END IF
    4 X=D(J)
      Y=XA*X+XB
      IF (Y.GT.B) THEN
        J=2
        GOTO 1
      END IF
    6 RETURN
      END
C -----------------------------------------------------------------------
      SUBROUTINE LIAUS1 (X1,Y1,X2,Y2,A,B,DX,DY,JL)
C --- Unterprogramm zum Ausblenden von Linien (oder Teilen davon)
C     die ausserhalb des Schnittes liegen.
C --- X1,Y1,X2,Y2: Endpunkte der Strecken
C     A,B: Begrenzungen des Schnittes
C     DX,DY: Differenz zwischen den Punkten in x bzw. y                        c
C     Nach RETURN bedeutet:
C     JL=0 -Linie wird nicht ausgeblendet
C       =1 -Linie wird ausgeblendet
C
      DIMENSION X(2),Y(2)
C --- Geradengleichungen nach x bzw. y
      XA=DY/DX
      XB=Y1-XA*X1
      YA=DX/DY
      YB=X1-YA*Y1
C --- Berechnen der neuen Punkte auf dem Rand des Schnittes
      J=1
      X(J)=0
      Y(J)=XB
      IF (Y(J).GE.0 .AND. Y(J).LE.B) J=J+1
      X(J)=A
      Y(J)=XA*X(J)+XB
      IF (Y(J).GE.0 .AND. Y(J).LE.B) J=J+1
      IF (J.GT.2) GOTO 1
      Y(J)=0
      X(J)=YB
      IF (X(J).GE.0 .AND. X(J).LE.A) J=J+1
      IF (J.GT.2) GOTO 1
      Y(J)=B
      X(J)=YA*Y(J)+YB
      IF (X(J).GE.0 .AND. X(J).LE.A) J=J+1
      IF (J.GT.2) GOTO 1
      JL=1
      RETURN
    1 X1=X(1)
      Y1=Y(1)
      X2=X(2)
      Y2=Y(2)
      JL=0
      RETURN
      END
